#include	"include/generic.h"
#include	"include/config.h"
#include	"include/h8_3048.h"
#include	"include/sys.h"

#define	RIGHTON		(0x0001)
#define LEFTON		(0x0002)
#define UPON		(0x0004)
#define DOWNON		(0x0008)

#define MAINDISP        (0x1000)
#define CHDISP		(0x1010)

#define	ENTER		(0x2000)
#define EDIT		(0x2010)
#define PGMINFO		(0x2020)

/*----------------------------------------------------------------
 *    ϐE֐錾
 *----------------------------------------------------------------*/
UCHAR	panelLockOnOff(UCHAR);
UCHAR	mnsetoff(int, UCHAR);
UCHAR	mnseton(int, UCHAR);
UCHAR	chsetoff(int, UCHAR);
UCHAR	chseton(int, UCHAR);
int	swcheck(ChAttr *);
int	checkPush(int);
int	display(int, int);
int	setdpmode(int, int, int);
int	checkVolUp(MnAttr *, ChAttr *);

void	BeepEnable();
void	BeepDisable();
UINT	getBeepLen();
void	Beep(int);
void	setBeepLength(UINT);
void	sysParamInit();
int	readRom(SysAttr *, SysAttr *);
void	sysParamRec();
UCHAR	getStartMode();
void	setStartMode(UCHAR);

/**** Backup RAM ****/
extern int	curch;		/* ݑΏۂƂȂĂ`l */
extern SysAttr	sParam;

/**** ϐ ****/
extern int	setchflag;	/* `lf[^̐ݒOKtO */
extern ChAttr  *cd;		/* o͗p`lf[^̃|C^ */
extern MnAttr  *md;		/* o͗pCf[^̃|C^ */
extern ChAttr  dcd;		/* \p`lf[^ */
extern MnAttr  dmd;		/* \p`lf[^ */
extern SysAttr *romParam;	/* ۑf[^ */

extern UCHAR	panel;		/* plbN */
extern UINT	beep;		/* Beep JEgl(̒) */
extern UINT	bcnt;		/* Beep pJE^ */
extern UCHAR	beepEn;		/* Beep On/Off */

extern int	pretop, second;
extern int	top, chsec, mnsec;	/* ԕϐ(Top/SecondLevel) */
extern int	swcntA, swcntB;		/* XCb`ςȂJE^ */
extern UCHAR	runinit;		/* tO */
extern UCHAR	stamode;		/* N̕A[h */
extern int	keepram;
extern PgAttr	pgmds[100];

UCHAR	getCurSendSW() { return(cd[curch].sndsw); }
UCHAR	getCurCH()     { return(curch); }

/************************************************************************
 *    Beep ֘A֐                                                     *
 ************************************************************************/
void	BeepEnable()  { beepEn = 1; }
void	BeepDisable() { beepEn = 0; }
UINT	getBeepLen()  { return(beep * 8); }
UCHAR	getBeepOn()   { return beepEn; }

void
Beep(int force) {
    if (force)     bcnt = 0;
    if (beepEn)    bcnt = 0;
}

void
setBeepLength(UINT msec)
{
    if (msec < 0x08)    msec = 0x08;		/* ŏ8msec */
    if (msec > 0x2700)  msec = 0x2700;		/* ő10b */

    /*sParam.BeepLen = msec;*/
    beep = msec >> 3;
    bcnt = 0x7fff;
}

/************************************************************************
 *    plon/off֐                                              *
 ************************************************************************/
UCHAR
panelLockOnOff(UCHAR pnl)
{
    if (pnl == 0) {
        pnl = mnsetoff(top, pnl);
        pnl = chsetoff(top, pnl);
    } else {
        pnl = mnseton(top, pnl);
        pnl = chseton(top, pnl);
    }
    return (pnl);
}
    
UCHAR
mnsetoff(int tp, UCHAR pnl)
{
    pnl = pnl | MNLOCK;
    admnupdateSet(OFF);
    if ((tp == MAINDISP) || (tp == CHDISP)) {
        dispLockM();
    }
    return (pnl);
}

void
pcmnsetoff()
{
    panel = panel | PCMNLOCK;
    admnupdateSet(OFF);
    if ((top == MAINDISP) || (top == CHDISP)) {
        dispLockM();
    }
}

UCHAR
mnseton(int tp, UCHAR pnl)
{
    pnl = pnl & ~MNLOCK;
    if (pnl & (MNLOCK | PCMNLOCK)) return;
    admnupdateSet(ON);
    if ((tp == MAINDISP) || (tp == CHDISP)) {
        dispUnlockM();
    }
}

void
pcmnseton()
{
    panel = panel & ~PCMNLOCK;
    if (panel & (MNLOCK | PCMNLOCK)) return;
    admnupdateSet(ON);
    if ((top == MAINDISP) || (top == CHDISP)) {
        dispUnlockM();
    }
}
    

UCHAR
chsetoff(int tp, UCHAR pnl)
{
    pnl = pnl | CHLOCK;
    setchflag = OFF;
    setLedMode(BRINK_NONE, LED_LEFT);	/* LED _OFF */
    adchupdateSet(OFF);			/* AD f[^XVOFF */
    auxswUpdateSet(OFF);
    if ((tp == MAINDISP) || (tp == CHDISP)) {
        dispLockC();
    }
    return pnl;
}

void
pcchsetoff()
{
    panel = panel | PCCHLOCK;
    setchflag = OFF;
    setLedMode(BRINK_NONE, LED_LEFT);	/* LED _OFF */
    adchupdateSet(OFF);			/* AD f[^XVOFF */
    auxswUpdateSet(OFF);
    if ((top == MAINDISP) || (top == CHDISP)) {
        dispLockC();
    }
}

UCHAR
chseton(int tp, UCHAR pnl)
{
    pnl = pnl & ~CHLOCK;
    if (pnl & (CHLOCK | PCCHLOCK)) return;
    if ((tp == MAINDISP) || (tp == CHDISP)) {
        dispUnlockC();
    }
    return pnl;
}

void
pcchseton()
{
    panel = panel & ~PCCHLOCK;
    if (panel & (CHLOCK | PCCHLOCK)) return;
    if ((top == MAINDISP) || (top == CHDISP)) {
        dispUnlockC();
    }
}

/************************************************************************
 *    SW/֐                                                   *
 ************************************************************************/
int
swcheck(ChAttr *chd)
{
    int		rtn = 0;
    
    /**** ch؂ւ ****/
    if (checksw(MAINSW)) {
        if (setchflag == OFF)  curch++;
        if (curch == 16) curch = 0;
        setchflag = OFF;
        setLedMode(BRINK_NONE, LED_LEFT);	/* LED _OFF */
        adchupdateSet(OFF);			/* AD f[^XVOFF */
        auxswUpdateSet(OFF);
        rtn = 1;
    }

    /**** ch ݒԔ ****/
    if ((panel & (CHLOCK|PCCHLOCK)) == 0) {
        if (checksw(CMAINSW)) {
            setchflag = ON;
            setLedMode(DOT_BRINK, LED_LEFT);	/* LED _ */
            adchupdateSet(ON);			/* AD f[^XVON */
            auxswUpdateSet(ON);
            rtn = 1;
        }
    }

    /**** AUX SendXCb``FbN ****/
    if ((panel & (CHLOCK|PCCHLOCK)) == 0)
        getAuxSendSw(&chd[curch]);

    return (rtn);
}

/************************************************************************
 *    SWԔ                                                        *
 ************************************************************************/
int
checkPush(int ch)
{
    UCHAR	stat;
    int		rtn;
    
    stat = (UCHAR)getSwStat(TACTSW, PUSH_STAT);
    if (stat & 0x01) {					/* Right */
        if (swcntA < 30) {
            swcntA++;
        } else {
            swcntB++;
            if (swcntB == 10) {
                swcntB = 0;
                if ((top == MAINDISP) || (top == CHDISP)) {
                    pgmIncDec(-1);
                }
            }
        }
        rtn = 0;
    } else if (stat & 0x04) {				/* Left */
        if (swcntA < 30) {
            swcntA++;
        } else {
            swcntB++;
            if (swcntB == 10) {
                swcntB = 0;
                if ((top == MAINDISP) || (top == CHDISP)) {
                    pgmIncDec(1);
                }
            }
        }
        rtn = 0;
    } else {
        swcntA = 0;
        swcntB = 0;
        rtn = 1;
    }
    return(rtn);
}

int
display(int ch, int dup)
{
    switch(top) {
    case MAINDISP:  dispMain(md, &dmd, cd, &dcd, mnsec, ch);  break;
    case CHDISP:    dispCH(md, &dmd, cd, &dcd, chsec, ch);     break;
    case EDIT:      dispMenu(); break;
    }
    return(0);
}

int
setdpmode(int dpmd, int dlvl, int ch)
{
    if ((ch > 0) && (ch < 16)) {
        curch = ch;
    }
    if (dpmd == DISP_MAIN) {
        if ((top == MAINDISP) && (mnsec == dlvl)) return 0;
        if (dlvl < DMN_MAXLEVEL) {
            top = MAINDISP;
            mnsec = dlvl;
        }
    } else {
        if ((top == CHDISP) && (chsec == dlvl))  return 0;
        if (dlvl < DCH_MAXLEVEL) {
            top = CHDISP;
            chsec = dlvl;
        }
    }
    return 0;
}

void
sysParamInit()
{
    int		i;
    
    romParam = (SysAttr *)FAREA_TOP;
    if ((sParam.magicA[0] == 0xaaaa) && (sParam.magicA[1] == 0x5555) &&
        (sParam.magicB[0] == 0x6666) && (sParam.magicB[1] == 0x9999)) {
        keepram = 1;
    } else {
        sParam.magicA[0] = 0xaaaa;
        sParam.magicA[1] = 0x5555;
        sParam.magicB[0] = 0x6666;
        sParam.magicB[1] = 0x9999;
        keepram = 0;
        readRom(&sParam, romParam);
    }
}

int
readRom(SysAttr *sp, SysAttr *rp)
{
    int		i;

    if ((rp->magicA[0] == 0xaaaa) && (rp->magicA[1] == 0x5555) &&
        (rp->magicB[0] == 0x6666) && (rp->magicB[1] == 0x9999)) {
        for(i=0; i<4; i++) {
            sp->stoplen[i] = rp->stoplen[i];
            sp->parity[i]  = rp->parity[i];
            sp->datalen[i] = rp->datalen[i];
            sp->bps[i]     = rp->bps[i];
        }
        sp->BeepFreq = rp->BeepFreq;
        sp->BeepLen  = rp->BeepLen;
        sp->BeepEn   = rp->BeepEn;
        sp->contrast = rp->contrast;
        sp->defch    = rp->defch;
        sp->stamode  = rp->stamode;
        return 1;
    } else {
        sp->stoplen[0] = 1;
        sp->parity[0]  = 0;
        sp->datalen[0] = 8;
        sp->bps[0]     = 3840;
        sp->stoplen[1] = 1;
        sp->parity[1]  = 0;
        sp->datalen[1] = 8;
        sp->bps[1]     = 3840;
        sp->stoplen[2] = 1;
        sp->parity[2]  = 0;
        sp->datalen[2] = 8;
        sp->bps[2]     = 3840;
        sp->stoplen[3] = 1;
        sp->parity[3]  = 0;
        sp->datalen[3] = 8;
        sp->bps[3]     = 3840;
        sp->BeepFreq   = 2000;
        sp->BeepLen    = 32;
        sp->BeepEn     = 1;
        sp->contrast   = 100;
        sp->defch      = 0;
        sp->stamode    = 0;
	sysParamRec();
    }
}

void
setSysParam(int type, int data, int ch)
{
    switch(type) {
    case BEEP_FREQ:	sParam.BeepFreq    = (UINT)data;     break;
    case BEEP_LEN:	sParam.BeepLen     = (UINT)data;     break;
    case BEEP_ON:       sParam.BeepEn      = (UINT)data;     break;
    case CONTRAST:	sParam.contrast    = (UCHAR)data;    break;
    case SCI_BPS:       sParam.bps[ch]     = (UINT)data;     break;
    case SCI_STOP:      sParam.stoplen[ch] = (UCHAR)data;    break;
    case SCI_PRTY:      sParam.parity[ch]  = (UCHAR)data;    break;
    case SCI_DLEN:      sParam.datalen[ch] = (UCHAR)data;    break;
    case DEFPGM:        sParam.defch       = (UINT)data;     break;
    case STAMODE:	sParam.stamode     = (UCHAR)data;    break;
    }
}

UINT  getSysBeepFreq()      { return(sParam.BeepFreq); }
UINT  getSysBeepLen()       { return(sParam.BeepLen); }
UINT  getSysBeepON()        { return(sParam.BeepEn); }
UCHAR getSysContrast()      { return(sParam.contrast); }
UINT  getSysBps(int ch)     { return(sParam.bps[ch]); }
UCHAR getSysStop(int ch)    { return(sParam.stoplen[ch]); }
UCHAR getSysPrty(int ch)    { return(sParam.parity[ch]); }
UCHAR getSysDlen(int ch)    { return(sParam.datalen[ch]); }
UINT  getSysDefCh()         { return(sParam.defch); }
UCHAR getStartMode()        { return(sParam.stamode); }
void  setStartMode(UCHAR m) { sParam.stamode = m; }


void
sysParamRec()
{
    disableIRQ();
    eraseSector(7);
    flashProgram((UCHAR *)romParam,
                 (UCHAR *)&sParam, (ULONG)(sizeof(SysAttr)));
    enableIRQ();
}

