/************************************************************************
 *                                                                      *
 *    H8/3048F 쥸                                         *
 *                                                                      *
 ************************************************************************/

#define	SCI_CH0		(1)
#define	SCI_CH1		(0)
#define	NUM_IRQ0	(0x01)
#define	NUM_IRQ1	(0x02)
#define	NUM_IRQ2	(0x04)
#define	NUM_IRQ3	(0x08)
#define	NUM_IRQ4	(0x10)
#define	NUM_IRQ5	(0x20)

#define	disableIRQ()	asm("    orc    #128, ccr")
#define	enableIRQ()	asm("    andc    #127, ccr")

/************************************************************************
 *    H8¢쥸ɥ쥹                                      *
 ************************************************************************/

/*----------------------------------------------------------------------*
 *    ƥॳȥ롦ߥȥ                        *
 *----------------------------------------------------------------------*/
#define	MDCR	(*((UCHAR *)0xffff1))	/* ⡼ɥȥ */
#define	SYSCR	(*((UCHAR *)0xffff2))	/* ƥॳȥ */
#define	ISCR	(*((UCHAR *)0xffff4))	/* IRQ󥹥ȥ */
#define	IER	(*((UCHAR *)0xffff5))	/* IRQ֥͡쥸 */
#define	ISR	(*((UCHAR *)0xffff6))	/* IRQơ쥸 */
#define	IPRA	(*((UCHAR *)0xffff8))	/* IRQץ饤ƥ쥸A */
#define	IPRB	(*((UCHAR *)0xffff9))	/* IRQץ饤ƥ쥸B */

#define	DIVCR	(*((UCHAR *)0xfff5d))	/* åʬ楳ȥ */
#define	MSTCR	(*((UCHAR *)0xfff5e))	/* ⥸塼륹Хȥ */

/*----------------------------------------------------------------------*
 *    Хȥ顼                                                *
 *----------------------------------------------------------------------*/
#define ABWCR   (*((UCHAR *)0xffffec))	/* Хȥ */
#define ASTCR   (*((UCHAR *)0xffffed))	/* ơȥȥ */
#define WCR     (*((UCHAR *)0xffffee))	/* ȥȥ */
#define WCER    (*((UCHAR *)0xffffef))	/* ȥȥ饤֥͡ */
#define BRCR    (*((UCHAR *)0xfffff3))	/* Х꡼ȥ */
#define CSCR    (*((UCHAR *)0xffff5f))	/* åץ쥯ȥȥ */

/*----------------------------------------------------------------------*
 *    եå女ȥ                                          *
 *----------------------------------------------------------------------*/
#define	RFSHCR	(*((UCHAR *)0xfffac))	/* եå女ȥ */
#define	RTMCSR	(*((UCHAR *)0xfffad))	/* ޥȥ/ơ */
#define	RTCNT	(*((UCHAR *)0xfffae))	/* եå奿 */
#define	RTCOR	(*((UCHAR *)0xfffaf))	/* եå奿ॳ󥹥 */

/*----------------------------------------------------------------------*
 *    DMAȥ                                                   *
 *----------------------------------------------------------------------*/
/* ͥ0 */
#define	MAR0AR	(*((UCHAR *)0xfff20))	/* ꥢɥ쥹0AR */
#define	MAR0AE	(*((UCHAR *)0xfff21))	/* ꥢɥ쥹0AE */
#define	MAR0AH	(*((UCHAR *)0xfff22))	/* ꥢɥ쥹0AH */
#define	MAR0AL	(*((UCHAR *)0xfff23))	/* ꥢɥ쥹0AL */
#define	IOAR0A	(*((UCHAR *)0xfff26))	/* I/Oɥ쥹쥸 0A */
#define	ETCR0AH	(*((UCHAR *)0xfff24))	/* žȥ쥸 0AH */
#define	ETCR0AL	(*((UCHAR *)0xfff25))	/* žȥ쥸 0AL */
#define	DTCR0A	(*((UCHAR *)0xfff27))	/* DTC쥸0A */
#define	MAR0BR	(*((UCHAR *)0xfff28))	/* ꥢɥ쥹0BR */
#define	MAR0BE	(*((UCHAR *)0xfff29))	/* ꥢɥ쥹0BE */
#define	MAR0BH	(*((UCHAR *)0xfff2A))	/* ꥢɥ쥹0BH */
#define	MAR0BL	(*((UCHAR *)0xfff2B))	/* ꥢɥ쥹0BL */
#define	IOAR0B	(*((UCHAR *)0xfff2E))	/* I/Oɥ쥹쥸 0B */
#define	ETCR0BH	(*((UCHAR *)0xfff2C))	/* žȥ쥸 0BH */
#define	ETCR0BL	(*((UCHAR *)0xfff2D))	/* žȥ쥸 0BL */
#define	DTCR0B	(*((UCHAR *)0xfff2F))	/* DTC쥸0B */

/* ͥ1 */
#define	MAR1AR	(*((UCHAR *)0xfff30))	/* ꥢɥ쥹1AR */
#define	MAR1AE	(*((UCHAR *)0xfff31))	/* ꥢɥ쥹1AE */
#define	MAR1AH	(*((UCHAR *)0xfff32))	/* ꥢɥ쥹1AH */
#define	MAR1AL	(*((UCHAR *)0xfff33))	/* ꥢɥ쥹1AL */
#define	IOAR1A	(*((UCHAR *)0xfff36))	/* I/Oɥ쥹쥸 1A */
#define	ETCR1AH	(*((UCHAR *)0xfff34))	/* žȥ쥸 1AH */
#define	ETCR1AL	(*((UCHAR *)0xfff35))	/* žȥ쥸 1AL */
#define	DTCR1A	(*((UCHAR *)0xfff37))	/* DTC쥸1A */
#define	MAR1BR	(*((UCHAR *)0xfff38))	/* ꥢɥ쥹1BR */
#define	MAR1BE	(*((UCHAR *)0xfff39))	/* ꥢɥ쥹1BE */
#define	MAR1BH	(*((UCHAR *)0xfff3A))	/* ꥢɥ쥹1BH */
#define	MAR1BL	(*((UCHAR *)0xfff3B))	/* ꥢɥ쥹1BL */
#define	IOAR1B	(*((UCHAR *)0xfff3E))	/* I/Oɥ쥹쥸 1B */
#define	ETCR1BH	(*((UCHAR *)0xfff3C))	/* žȥ쥸 1BH */
#define	ETCR1BL	(*((UCHAR *)0xfff3D))	/* žȥ쥸 1BL */
#define	DTCR1B	(*((UCHAR *)0xfff3F))	/* DTC쥸1B */

/*----------------------------------------------------------------------*
 *    I/Oݡ                                                         *
 *----------------------------------------------------------------------*/
/* ݡ1ݡ6 */
#define P1DDR   (*((UCHAR *)0xffffc0))
#define P1DR    (*((UCHAR *)0xffffc2))

#define P2DDR   (*((UCHAR *)0xffffc1))
#define P2DR    (*((UCHAR *)0xffffc3))
#define P2PCR   (*((UCHAR *)0xffffd8))

#define P3DDR   (*((UCHAR *)0xffffc4))
#define P3DR    (*((UCHAR *)0xffffc6))

#define P4DDR   (*((UCHAR *)0xffffc5))
#define P4DR    (*((UCHAR *)0xffffc7))
#define P4PCR   (*((UCHAR *)0xffffda))

#define P5DDR   (*((UCHAR *)0xffffc8))
#define P5DR    (*((UCHAR *)0xffffca))
#define P5PCR   (*((UCHAR *)0xffffdb))

#define P6DDR   (*((UCHAR *)0xffffc9))
#define P6DR    (*((UCHAR *)0xffffcb))

/* ݡ79, ݡA, ݡB */
#define P7DR    (*((UCHAR *)0xffffce))

#define P8DDR   (*((UCHAR *)0xffffcd))
#define P8DR    (*((UCHAR *)0xffffcf))

#define P9DDR   (*((UCHAR *)0xffffd0))
#define P9DR    (*((UCHAR *)0xffffd2))

#define PADDR   (*((UCHAR *)0xffffd1))
#define PADR    (*((UCHAR *)0xffffd3))

#define PBDDR   (*((UCHAR *)0xffffd4))
#define PBDR    (*((UCHAR *)0xffffd6))

/*----------------------------------------------------------------------*
 *    16bit ƥ졼ƥåɥޥ˥å (ITU)                      *
 *----------------------------------------------------------------------*/
#define TSTR    (*((UCHAR *)0xffff60))	/* ޥȥ쥸 */
#define TSNC    (*((UCHAR *)0xffff61))	/* ޥ󥯥쥸 */
#define TMDR    (*((UCHAR *)0xffff62))	/* ޡ⡼ɡ쥸 */
#define TFCR    (*((UCHAR *)0xffff63))	/* ե󥯥󥳥ȥ */
#define TOER    (*((UCHAR *)0xffff90))	/* Output ޥ֥͡ */
#define TOCR    (*((UCHAR *)0xffff91))	/* Output ȥ */

/**** ޣ ****/
#define TCR0    (*((UCHAR *)0xffff64))	/* ޥȥ */
#define TIOR0   (*((UCHAR *)0xffff65))	/* I/Oȥ */
#define TIER0   (*((UCHAR *)0xffff66))	/* 󥿥ץȥ֥͡ */
#define TSR0    (*((UCHAR *)0xffff67))	/* ơ */
#define TCNT0   (*((UINT  *)0xffff68))	/* ޥ */
#define TCNT0H  (*((UCHAR *)0xffff68))	/* ޥ(H) */
#define TCNT0L  (*((UCHAR *)0xffff69))	/* ޥ(L) */
#define GRA0    (*((UINT  *)0xffff6a))	/* ͥ쥸A */
#define GRA0H   (*((UCHAR *)0xffff6a))	/* ͥ쥸A (H) */
#define GRA0L   (*((UCHAR *)0xffff6b))	/* ͥ쥸A (L) */
#define GRB0    (*((UINT  *)0xffff6c))	/* ͥ쥸B */
#define GRB0H   (*((UCHAR *)0xffff6c))	/* ͥ쥸B (H) */
#define GRB0L   (*((UCHAR *)0xffff6d))	/* ͥ쥸B (L) */

#define TCR1    (*((UCHAR *)0xffff6e))
#define TIOR1   (*((UCHAR *)0xffff6f))
#define TIER1   (*((UCHAR *)0xffff70))
#define TSR1    (*((UCHAR *)0xffff71))
#define TCNT1   (*((UINT  *)0xffff72))
#define TCNT1H  (*((UCHAR *)0xffff72))
#define TCNT1L  (*((UCHAR *)0xffff73))
#define GRA1    (*((UINT  *)0xffff74))
#define GRA1H   (*((UCHAR *)0xffff74))
#define GRA1L   (*((UCHAR *)0xffff75))
#define GRB1    (*((UINT  *)0xffff76))
#define GRB1H   (*((UCHAR *)0xffff76))
#define GRB1L   (*((UCHAR *)0xffff77))

#define TCR2    (*((UCHAR *)0xffff78))
#define TIOR2   (*((UCHAR *)0xffff79))
#define TIER2   (*((UCHAR *)0xffff7a))
#define TSR2    (*((UCHAR *)0xffff7b))
#define TCNT2   (*((UINT  *)0xffff7c))
#define TCNT2H  (*((UCHAR *)0xffff7c))
#define TCNT2L  (*((UCHAR *)0xffff7d))
#define GRA2    (*((UINT  *)0xffff7e))
#define GRA2H   (*((UCHAR *)0xffff7e))
#define GRA2L   (*((UCHAR *)0xffff7f))
#define GRB2    (*((UINT  *)0xffff80))
#define GRB2H   (*((UCHAR *)0xffff80))
#define GRB2L   (*((UCHAR *)0xffff81))

#define TCR3    (*((UCHAR *)0xffff82))
#define TIOR3   (*((UCHAR *)0xffff83))
#define TIER3   (*((UCHAR *)0xffff84))
#define TSR3    (*((UCHAR *)0xffff85))
#define TCNT3   (*((UINT  *)0xffff86))
#define TCNT3H  (*((UCHAR *)0xffff86))
#define TCNT3L  (*((UCHAR *)0xffff87))
#define GRA3    (*((UINT  *)0xffff88))
#define GRA3H   (*((UCHAR *)0xffff88))
#define GRA3L   (*((UCHAR *)0xffff89))
#define GRB3    (*((UINT  *)0xffff8a))
#define GRB3H   (*((UCHAR *)0xffff8a))
#define GRB3L   (*((UCHAR *)0xffff8b))
#define BRA3    (*((UINT  *)0xffff8c))	/* Хåե쥸A */
#define BRA3H   (*((UCHAR *)0xffff8c))	/* Хåե쥸A (H) */
#define BRA3L   (*((UCHAR *)0xffff8d))	/* Хåե쥸A (L) */
#define BRB3    (*((UINT  *)0xffff8e))	/* Хåե쥸B */
#define BRB3H   (*((UCHAR *)0xffff8e))	/* Хåե쥸B (H) */
#define BRB3L   (*((UCHAR *)0xffff8f))	/* Хåե쥸B (L) */

#define TCR4    (*((UCHAR *)0xffff92))
#define TIOR4   (*((UCHAR *)0xffff93))
#define TIER4   (*((UCHAR *)0xffff94))
#define TSR4    (*((UCHAR *)0xffff95))
#define TCNT4   (*((UINT  *)0xffff96))
#define TCNT4H  (*((UCHAR *)0xffff96))
#define TCNT4L  (*((UCHAR *)0xffff97))
#define GRA4    (*((UINT  *)0xffff98))
#define GRA4H   (*((UCHAR *)0xffff98))
#define GRA4L   (*((UCHAR *)0xffff99))
#define GRB4    (*((UINT  *)0xffff9a))
#define GRB4H   (*((UCHAR *)0xffff9a))
#define GRB4L   (*((UCHAR *)0xffff9b))
#define BRA4    (*((UINT  *)0xffff9c))
#define BRA4H   (*((UCHAR *)0xffff9c))
#define BRA4L   (*((UCHAR *)0xffff9d))
#define BRB4    (*((UINT  *)0xffff9e))
#define BRB4H   (*((UCHAR *)0xffff9e))
#define BRB4L   (*((UCHAR *)0xffff9f))

/*----------------------------------------------------------------------*
 *    ץޥ֥륿ߥ󥰥ѥ󥳥ȥ(TPC)                 *
 *----------------------------------------------------------------------*/
#define	TPMR	(*((UCHAR *)0xfffa0))	/* TPCϥ⡼ */
#define	TPCR	(*((UCHAR *)0xfffa1))	/* TPCϥȥ */
#define	NDERB	(*((UCHAR *)0xfffa2))	/* ͥȥǡ֥͡B */
#define	NDERA	(*((UCHAR *)0xfffa3))	/* ͥȥǡ֥͡A */
#define	NDRA0	(*((UCHAR *)0xfffa5))	/* ͥȥǡA0 */
#define	NDRA1	(*((UCHAR *)0xfffa7))	/* ͥȥǡA1 */
#define	NDRB0	(*((UCHAR *)0xfffa4))	/* ͥȥǡB0 */
#define	NDRB1	(*((UCHAR *)0xfffa6))	/* ͥȥǡB1 */

/*----------------------------------------------------------------------*
 *    åɥå                                              *
 *----------------------------------------------------------------------*/
#define WTCNT	(*((UINT  *)0xfffa8))
#define	TCSR	(*((UCHAR *)0xfffa8))	/* ޥȥ롦ơ */
#define WTCSR	(*((UINT  *)0xfffa8))
#define	TCNT	(*((UCHAR *)0xfffa9))	/* ޥ */
#define	RSTCSR	(*((UCHAR *)0xfffab))	/* ꥻåȥȥ롦ơ */

#define	RDTCSR	(*((UINT *)0xfffa8))	/* ޥȥ롦ơ */
#define	RDTCNT	(*((UINT *)0xfffa9))	/* ޥ */
#define	RRSTCSR	(*((UINT *)0xfffab))	/* ꥻåȥȥ롦ơ */

/*----------------------------------------------------------------------*
 *    ꥢ륳ߥ˥/ޡȥɡ󥿡ե       *
 *----------------------------------------------------------------------*/
/* ͥ 0 (ޡȥɷ) */
#define SMR0    (*((UCHAR *)0xfffb0))	/* ꥢ⡼ */
#define BRR0    (*((UCHAR *)0xfffb1))	/* ӥåȥ졼 */
#define SCR0    (*((UCHAR *)0xfffb2))	/* ꥢ륳ȥ */
#define TDR0    (*((UCHAR *)0xfffb3))	/* ǡ */
#define SSR0    (*((UCHAR *)0xfffb4))	/* ꥢ륹ơ */
#define RDR0    (*((UCHAR *)0xfffb5))	/* ǡ */
#define	SCMR	(*((UCHAR *)0xfffb6))

#define SMR0Ptr (0xfffb0)		/* ꥢ⡼ */
#define BRR0Ptr (0xfffb1)		/* ӥåȥ졼 */
#define SCR0Ptr (0xfffb2)		/* ꥢ륳ȥ */
#define TDR0Ptr (0xfffb3)		/* ǡ */
#define SSR0Ptr (0xfffb4)		/* ꥢ륹ơ */
#define RDR0Ptr (0xfffb5)		/* ǡ */
#define	SCMRPtr (0xfffb6)

/* ͥ1 */
#define SMR1    (*((UCHAR *)0xfffb8))
#define BRR1    (*((UCHAR *)0xfffb9))
#define SCR1    (*((UCHAR *)0xfffba))
#define TDR1    (*((UCHAR *)0xfffbb))
#define SSR1    (*((UCHAR *)0xfffbc))
#define RDR1    (*((UCHAR *)0xfffbd))

#define SMR1Ptr (0xfffb8)
#define BRR1Ptr (0xfffb9)
#define SCR1Ptr (0xfffba)
#define TDR1Ptr (0xfffbb)
#define SSR1Ptr (0xfffbc)
#define RDR1Ptr (0xfffbd)

/*----------------------------------------------------------------------*
 *    ADDAС                                                  *
 *----------------------------------------------------------------------*/
/* ADС */
#define PADDRA	(0xfffe0)		/* ADǡ쥸A ɥ쥹 */
#define PADDRB	(0xfffe2)		/* ADǡ쥸B ɥ쥹 */
#define PADDRC	(0xfffe4)		/* ADǡ쥸C ɥ쥹 */
#define PADDRD	(0xfffe6)		/* ADǡ쥸D ɥ쥹 */
#define	PADCSR	(0xfffe8)		/* ȥ롦ơɥ쥹*/
#define	PADCR	(0xfffe9)		/* ADȥ쥸ɥ쥹 */

#define ADDRA   (*((UINT  *)PADDRA))	/* ǡ쥸A */
#define ADDRAH  (*((UCHAR *)PADDRA))
#define ADDRAL  (*((UCHAR *)(PADDRA+1)))
#define ADDRB   (*((UINT  *)PADDRB))	/* ǡ쥸B */
#define ADDRBH  (*((UCHAR *)PADDRB))
#define ADDRBL  (*((UCHAR *)(PADDRB+1)))
#define ADDRC   (*((UINT  *)PADDRC))	/* ǡ쥸C */
#define ADDRCH  (*((UCHAR *)PADDRC))
#define ADDRCL  (*((UCHAR *)(PADDRC+1)))
#define ADDRD   (*((UINT  *)PADDRD))	/* ǡ쥸D */
#define ADDRDH  (*((UCHAR *)PADDRD))
#define ADDRDL  (*((UCHAR *)PADDRD+1))
#define ADCSR   (*((UCHAR *)PADCSR))	/* ADȥ롦ơ */
#define ADCR    (*((UCHAR *)PADCR))	/* ADȥ */

/* DAС */
#define DADR0   (*((UCHAR *)0xfffdc))	/* DA ǡ쥸0 */
#define DADR1   (*((UCHAR *)0xfffdd))	/* DA ǡ쥸1 */
#define DACR    (*((UCHAR *)0xfffde))	/* DA ȥ쥸 */
#define DASTCR  (*((UCHAR *)0xfff5c))	/* DA Хȥ */

/*----------------------------------------------------------------------*
 *    RAM / եå                                            *
 *----------------------------------------------------------------------*/
#define	FLMCR	(*((UCHAR *)0xfff40))	/* եåꥳȥ */
#define	EBR1	(*((UCHAR *)0xfff42))	/* õ֥å1 */
#define	EBR2	(*((UCHAR *)0xfff43))	/* õ֥å2 */
#define	RAMCR	(*((UCHAR *)0xfff48))	/* RAMȥ쥸 */

/************************************************************************
 *    H8 ¢쥸                                         *
 ************************************************************************/

#define	INIT_SYSCR	(0x03)		/* SYSCR */
#define	INIT_IER	(0x00)		/* ߥ֥͡ */
#define	INIT_ISCR	(0x00)		/* ߥå */
#define	INIT_IPRA	(0x04)		/* ߥץ饤ƥ */
#define	INIT_IPRB	(0x00)		/* ߥץ饤ƥ */

/**** Хȥ ****/
#define	INIT_ABWCR	(0x9f)		/* Х */
#define	INIT_ASTCR	(0x9f)		/* ơȥȥ */
#define	INIT_WCR	(0xfa)		/* ȥȥ */
#define	INIT_WCER	(0x9f)		/* ȡ֥͡ */
#define	INIT_BRCR	(0xfe)		/* Х꡼ػ */
#define	INIT_CSCR	(0xff)		/* åץ쥯ȥȥ */

/**** եå女ȥ ****/
/* ͤΤޤ */

/**** DMAȥ ****/
/* ͤΤޤ */

/**** I/Oݡ ****/
#define	INIT_P1DDR	(0xff)		/* ɥ쥹ϻ */
#define	INIT_P2DDR	(0xff)		/* ɥ쥹ϻ */
/* P3DDRϥǡХ */
/* P4DDRϥǡХ */
#define	INIT_P4PCR	(0xff)		/* pull up MOS ON */
#define	INIT_P5DDR	(0xff)		/* ɥ쥹ϻ */
#define	INIT_P5PCR	(0xff)		/* pull up MOS ON */
/* P6DDRϽͤΤޤ */
/* ݡ7Ϥʤ */
#define	INIT_P8DDR	(0xee)		/* CS1-3/IRQ */
#define	INIT_P9DDR	(0xf0)		/* SCIü */
#define	INIT_PADDR	(0x00)		/*  */
#define	INIT_PBDDR	(0x00)		/*  */

/**** ITU ****/
#define	RUN_ITU0	(0x01)
#define	RUN_ITU1	(0x02)
#define	RUN_ITU2	(0x04)
#define	RUN_ITU3	(0x08)
#define	RUN_ITU4	(0x10)

#define INIT_TSTR	RUN_ITU0	/* ITU0 ư */
/* #define	INIT_TSNC	(0x00) */		/* ͤΤޤ */
#define	INIT_TSNC	(0xe0)		/* ͤΤޤ */
/* #define	INIT_TMDR	(0x00) */		/* ͤΤޤ */
#define	INIT_TMDR	(0x80)		/* ͤΤޤ */
#define	INIT_TFCR	(0xc0)		/* ͤΤޤ */
#define	INIT_TOER	(0xc0)		/* ޽϶ػ */
#define	INIT_TOCR	(0xff)		/* ͤΤޤ */

#define INIT_TCR0	(0xa3)		/* GRAڥꥢ/8 å */
#define	INIT_TIOR0	(0x88)		/* GRA/GRB ڥ϶ػ */
#define	INIT_TIER0	(0xf9)		/* IMIEA = 1 */
#define	INIT_GRA0	(4000)		/* 2msec  */
#define INIT_GRB0	(2000)		/* 1msec  */
#define INT_GRAMASK	(0x01)
#define	INT_GRBMASK	(0x02)
#define INT_OVFMASK	(0x04)

/**** TPC ****/
/* 괺ͤΤޤ */

/**** åɥå ****/
/* 괺ͤΤޤ */

/**** SCI ****/
#define	TxON(x)		(x | 0x20)
#define	RxON(x)		(x | 0x10)
#define	TxOFF(x)	(x & 0xdf)
#define	RxOFF(x)	(x & 0xef)
#define	INIT_SMR0	(0x00)		/* ͤΤޤ */
#define	INIT_SCR0	(0x30)		/* ͤΤޤ */
#define	INIT_BRR0	(0x0c)		/* 38400 bps */

#define	INIT_SMR1	(0x00)		/* ͤΤޤ */
#define	INIT_SCR1	(0x30)		/* ͤΤޤ */
#define	INIT_BRR1	(0x0c)		/* 38400 bps */

/**** ޡȥɡ󥿡ե ****/
/* ̤ */

/**** AD/DAС ****/
#define	INIT_ADCR	(0x7f)		/* ͤΤޤ */
#define	INIT_ADCSR	(0x13)		/* Ѵ233ơȡ */

/* end of file */

