/************************************************************************
 ************************************************************************
 ****                                                                ****
 ****    miscenv.c : X̊ݒ֐                              ****
 ****                                                                ****
 ************************************************************************
 ************************************************************************/
#include	"generic.h"
#include	"config.h"
#include	"include/sys.h"

extern	UCHAR	getStartMode();
extern	void	setStartMode(UCHAR);
extern	UCHAR	getBeepOn();
extern	UINT	getBeepFreq();

int	miscInit();
int	execDispInfo();
int	execSysEnv();
void	dispSysEnv(int);
int	editSysEnv(int, int);
void	dispBeepOnOff();
int	editBeepOnOff(int);
void	dispBeepFreq();
int	editBeepFreq(int);
void	dispBeepMsec();
int	editBeepMsec(int);
void	dispContrast();
int	editContrast(int, UCHAR);
void	dispStartMode();
int	editStartMode();
void	saveSysEnv();

extern UINT	beep;			/* Beep JEgl(̒) */
extern UINT	bcnt;			/* Beep pJE^ */

void
dispSysEnv(int m)
{
    switch(m) {
    case 0:    dispBeepOnOff();		break;
    case 1:    dispBeepFreq();		break;
    case 2:    dispBeepMsec();		break;
    case 3:    dispContrast();		break;
    case 4:    dispStartMode();		break;
    }
}

int
editSysEnv(int m, int s)
{
    int		rtn;
    UCHAR	dcntrst;
    
    dcntrst = getContrast() / 4;
    switch(m) {
    case 0:	rtn = editBeepOnOff(s);		break;
    case 1:	rtn = editBeepFreq(s);		break;
    case 2:	rtn = editBeepMsec(s);		break;
    case 3:	rtn = editContrast(s, dcntrst);	break;
    case 4:	rtn = editStartMode();          break;
    }
    return(rtn);
}

void
dispBeepOnOff()
{
    lcdMoveto(0, 7);
    if (getBeepOn()) { lcdOut("ON "); lcdCommand(CUR_LEFT); }
    else  	     { lcdOut("OFF"); }
}

int
editBeepOnOff(int s)
{
    int		rtn=0;
    
    if (s == 1) {
        BeepEnable();
        /*beepon = 1;*/
        rtn = 1;
    } else if (s == -1) {
	BeepDisable();
        /*beepon = 0;*/
        rtn = 0;
    }
    dispBeepOnOff();
    return(rtn);
}

void
dispBeepFreq()
{
    char	fstr[5];
    UINT	beepf;

    beepf = getBeepFreq();
    itonstr(fstr, beepf, 4);
    fstr[4] = '\0';
    lcdMoveto(1, 1);
    lcdOut(fstr);
}

int
editBeepFreq(int s)
{
    UINT	bfreq;

    bfreq = getBeepFreq();
    if (s == 1) {
        if (bfreq < 20000)    bfreq = bfreq + 100;
        setBeepFreq(bfreq);
    } else if (s == -1) {
        if (bfreq > 100)      bfreq = bfreq - 100;
        setBeepFreq(bfreq);
    }
    dispBeepFreq();
    return(1);
}

void
dispBeepMsec()
{
    char	mstr[5];
    UINT	len;

    len = getBeepLen();
    itonstr(mstr, len, 4);
    mstr[4] = '\0';
    lcdMoveto(1, 10);
    lcdOut(mstr);
}

int
editBeepMsec(int s)
{
    UINT	dms;

    dms = getBeepLen();
    if (s == 1) {
        dms = dms << 1;
        setBeepLength(dms);
    } else if (s == -1) {
        dms = dms >> 1;
        setBeepLength(dms);
    }
    dispBeepMsec();
    return(1);
}

void
dispContrast()
{
    UCHAR	c, str[6];

    c = getContrast() / 4;
    if (c >= 30)  c = 30;
    lcdMoveto(2, 12);
    itonstr(str, c, 2);
    lcdOut(str);
    lcdMoveto(2, 13);
}

int
editContrast(int s, UCHAR src)
{
    UCHAR	contrast;
    
    if (s == 1) {
        if (src < 30)    src = src++;
    } else if (s == -1) {
        if (src > 0)	 src = src--;
    }
    contrast = src * 4;
    setContrast(contrast);
    dispContrast();
    return(0);
}

void
dispStartMode()
{
    UCHAR	m;
    
    m = getStartMode();
    lcdMoveto(3, 10);
    if (m) {
        lcdOut("CONT");
    } else {
        lcdOut(" PGM");
    }
    lcdMoveto(3, 13);
}
    
int
editStartMode()
{
    UCHAR	m;

    m = getStartMode();
    if (m)	setStartMode(0);
    else	setStartMode(1);
    dispStartMode();
    return(0);
}
              
void
saveSysEnv()
{
    UCHAR	contrast;
    UINT	bfreq, beepon, dms;
    
    lcdCommand(CLEAR);
    lcdCommand(BRINK_OFF);
    lcdCommand(CUR_OFF);
    lcdMoveto(1, 0);
    lcdOut("Save system setting.");

    /* bfreq, beepon, dms, contrast */
    bfreq = getBeepFreq();
    setSysParam(BEEP_FREQ, bfreq,    0);
    dms = getBeepLen();
    setSysParam(BEEP_LEN,  dms,      0);
    beepon = getBeepOn();
    setSysParam(BEEP_ON,   beepon,   0);
    contrast = getContrast();
    setSysParam(CONTRAST,  contrast, 0);
    waitSecLoop(1);
    sysParamRec();
}
