/************************************************************************
 *                                                                      *
 *    string.c : oCg֐iWCuΉ)            *
 ************************************************************************/
#include	"generic.h"
#include	"config.h"
#include	"ansi.h"

int
strlen(char *s)
{
    int		i=0;
    while(s[i])	i++;
    return(i);
}
	
int
strcmp(char *d, char *s)
{
    int		rtn;
    
    rtn = 0;
    while(*d != '\0' && *d == *s) {
	d++;
	s++;
    }
    return((int)(*d - *s));
}

int
strncmp(char *d, char *s, int n)
{
    if (n == 0)	return(0);
    while(n-- != 0 && *d == *s) {
	if((n == 0) || (*d == '\0') || (*s == '\0'))	break;
	d++;
	s++;
    }
    return((int)(*d - *s));
}

char *
strcat(char *d, char *s)
{
    char	*rtn;

    rtn = d;
    while(*d)	d++;
    while(*d++ = *s++)	;

    return(rtn);
}

char *
strncat(char *d, char *s, int n)
{
    char	*rtn;

    rtn = d;
    while(*d)	d++;
    while(n-- != 0 && (*d++ = *s++)) {
	if (n == 0)	*d = '\0';
    }

    return(rtn);
}

char *
strcpy(char *d, char *s)
{
    char	*rtn;

    rtn = d;
    while(*d++ = *s++) ;
    *d = '\0';
    return(rtn);
}

char *
strncpy(char *d, char *s, int n)
{
    char	*rtn;

    rtn = d;
    while(n > 0) {
	--n;
	if ((*d++ = *s++) == '\0')	break;
    }
    *d = '\0';
    return(rtn);
}

int
memcopy16(void *dest, void *src, int num)
{
    int		i;
    
    for(i=0; i<num; i++) {
	*(unsigned int *)dest = *(unsigned int *)src;
	dest = dest + 2;
	src = src + 2;
    }
    return(i);
}

int
memcpy(char *dest, char *src, int num)
{
    int		i;
    for(i=0; i<num; i++) {
	*dest = *src;
	dest++;
	src++;
    }
    return(i);
}

int
itostr(int d, char *str, int base)
{
    int		i, sub, cnt, max;
    char	src[8];

    max = 0;
    while(d) {
	sub = d / base;
	cnt = d - sub * base;
	src[max++] = cnt + '0';
	d = sub;
    }

    if (max == 0) {
	str[0] = '0';
	i = 1;
    } else {
	for(i=0; i<max; i++) {
	    str[max-i-1] = src[i];
	}
    }

    str[i] = '\0';
    return(i);
}

int
itonstr(char *s, long n, int len)
{
    long	d, sub, cnt;
    int		i;

    d = n;
    for(i=0; i<len; i++) {
	sub = d / 10;
	cnt = d - sub * 10;
	s[len - 1 - i] = cnt + '0';
	d = sub;
    }
    s[len] = '\0';
    for(i=0; i<len; i++) {
        if (i == len - 1) break;
        if (s[i] == '0')  s[i] = ' ';
        else              break;
    }
    
    return(0);
}

int
itonhstr(char *s, long n, int len)
{
    long	d;
    int		i, max;

    /*  0 fill */
    if (len == 2)	max = 2;
    else if(len == 4)	max = 4;
    else if(len == 8)	max = 8;
    else		max = 4;
    
    for(i=0; i<max; i++) {
	s[i] = '0';
    }
    s[max] = '\0';

    /* oCgϊ */
    for(i=0; i<2; i++) {
	d = n & 0x0f;
	if (d < 0x0a)	s[max-(i+1)] = d + '0';
	else		s[max-(i+1)] = (d - 10) + 'a';
	n = n >> 4;
    }

    /* 16bitϊ */
    if ((len == 4) || (len == 8)) {
	for(i=0; i<2; i++) {
	    d = n & 0x0f;
	    if (d < 0x0a)	s[max-(i+3)] = d + '0';
	    else		s[max-(i+3)] = (d - 10) + 'a';
	    n = n >> 4;
	}
    }
    /* 32bitϊ */
    if (len == 8) {
	for(i=0; i<4; i++) {
	    d = n & 0x0f;
	    if (d < 0x0a)	s[max-(i+5)] = d + '0';
	    else		s[max-(i+5)] = (d - 10) + 'a';
	    n = n >> 4;
	}
    }

    return(0);
}

long
strtoi(char *src)
{
    long	d, base, sign;
    char	*p;

    p = src;
    /*  */
    if (*p == '-') {
	sign = -1;
	p++;
    } else {
	sign = 1;
    }

    /* 10i/16i */
    if (strncmp(p, "0x", 2) == 0) {
	base = 16;
	p += 2;
    } else if (strncmp(p, "0X", 2) == 0) {
	base = 16;
	p += 2;
    } else {
	base = 10;
    }

    /* lvZ */
    d = 0;
    while (*p) {
	if ((*p >= '0') && (*p <= '9')) {
	    d = (d * base) + (long)(*p - '0');
	} else if ((*p >= 'a') && (*p <= 'f')) {
	    d = (d * base) + (long)(*p - 'a' + 10);
	} else if ((*p >= 'A') && (*p <= 'F')) {
	    d = (d * base) + (long)(*p - 'A' + 10);
	}
	p++;
    }
    d = d * sign;	/*  */

    return(d);
}

/************************************************************************
 *    Bios p̊֐ivOΉjʏgpȂ                 *
 ************************************************************************/
/**** tr ****/
int
hstrncmp(char *dest, char *src, int n)
{
    int		i, rtncode = 0;

    for(i=0; i<n; i++) {
	rtncode = rtncode + (int)(*src - *dest);
	src++;
	dest++;
    }

    return(rtncode);
}

/**** t16iϊ ****/    
ULONG
hstrtoni(char *s, int n)
{
    int         i;
    ULONG       d;

    d = 0;
    for(i=0; i<n; i++) {
	d = d << 4;
        if ((s[i] >= '0') && (s[i] <= '9'))
            d = d + (ULONG)(s[i] - '0');
        else if ((s[i] >= 'A') && (s[i] <= 'F'))
            d = d + (ULONG)(s[i] - 'A' + 10);
        else if ((s[i] >= 'a') && (s[i] <= 'f'))
            d = d + (ULONG)(s[i] - 'a' + 10);
    }
    return(d);
}

/* end of file */
