/************************************************************************
 ************************************************************************
 ****
 ****    main.c : NEj^vO
 ****
 ****---------------------------------------------------------------
 ****	V1.0	2001.3.1    HaM-Ip[X    by tutiyama
 ************************************************************************
 ************************************************************************/
#include	"generic.h"
#include	"h8_3048.h"
#include	"sys.h"
#include	"ansi.h"

/************************************************************************
 *    ֐Eϐ錾                                                    *
 ************************************************************************/
/**** O֐ ****/
extern	void	init_sys();
extern  int	waitmsec(int);

/**** ֐錾 ****/
int	main();
BOOL	checkStart();
int	load_app();
int	halt();
void	printStartMsg();
UCHAR	CheckTxData(UCHAR);
int	cputc(int, int);
int	cputs(char *, int);
int	cgetc(int);

extern	int	settingmd;		/* param.s Ő錾 */

/************************************************************************
 *    main()                                                            *
 ************************************************************************/
int
main()
{
    BOOL	b;
    UCHAR	*led;

    init_sys();				/* H8ӏ */
    b = checkStart();			/* X^[g`FbN */
    stopSCI(SCI_CH1);			/* ch1 VA~ */
    stopSCI(SCI_CH0);			/* ch1 VA~ */
    fifoInit();				/* VApobt@ */
    lcdInit();				/* LCDNA */
    startInt();				/* 荞݋ */
    init_sci0();			/* obt@[hVAJn */
    init_sci1();			/* obt@[hVAJn */
    shellInit();			/* VF̏ */

    if( b ){				/* N`FbN/Serial Restart */
	load_app();			/* AvP[Vs */
    }
    biosLcdMove(2, 0);
    biosLcdOut("Run Shell mode.");
    printStartMsg();			/* bios startup message */
    bootShell();			/* mixer boot shell */
}

/************************************************************************
 *	checkStart() : AvP[V/VFN؂芷              *
 ************************************************************************/
/*
 * o 10AŃXy[X͂ꂽHaMVFN
 * o tbVɃAvP[VĂȂVFN
 */
BOOL
checkStart()
{
    int		i, c;
    ULONG	*vector, *start;
    UCHAR	s;
    ULONG	MagicBootCode=0x48616D32;
    ULONG	*MagicBootReg=(ULONG *)0x0a00fc;

    /* VA͂̃`FbN */
    waitmsec(5);
    c = cgetc(SCI_CH1);
    if (c == ' ') {
	cputs("\n\rStarting Bios\n\r", SCI_CH1);
	stopSCIRx(SCI_CH1);		/* ch1 VAM~ */
	s = SSR1;
	if (s & 0x08) {			/* peBG[ */
	    SSR1 = s & 0xf7;
	}
	if (s & 0x10) {			/* t[~OG[ */
	    SSR1 = s & 0xef;
	}
	if (s & 0x20) {			/* I[o[G[ */
	    SSR1 = s & 0xdf;
	}
	for(i=0; i<100; i++) {		/* 2b҂ */
	    waitmsec(2);
	    if ((i % 25) == 0) cputs(">", SCI_CH1);
	}
	cputs("\n\r", SCI_CH1);
	startSCIRx(SCI_CH1);		/* VAMX^[g */
	c = getc(SCI_CH1);
	return(FALSE);			/* Bios N */
    }

    /* tbṼ`FbN */
    if (! flashCheck()) {
	cputs("Flash memory Error.\n", SCI_CH1);
	return(FALSE);
    }

    /* AvP[VxN^̃`FbN */
    vector = (ULONG *)EXT_FLASH_START;
    if (*vector == 0xffffffff) {
	cputs("No apprication installed.\n\r", SCI_CH1);
	return(FALSE);
    }
    
    /* }WbNu[gR[h̃`FbN */
    if( *MagicBootReg == MagicBootCode ) {
	cputs("Boot Code Detected.\n\r", SCI_CH1);
	*MagicBootReg=0xffffffff;
	return(FALSE);
    }

    /* X^[gAbvR[h̃`FbN */
    start = (ULONG *)(*vector);
    if (*start == 0xffffffff) {
	cputs("No apprication startup code.\n\r", SCI_CH1);
	return(FALSE);
    }
    return(TRUE);
}

/************************************************************************
 *    loadApp() : AvP[V[h                                *
 ************************************************************************/
int
load_app()
{
    ULONG	*vector = (ULONG *)(0x20000);
    ULONG 	*appvect= (ULONG *)(0xa0000);
    /* UINT	*bcode =  (UINT *)(0xd0000); */
    UCHAR	*ps, *pd;
    ULONG	cnt;
    	
    if (*vector == (ULONG)0xffffffff) {
	puts("Apprication Not Found.\n\r", stdout);
	return(0);			/* AvP[VȂ */
    }else{
    	/* Data ]i128KBj*/
        biosLcdMove(2, 0);
        biosLcdOut("Loading...");
    	ps=(UCHAR *)vector;
    	pd=(UCHAR *)appvect;
    	for( cnt=0; cnt<0x20000; cnt++){
            if ((cnt & 0xffff) == 0) {
                biosLcdOut(".");
            }
            *pd++ = *ps++;
	}
    	/* Data Check */
    	if( *vector != *appvect ){
	    puts("Data Error  => Return to Boot-Monitor\n\r", stdout);
	    return(0);			/* Data G[ */
    	}
    }
    disableIRQ();
    start_app(vector);
    return(0);
}

/************************************************************************
 *    halt() : VXe~                                             *
 ************************************************************************/
int
halt()
{
    puts("halted.", stdout);
    while(1) {;}
}

/************************************************************************
 *    printStartMsg() : HamII B&L X^[gbZ[W
 ************************************************************************/
int	vernum = 0x0004;
void
printStartMsg()
{
    puts("\n\r", stdout);
    puts("***************************************\n\r", stdout);
    puts("*    K-mix Boot                       *\n\r", stdout);
    puts("*                        Ver. 0.4     *\n\r", stdout);
    puts("*                        2004. 3.24   *\n\r", stdout);
    puts("***************************************\n\r", stdout);
}

/************************************************************************
 *    cputs/cputc : |[O[hiobt@ȂjڃANZX        *
 ************************************************************************/
#define	SCI_TxSTART(x)	(x & 0x7f)
#define CHECK_TxEND(x)  (x & 0x04)

UCHAR CheckTxData(UCHAR v) { return(v & 0x80); }

int
cputc(int c, int fd)
{
    if (fd == SCI_CH0) {
        while(1) {
            if (CheckTxData(SSR0))	break;
        }
        TDR0 = (UCHAR) c;
        SSR0 = SCI_TxSTART(SSR0);
    } else {
        while(1) {
            if (CheckTxData(SSR1))	break;
        }
        TDR1 = (UCHAR) c;
        SSR1 = SCI_TxSTART(SSR1);
    }
    return(0);
}

int
cputs(char *string, int fd)
{
    int		i = 0;

    while(string[i] != '\0') {
        cputc(string[i], fd);
        i++;
    }
    return(i);
}
    
/************************************************************************
 *    cgetc : |[O[hiobt@ȂjڃANZX              *
 ************************************************************************/
#define	CHECK_RxD(x)	(x & 0x40)
/**** ꕶ ****/
int
cgetc(int fd)
{
    int	 c;
    char d;

    c = 0;
    /**** G[͏ȗ ****/
    if (fd == SCI_CH0) {			/* CH0 f[^M */
	if (CHECK_RxD(SSR0)) {
	    c = RDR0;
	    SSR0 = SSR0 & 0xbf;
	}
    } else {					/* CH1 f[^M */
	if (CHECK_RxD(SSR1)) {
	    c = RDR1;
	    SSR1 = SSR1 & 0xbf;
	}
    }
    return(c);
}

/* end of file */
