/************************************************************************
 *                                                                      *
 *    shell.c : AvP[VVF                                  *
 *                                                                      *
 ************************************************************************/
#include	"generic.h"
#include	"config.h"
#include	"h8_3048.h"
#include	"sys.h"
#include	"ansi.h"

#include	"shell.h"
#include	"command.h"

extern	int	sci0in();
extern	int	sci1in();
extern	int	sci0out(char);
extern	int	sci0outs(char *);
extern	int	sci1out(char);
extern	int	sci1outs(char *);

void	prompt(void);
void	getcmdchar(int);
void	add(int);
void	insert(int);
void	newcmdbuf(void);
int	sethistory(int);
void	cursol_right(char *);
void	cursol_left(char *);
void	functionKey(int);
void	commandClear(void);
void	cursol_end(void);
void	cursol_head(void);
void	delete(void);
void	backspace(void);
void	kill_line(void);
void	clear_line(void);
void	cur_save(void);
void	cur_retrieve(void);

void	shellInit(void);
void	shell(void);
int	execCommand(char *);
int	cmdline(char **, char *);
void	*searchCommand(char *);

char	*npm = "K-mix>";
char	*bpm = "KmixBoot>";

extern char	*command;		/* R}hobt@|C^ */
extern int	scol;			/* ̓R}h */
extern int	hnum;			/* qXgԍ */
extern int	bnum;			/* R}hobt@ԍ */
extern int	cur;			/* J[\ʒu */
extern int	exeflag;		/* R}hstO */
extern int	result;			/* R}hsXe[^X */
extern int	smode;			/* ̓[h */
extern char	*pm;
extern int	argc;
extern char	*argv[10];
extern char	cmdbuf[HNUM][80];	/* R}hobt@ */
extern char	cmdstr[80];		/* sR}h */
extern cmdlist	*cmdl;			/* R}hXg\ */
extern int	comnum;

void
setCmdList(cmdlist *cmd, int num)
{
    cmdl = cmd;
    comnum = num;
}

void
prompt(void)
{
    puts(pm, stdout);
    cur_save();
    cur = 0;
}

void
setprompt(int smode)
{
    if (smode)  pm = npm;
    else        pm = bpm;
}

int
getbufnum()
{
    return(bnum);
}

void
getcmdchar(int c)
{
    if (cur == scol) {			/* ֒ǉ */
	add(c);
    } else {				/* } */
	insert(c);
    }
    exeflag = 0;
}

void
add(int c)
{
    command[scol++] = c;
    command[scol] = '\0';
    cur++;
    putc(c, stdout);
}

void
insert(int c)
{
    int		i;
    char	str[4];
    
    if (cur < 0)	return;
    if (cur >= scol) {
	command[scol++] = c;
	command[scol] = '\0';
	cur++;
    } else {
	for(i=scol; i>cur; i--) {		/* 1炷 */
	    command[i] = command[i-1];
	}
	command[i] = c;				/* } */
	scol++;
	cur++;
    }
    puts(&command[cur-1], stdout);
    itostr((scol-cur), str, 10);
    cursol_left(str);
}

void
newcmdbuf(void)
{
    if (bnum == HNUM-1)	bnum = 0;
    else		bnum++;
    command = cmdbuf[bnum];
    hnum = bnum;
}

int
sethistory(int n)
{
    int		i, h, rtn;

    rtn = 0;
    h = hnum + n;
    if (h >= HNUM) {
	h = h - HNUM;
    } else if (h < 0) {
	h = h + HNUM;
    }
    if (h == bnum)	return(rtn);
    
    if (cmdbuf[h][0] != '\0') {
	hnum = h;
	cur_retrieve();
	for(i=0; i<scol; i++) {
	    putc(' ', stdout);
	}
	cur_retrieve();
	strcpy(command, cmdbuf[hnum]);
	scol = strlen(command);
	cur = scol;
	puts(command, stdout);
	rtn = 1;
    }
    return(rtn);
}

void
cursol_right(char *c)
{
    int		i;
    char	str[4];

    i = 0;
    if (cur > scol) {
	cur = scol;
    } else {
	str[i++] = ANSI_ESC;
	str[i++] = '[';
	while(*c != '\0') {
	    str[i++] = *c;
	    c++;
	}
	str[i++] = 'C';
	str[i] = '\0';
	puts(str, stdout);
    }
}

void
cursol_left(char *c)
{
    int		i;
    char	str[4];

    i = 0;
    if (cur < 0) {
	cur = 0;
    } else {
	str[i++] = ANSI_ESC;
	str[i++] = '[';
	while(*c != '\0') {
	    str[i++] = *c;
	    c++;
	}
	str[i++] = 'D';
	str[i] = '\0';
	puts(str, stdout);
    }
}

void
functionKey(int key)
{
    ;		/* Function Key ̐ݒȂ */
}

void
commandClear(void)
{
    clear_line();
    scol = 0;
    cur = 0;
    command[scol] = '\0';
}

void
cursol_end(void)
{
    int		n, i;
    char	str[8];

    i = 0;
    n = scol - cur;
    if (n > 0) {
	str[i++] = ANSI_ESC;
	str[i++] = '[';
	i = i + itostr(n, &str[i], 10);
	str[i++] = 'C';
	str[i] = '\0';
	cur = scol;
	puts(str, stdout);
    }
}

void
cursol_head(void)
{
    int		i;
    char	str[8];
    
    i = 0;
    if (cur > 0) {
	str[i++] = ANSI_ESC;
	str[i++] = '[';
	i = i + itostr(cur, &str[i], 10);
	str[i++] = 'D';
	str[i] = '\0';
	cur = 0;
	puts(str, stdout);
    }
}

void
delete(void)
{
    int		i;
    char	str[4];

    if (cur == scol)	return;

    for(i=cur; i<scol; i++) {
	command[i] = command[i+1];
    }
    command[i] = '\0';
    puts(&command[cur], stdout);
    putc(' ', stdout);
    itostr((scol-cur), str, 10);
    cursol_left(str);
    scol--;
}

void
backspace(void)
{
    int		i;
    char	str[8];
    
    if (cur < 1)	return;
    if (cur == scol) {
	cursol_left("1");
	putc(' ', stdout);
	cursol_left("1");
	scol--;
	cur = scol;
	command[scol] = '\0';
    } else {
	cur--;
	for(i=cur; i<scol; i++) {
	    command[i-1] = command[i];		/* ꕶl߂ */
	}
	command[i-1] = '\0';
	puts(&command[cur], stdout);
	putc(' ', stdout);
	scol--;
	itostr((scol-cur), str, 10);
	cursol_left(str);
    }
}

void
kill_line(void)
{
    int		i;
    char	s[4];
    
    if (cur == scol)	return;
    for(i=cur; i<scol; i++) {
	putc(' ', stdout);
	command[i] = '\0';
    }
    itostr((scol-cur), s, 10);
    cursol_left(s);
    scol = cur;
}

void
clear_line(void)
{
    int		i;
    
    cur_retrieve();
    cur = 0;
    for(i=0; i<scol; i++) {
	putc(' ', stdout);
	command[i] = '\0';
    }
    cur_retrieve();
    scol = 0;
}

void
cur_save(void)
{
    char  str[4] = {0x1b, '[', 's', '\0'};
    puts(str, stdout);
}

void
cur_retrieve(void)
{
    char  str[4] = {0x1b, '[', 'u', '\0'};
    puts(str, stdout);
}

/************************************************************************
 *    shell ֐                                                  *
 ************************************************************************/
void
shellInit(void)
{
    int		i, n;
    
    puts("\n\r", stdout);
    setCmdList(cmddb, CMDNUM);
    for(n=0; n<HNUM; n++) {
	for(i=0; i<80; i++) {
	    cmdbuf[n][i] = '\0';
	}
    }
    scol = 0;
    exeflag = 1;
    result = 0;
    smode = NORMAL;
    hnum = 0;
    bnum = 0;
    cur = 0;
    command = cmdbuf[bnum];
    prompt();
}

bootShell(void)
{
    setprompt(0);
    prompt();
    while(1) {
        shell();
    }
}

/************************************************************************
 *    shell() : VFs֐(C^[oR[)                      *
 ************************************************************************/
void
shell(void)
{
    int		c, key,cnum;
    char	buf[8];

    buf[0]='0'; buf[1]='x'; buf[4]=' '; buf[5]='\0';
    c = getc(stdin);
    key = NONKEY;
    cnum = 0;
    if (c == EOF)	return;
    switch(c & 0xff) {
    case '\n':
    case '\r':
	puts("\n\r", stdout);			/* GR[obN */
	if (exeflag == 0) {			/* 2Ash~ */
	    command[scol] = '\0';		/* I[ */
	    result = execCommand(command);	/* R}hs */
	    newcmdbuf();
	}
	scol = 0;
	cur = 0;
	exeflag = 1;
	prompt();
	break;
    case ANSI_ESC:			/* 0x1b : Escape */
	smode = ESCAPE_KEY;
	break;
    case '[':				/* 0x5b : Escape Sequence Jn */
	if (smode == ESCAPE_KEY) {
	    smode = ESCAPE;
	    key = ESCKAY;
	} else {
	    getcmdchar(c);
	    smode = NORMAL;
	}
	break;
    case '0':
	if (smode == FUNC_B) {
	    smode = ELAST;
	    key = F9KEY;
	} else {
	    getcmdchar(c);
	    smode = NORMAL;
	}
	break;
    case '1':
	if (smode == ESCAPE) {
	    smode = FUNC_A;
	} else if (smode == FUNC_A) {
	    smode = ELAST;
	    key = F1KEY;
	} else if (smode == FUNC_B) {
	    smode = ELAST;
	    key = F10KEY;
	} else {
	    getcmdchar(c);
	    smode = NORMAL;
	}
	break;
    case '3':
	if (smode == ESCAPE) {
	    smode = ELAST;
	    key = PAGEUP;
	} else if (smode == FUNC_A) {
	    smode = ELAST;
	    key = F3KEY;
	} else if (smode == FUNC_B) {
	    smode = ELAST;
	    key = F11KEY;
	} else {
	    getcmdchar(c);
	    smode = NORMAL;
	}
	break;
    case '4':
	if (smode == ESCAPE) {
	    smode = ELAST;
	    key = DELKEY;
	} else if (smode == FUNC_A) {
	    smode = ELAST;
	    key = F4KEY;
	} else if (smode == FUNC_B) {
	    smode = ELAST;
	    key = F12KEY;
	} else {
	    getcmdchar(c);
	    smode = NORMAL;
	}
	break;
    case '5':
	if (smode == ESCAPE) {
	    smode = ELAST;
	    key = ENDKEY;
	} else if (smode == FUNC_A) {
	    smode = ELAST;
	    key = F5KEY;
	} else {
	    getcmdchar(c);
	    smode = NORMAL;
	}
	break;
    case '6':
	if (smode == ESCAPE) {
	    smode = ELAST;
	    key = PAGEDOWN;
	} else {
	    getcmdchar(c);
	    smode = NORMAL;
	}
	break;
    case '7':
	if (smode == FUNC_A) {
	    smode = ELAST;
	    key = F6KEY;
	} else {
	    getcmdchar(c);
	    smode = NORMAL;
	}
	break;
    case '8':
	if (smode == FUNC_A) {
	    smode = ELAST;
	    key = F7KEY;
	} else {
	    getcmdchar(c);
	    smode = NORMAL;
	}
	break;
    case '9':
	if (smode == FUNC_A) {
	    smode = ELAST;
	    key = F8KEY;
	} else {
	    getcmdchar(c);
	    smode = NORMAL;
	}
	break;
    case 'A':
	if (smode == ESCAPE) {			/* L[m */
	    if (sethistory(-1))			/* qXg -1 */
		exeflag = 0;
	} else {
	    getcmdchar(c);
	}
	smode = NORMAL;
	break;
    case 'B':
	if (smode == ESCAPE) {			/* L[m */
	    if (sethistory(1))			/* qXg +1 */
		exeflag = 0;
	} else {
	    getcmdchar(c);
	}
	smode = NORMAL;
	break;
    case 'C':
	if (smode == ESCAPE) {			/* EL[m */
	    cur++;
	    cursol_right("1");			/* J[\E */
	} else {
	    getcmdchar(c);
	}
	smode = NORMAL;
	break;
    case 'D':
	if (smode == ESCAPE) {			/* L[m */
	    cur--;
	    cursol_left("1");			/* J[\ */
	} else {
	    getcmdchar(c);
	}
	smode = NORMAL;
	break;
    case '~':
	if (smode == ELAST) {			/* GXP[vV[PXm */
	    functionKey(key);
	} else {
	    getcmdchar(c);
	}
	smode = NORMAL;
	break;
    case Ctrl_Q:				/* ANSI_DC1 : Quit */
	commandClear();
	break;
    case Ctrl_E:				/* s */
	cursol_end();
	cur = scol;
	break;
    case Ctrl_U:
	commandClear();				/* R}hNA */
	break;
    case Ctrl_P:				/* qXg -1 */
	if (sethistory(-1))	exeflag = 0;
	break;
    case Ctrl_A:				/* s */
	cursol_head();
	cur = 0;
	break;
    case ANSI_DEL:
    case Ctrl_D:				/* ANSI_EOT : Delete */
	delete();
	break;
    case Ctrl_F:				/* J[\E */
	cur++;
	cursol_right("1");
	break;
    case Ctrl_H:				/* ANSI_BS : Back space */
	backspace();
	break;
    case Ctrl_K:				/* J[\E폜 */
	kill_line();
	break;
    case Ctrl_B:				/*  */
 	cur--;
	cursol_left("1");
	break;
    case Ctrl_N:
	if (sethistory(+1))	exeflag = 0;	/* qXg +1 */
	break;
    case '\t':
	if ((cnum = fillCommand(command, command, cnum)) == -1) {
	    cnum = 0;
	}
	break;
    default:
	getcmdchar(c);
	break;
    }
}

int
execCommand(char *cmd)
{
    int		rtn;
    int		(*function)();
    
    if (cmd[0] == '\0')	return(1);

    strcpy(cmdstr, cmd);
    argc = cmdline(argv, cmdstr);
    function = searchCommand(argv[0]);
    if (function != NULL) {
	rtn = (*function)(argc, argv);
    } else {
	puts("Error : can't find  ", stdout);
	puts(argv[0], stdout);
	puts("\n\r", stdout);
	rtn = -1;
    }
    return(rtn);
}

int
cmdline(char **argv, char *cmd)
{
    int		i = 0;
    int		n = 0;
    int		space = 0;

    argv[n] = &(cmd[i]);
    while(cmd[i] != '\0') {
	if (cmd[i] == ' ') {
	    if (space) {
		space = 1;
		cmd[i] = '\0';
		i++;
	    } else {
		cmd[i] = '\0';
		i++;
		n++;
		argv[n] = &(cmd[i]);
		space = 1;
	    }
	} else {
	    i++;
	    space = 0;
	}
    }

    return(n+1);
}

void *
searchCommand(char *str)
{
    int		i, find;

    find = 0;
    for(i=0; i<comnum; i++) {
	if (strcmp(cmdl[i].name, str) == 0) {
	    find = 1;
	    break;
	}
    }
    if (find) {
	return (cmdl[i].func);
    } else {
	return NULL;
    }
}

int
fillCommand(char *dest, char *src, int num)
{
    int		len, cn, find, n;

    len = strlen(src);
    if (num < comnum)	cn = num;
    else		cn = 0;

    find = 0;
    n = 0;
    while(1) {
	/**** R}hv`FbN ****/
	if (strncmp(cmdl[cn].name, src, len) == 0) {
	    find = 1;
	    break;
	}

	/**** R}hCfbNXvZ ****/
	cn++;
	if (cn >= comnum)	cn = 0;

	/**** T[``FbN ****/
	n++;
	if (n >= comnum)	break;
    }

    if (find) {
	strcpy(dest, cmdl[cn].name);
	cn++;
	if (cn >= comnum)	cn = 0;
	return(cn);
    } else {
	return(-1);
    }
}

int
dispCommandList()
{
    int		i, l, maxlen;
    int		scol, n;

    maxlen = 0;
    for(i=0; i<comnum; i++) {
	l = strlen(cmdl[i].name);
	if (l > maxlen)	maxlen = l;
    }
    maxlen = maxlen + 2;
    
    scol = 0;
    for(i=0; i<comnum; i++) {
	puts(cmdl[i].name, stdout);
	l = strlen(cmdl[i].name);
	for(n=0; n < maxlen-l; n++) {
	    putc(' ', stdout);
	}
	scol += maxlen;
	if ((scol+maxlen) > 76) {
	    puts("\n\r", stdout);
	    scol = 0;
	}
    }
    puts("\n\r", stdout);
    return(1);
}
    

/* end of file */
