/************************************************************************
 ************************************************************************
 ****                                                                ****
 ****    adda.c : ADϊADAϊ                                 ****
 ****                                                                ****
 ****----------------------------------------------------------------****
 ****                                                                ****
 ****    2004. 2.19 : fix.                                           ****
 ****                                                                ****
 ************************************************************************
 ************************************************************************/
#include	"include/generic.h"
#include	"include/h8_3048.h"
#include	"include/config.h"
#include	"include/sys.h"

/*
 * addc   i  aswc
 *   0    0    0 : adcr[0][0] = V_MAIN_L
 *   1    1    0 : adcr[1][0] = V_AUXR_R0
 *   2    2    0 : adcr[2][0] = V_AUXR_L1
 *   3    3    0 : adcr[3][0] = V_AUXS1
 *   4    4    0 : adcr[4][0] = V_EQM
 *   5    5    0 : adcr[5][0] = V_CHMAIN
 *   6    0    1 : adcr[0][1] = V_MAIN_R
 *   7    1    1 : adcr[1][1] = V_AUXR_R0
 *   8    2    1 : adcr[2][1] = V_AUXR_L0
 *   9    3    1 : adcr[3][1] = V_AUXS3
 *  10    4    1 : adcr[4][1] = V_PAN
 *  11    5    1 : adcr[5][1] = none
 *  12    0    2 : adcr[0][2] = none
 *  13    1    2 : adcr[1][2] = V_AUXR_R3
 *  14    2    2 : adcr[2][2] = V_AUXR_L3
 *  15    3    2 : adcr[3][2] = V_AUXS2
 *  16    4    2 : adcr[4][2] = V_EQL
 *  17    5    2 : adcr[5][2] = none
 *  18    0    3 : adcr[0][3] = none
 *  19    1    3 : adcr[1][3] = V_AUXR_R2
 *  20    2    3 : adcr[2][3] = V_AUXR_L2
 *  21    3    3 : adcr[3][3] = V_AUXS0
 *  22    4    3 : adcr[4][3] = V_EQH
 *  23    5    3 : adcr[5][3] = none
 */
#define	V_MAIN_L	(adcr[0][0])
#define	V_MAIN_R	(adcr[0][1])
#define	V_AUXR_R0	(adcr[1][1])
#define	V_AUXR_R1	(adcr[1][0])
#define V_AUXR_R2	(adcr[1][3])
#define	V_AUXR_R3	(adcr[1][2])
#define V_AUXR_L0	(adcr[2][1])
#define V_AUXR_L1	(adcr[2][0])
#define V_AUXR_L2	(adcr[2][3])
#define	V_AUXR_L3	(adcr[2][2])
#define	V_AUXS0		(adcr[3][3])
#define V_AUXS1		(adcr[3][0])
#define	V_AUXS2		(adcr[3][2])
#define	V_AUXS3		(adcr[3][1])
#define V_EQH		(adcr[4][3])
#define V_EQM		(adcr[4][0])
#define V_EQL		(adcr[4][2])
#define V_PAN		(adcr[4][1])
#define	V_CHMAIN	(adcr[5][0])

/************************************************************************
 *    錾                                                              *
 ************************************************************************/
/**** ֐錾 ****/
extern	int	asmWriteByte(UCHAR *, UCHAR);
extern  ChAttr	*getChDataPtr(int);
extern	MnAttr	*getMnDataPtr();

void	addaInit();
void	adinput(int);
void	adConvert(ChAttr *, MnAttr *);
void	setContrast(UCHAR);
void	settmpchp(MnAttr *, ChAttr *);

/**** ϐ錾 ****/
extern  UCHAR	ledMask, lampMask;
extern	UCHAR	subaMask, mainaMask, aswc;
extern	UCHAR	adcr[6][4];		/* tB^OADl(8bit) */
extern	int	admode;			/* ADϊ */

extern	UCHAR	ad1p[6][4];		/* 1tB^pobt@ */
extern	UCHAR	ad2p[6][4];		/* 2tB^pobt@ */
extern	UCHAR	ad3p[6][4];		/* 3tB^pobt@ */
extern	UCHAR   adfc[6][4];             /* tB^pobt@JE^ */
extern	int	a, b, c, d;		/* tB^W */

extern	UCHAR	d1p[6][4], d2p[6][4];
extern	UCHAR   h1c[6][4];

extern	UCHAR   dummy;
extern	UCHAR   addc;			/* ADf[^^[QbgԍJE^ */
extern	UCHAR   *tmpadp[24];
extern	UCHAR   *addcp[24];		/* ADXV^[Qbgf[^|C^ */
extern	UCHAR	*adflg[24];		/* AD^[Qbgf[^XVtO */
UCHAR   admc[24] = {			/* Main / CH ʎq */
    1, 1, 1, 2, 2, 2, 1, 1, 1, 2, 2, 0, 0, 1, 1, 2, 2, 0, 0, 1, 1, 2, 2, 0
};
#define	MNSETMASK       (0x01)
#define	CHSETMASK       (0x02)

extern	ChAttr	*chdest[16];		/* AD^[QbgCH f[^|C^ */
extern	MnAttr  *mndest;		/* AD^[QbgMain f[^|C^ */
extern	int     addset;			/* ADf[^XVtO */
extern  char	cntrst;

int
adchupdateSet(int onoff)
{
    if (onoff == ON) {
        addset = addset | CHSETMASK;
    } else if (onoff == OFF) {
        addset = addset & ~CHSETMASK;
    }
}

int
admnupdateSet(int onoff)
{
    if (onoff == ON) {
        addset = addset | MNSETMASK;
    } else if (onoff == OFF) {
        addset = addset & ~MNSETMASK;
    }
}

void
setmndest(MnAttr *mnd)
{
    mndest = mnd;
}

void
setchdest(ChAttr *chd, int ch)
{
    chdest[ch] = chd;
}

void
settmpchp(MnAttr *dmd, ChAttr *dcd)
{
    tmpadp[ 0] = &(dmd->mainl);		/*  0: V_MAIN_L */
    tmpadp[ 1] = &(dmd->auxr[1]);	/*  1: V_AUXR_R1 */
    tmpadp[ 2] = &(dmd->auxl[1]);	/*  2: V_AUXR_L1 */
    tmpadp[ 3] = &(dcd->snd[1]);	/*  3: V_AUXS1 */
    tmpadp[ 4] = &(dcd->mid);		/*  4: V_EQM */
    tmpadp[ 5] = &(dcd->vol);		/*  5: V_CHMAIN */
    tmpadp[ 6] = &(dmd->mainr);		/*  6: V_MAIN_R */
    tmpadp[ 7] = &(dmd->auxr[0]);	/*  7: V_AUXR_R0 */
    tmpadp[ 8] = &(dmd->auxl[0]);	/*  8: V_AUXR_L0 */
    tmpadp[ 9] = &(dcd->snd[3]);	/*  9: V_AUXS3 */
    tmpadp[10] = &(dcd->pan);		/* 10: V_PAN */
    tmpadp[11] = &dummy;
    tmpadp[12] = &dummy;
    tmpadp[13] = &(dmd->auxr[3]);	/* 13: V_AUXR_R3 */
    tmpadp[14] = &(dmd->auxl[3]);	/* 14: V_AUXR_L3 */
    tmpadp[15] = &(dcd->snd[2]);	/* 15: V_AUXS2 */
    tmpadp[16] = &(dcd->low);		/* 16: V_EQL */
    tmpadp[17] = &dummy;
    tmpadp[18] = &dummy;
    tmpadp[19] = &(dmd->auxr[2]);	/* 19: V_AUXR_R2 */
    tmpadp[20] = &(dmd->auxl[2]);	/* 20: V_AUXR_L2 */
    tmpadp[21] = &(dcd->snd[0]);	/* 21: V_AUXS0 */
    tmpadp[22] = &(dcd->hi);		/* 22: V_EQH */
    tmpadp[23] = &dummy;
}

void
setaddcp(int ch)
{
    /*  0: V_MAIN_L /  1: V_AUXR_R1 /  2: V_AUXR_L1 */
    addcp[ 3] = &(chdest[ch]->snd[1]);		/*  3: V_AUXS1 */
    adflg[ 3] = &(chdest[ch]->sflg);
    addcp[ 4] = &(chdest[ch]->mid);		/*  4: V_EQM */
    adflg[ 4] = &(chdest[ch]->tflg);
    addcp[ 5] = &(chdest[ch]->vol);		/*  5: V_CHMAIN */
    adflg[ 5] = &(chdest[ch]->vflg);
    /*  6: V_MAIN_R /  7: V_AUXR_R0 /  8: V_AUXR_L0 */
    addcp[ 9] = &(chdest[ch]->snd[3]);		/*  9: V_AUXS3 */
    adflg[ 9] = &(chdest[ch]->sflg);
    addcp[10] = &(chdest[ch]->pan);		/* 10: V_PAN */
    adflg[10] = &(chdest[ch]->tflg);
    /* 11: none / 12: none / 13: V_AUXR_R3 / 14: V_AUXR_L3 */
    addcp[15] = &(chdest[ch]->snd[2]);		/* 15: V_AUXS2 */
    adflg[15] = &(chdest[ch]->sflg);
    addcp[16] = &(chdest[ch]->low);		/* 16: V_EQL */
    adflg[16] = &(chdest[ch]->tflg);
    /* 17: none / 18: none / 19: V_AUXR_R2 / 20: V_AUXR_L2 */
    addcp[21] = &(chdest[ch]->snd[0]);		/* 21: V_AUXS0 */
    adflg[21] = &(chdest[ch]->sflg);
    addcp[22] = &(chdest[ch]->hi);		/* 22: V_EQH */
    adflg[22] = &(chdest[ch]->tflg);
    /* 23: none */
}

void
setaddmp()
{
    addcp[ 0] = &(mndest->mainl);		/*  0: V_MAIN_L */
    adflg[ 0] = &(mndest->mnflg);
    addcp[ 1] = &(mndest->auxr[1]);	/*  1: V_AUXR_R1 */
    adflg[ 1] = &(mndest->arflg);
    addcp[ 2] = &(mndest->auxl[1]);	/*  2: V_AUXR_L1 */
    adflg[ 2] = &(mndest->alflg);
    /*  3: V_AUXS1 /  4: V_EQM /  5: V_CHMAIN */
    addcp[ 6] = &(mndest->mainr);	/*  6: V_MAIN_R */
    adflg[ 6] = &(mndest->mnflg);
    addcp[ 7] = &(mndest->auxr[0]);	/*  7: V_AUXR_R0 */
    adflg[ 7] = &(mndest->arflg);
    addcp[ 8] = &(mndest->auxl[0]);	/*  8: V_AUXR_L0 */
    adflg[ 8] = &(mndest->alflg);
    /*  9: V_AUXS3 / 10: V_PAN */
    addcp[11] = &dummy;  adflg[11] = &dummy;
    addcp[12] = &dummy;  adflg[12] = &dummy;
    addcp[13] = &(mndest->auxr[3]);	/* 13: V_AUXR_R3 */
    adflg[13] = &(mndest->arflg);
    addcp[14] = &(mndest->auxl[3]);	/* 14: V_AUXR_L3 */
    adflg[14] = &(mndest->alflg);
    /* 15: V_AUXS2 / 16: V_EQL */
    addcp[17] = &dummy;  adflg[17] = &dummy;
    addcp[18] = &dummy;  adflg[18] = &dummy;
    addcp[19] = &(mndest->auxr[2]);	/* 19: V_AUXR_R2 */
    adflg[19] = &(mndest->arflg);
    addcp[20] = &(mndest->auxl[2]);	/* 20: V_AUXR_L2 */
    adflg[20] = &(mndest->alflg);
    /* 21: V_AUXS0 / 22: V_EQH / 23: none */
    addcp[23] = &dummy;  adflg[23] = &dummy;
}

/************************************************************************
 *    AD/DAϊ̏                                               *
 *    AD0`5 ON, XL[h0`3̕ϊJnAϊI荞ݖ   *
 ************************************************************************/
void
addaInit()
{
    int		i, j;

    /**** f[^|C^̏ ****/
    for(i=0; i<16; i++) {
        chdest[i] = getChDataPtr(i);
    }
    mndest = getMnDataPtr();
    
    /**** ADf[^̏ ****/
    for(i=0; i<6; i++) {
	for(j=0; j<4; j++) {
	    adcr[i][j] = 0;		/* ̓f[^NA */
	    ad1p[i][j] = 0;		/* tB^obt@NA */
	    ad2p[i][j] = 0;		/* tB^obt@NA */
	    ad3p[i][j] = 0;		/* tB^obt@NA */
            adfc[i][j] = 0;
            d1p[i][j]  = 0;
            d2p[i][j]  = 0;
            h1c[i][j]  = 0;
	}
    }
    cntrst = 0;
    addset = 0;
    addc = 0;
    a = 1;
    b = 2;
    c = 3;
    d = 3;

    /**** AiOXCb` ****/
    subaMask = 0x01;
    mainaMask = 0x10;

    /**** DAϊ평 ****/
    DASTCR = 0xFE;			/* DAX^oCRg[ */
    DACR   = 0xFF;			/* DARg[WX^ */

    DADR0 = 0x00;			/* DAf[^WX^ */
    DADR1 = 0x00;

    /**** ADϊ평 ****/
    ADCR  = 0x00;			/* gK͋֎~ */
    ADCSR = 0x33;			/* XL[h0`3Jn */
    aswc = 0;				/* AiOXCb`pJE^ */
    admode = 0;				/* ADϊԃZbg */
}

UCHAR
adfilter(UCHAR now, UCHAR i, UCHAR j)
{
    UCHAR	data;

    now = now >> 1;
    data = (now*a + ad1p[i][j]*b + ad2p[i][j]*c + ad3p[i][j]*d) / (a+b+c+d);
    ad3p[i][j] = ad2p[i][j];
    ad2p[i][j] = ad1p[i][j];
    ad1p[i][j] = now;
    return(data);
}

UCHAR
adaverage(UCHAR data, UCHAR i, UCHAR j)
{
    UCHAR	rtn;
    
    if (d1p[i][j] == d2p[i][j])	rtn = d1p[i][j];
    else			rtn = data;

    d2p[i][j] = d1p[i][j];
    d1p[i][j] = data;

    return(rtn);
}

UCHAR
adhys(UCHAR now, UCHAR i, UCHAR j)
{
    UCHAR	result;
    UCHAR	sub, data;

    result = now;		/* l */
    data = adcr[i][j];		/* Ol */
    
    if (result > data)		sub = result - data;
    else			sub = data - result;
    if (sub == 1) {
	if (h1c[i][j] < 10) {
	    h1c[i][j] = h1c[i][j] + 1;
	    result = data;
	} else {
	    h1c[i][j] = 0;
	}
    } else {
	h1c[i][j] = 0;
    }
    
    return(result);
}

int
setaddata(UCHAR src, UCHAR num, int ch)
{
    int		eq, rtn;

    *tmpadp[num] = src;			/* \pf[^̕ۑ */
    if ((admc[num] & addset) == 0)    return(0);
    /* 4(middle), 10(pan), 16(low), 22(high) */
    rtn = 0;
    switch(num) {
    case  4:    eq = EQMID;   tone(ch, eq, src);  rtn = 1;	break;
    case 10:    eq = PANPOD;  tone(ch, eq, src);  rtn = 1;	break;
    case 16:    eq = EQLOW;   tone(ch, eq, src);  rtn = 1;	break;
    case 22:    eq = EQHIGH;  tone(ch, eq, src);  rtn = 1;	break;
    case  3:    auxsend(ch, 0x01, src);           rtn = 1;      break;
    case  9:    auxsend(ch, 0x03, src);           rtn = 1;      break;
    case 15:    auxsend(ch, 0x02, src);           rtn = 1;      break;
    case 21:    auxsend(ch, 0x00, src);           rtn = 1;      break;
    case  2:    auxrtn(1, LCH, src);              rtn = 1;      break;
    case  8:    auxrtn(0, LCH, src);              rtn = 1;      break;
    case 14:    auxrtn(3, LCH, src);              rtn = 1;      break;
    case 20:    auxrtn(2, LCH, src);              rtn = 1;      break;
    case  1:    auxrtn(1, RCH, src);              rtn = 1;      break;
    case  7:    auxrtn(0, RCH, src);              rtn = 1;      break;
    case 13:    auxrtn(3, RCH, src);              rtn = 1;      break;
    case 19:    auxrtn(2, RCH, src);              rtn = 1;      break;
    case  0:    mainvolume(LCH, src);             rtn = 1;      break;
    case  6:    mainvolume(RCH, src);             rtn = 1;      break;
    }
    if (rtn)    return(rtn);

    /**** volume setting ****/
    if (*addcp[num] != src) {
        AFLAGON(*adflg[num]);
        *addcp[num] = src;
    }
    return(1);
}
    
/************************************************************************
 *    ADϊ͏                                                    *
 *    ADf[^ǂݍ݁AtB^O(SLtB^)  *
 *    sBǂݍADf[^͏8bitB                                *
 ************************************************************************/
void
adinput(int ch)
{
    UCHAR	*ptr, data;
    int		i;

    /**** ADϊl̓ǂݍ ****/
    asmWriteByte((UCHAR *)PADCSR, 0x13);	/* ADϊ~ */
    ptr = (UCHAR *)PADDRA;
    if (admode == 0) {
        /**** ADf[^ ****/
	for (i=0; i<4; i++) {			/* tB^Z */
            /* adcr[i][aswc] = *ptr >> 1; */
            data = adfilter(*ptr, (UCHAR)i, aswc);
            data = adaverage(data, (UCHAR)i, aswc);
            adcr[i][aswc] = adhys(data, (UCHAR)i, aswc);
            setaddata(adcr[i][aswc], addc, ch);
	    ptr = ptr + 2;			/* |C^CNg */
            addc++;
	}
	asmWriteByte((UCHAR *)PADCSR, 0x37);	/* ch4,5 XL[h */
	admode = 1;
    } else {
        /**** ADf[^ ****/
	for (i=4; i<6; i++) {			/* tB^Z */
            /* adcr[i][aswc] = *ptr; */
            data = adfilter(*ptr, (UCHAR)i, aswc);
            data = adaverage(data, (UCHAR)i, aswc);
            adcr[i][aswc] = adhys(data, (UCHAR)i, aswc);
            setaddata(adcr[i][aswc], addc, ch);
	    ptr = ptr + 2;			/* |C^CNg */
            addc++;
	}

        /**** AiOXCb`̐؂ւADX^[g ****/
	aswc++;
	if (aswc == 4) {
	    mainaMask = 0x10;			/* ؂ւlZbg */
	    subaMask = 0x01;			/* ؂ւlZbg */
	    aswc = 0;				/* chJE^Zbg */
            addc = 0;
	} else {
	    mainaMask = mainaMask << 1;		/* ؂ւlZbg */
	    subaMask = subaMask << 1;		/* ؂ւlZbg */
	}
	asmWriteByte((UCHAR *)0xe4003, ((ledMask&0xf0) | (subaMask&0x0f)));
	asmWriteByte((UCHAR *)0xe4002, ((lampMask&0x0f) | (mainaMask&0xf0)));
	asmWriteByte((UCHAR *)PADCSR, 0x33);	/* ch0-3 XLJn */
	admode = 0;
    }
}

int
adprint()
{
    char	str[8];

    puts("\n\r", stdout);
    /*
    itostr(V_MAIN_L, str, 10);  puts(str, stdout);  putc(' ', stdout);
    itostr(V_MAIN_R, str, 10);  puts(str, stdout);  putc(' ', stdout);
    itostr(V_AUXR_L0, str, 10);  puts(str, stdout);  putc(' ', stdout);
    itostr(V_AUXR_R0, str, 10);  puts(str, stdout);  putc(' ', stdout);
    itostr(V_AUXR_L1, str, 10);  puts(str, stdout);  putc(' ', stdout);
    itostr(V_AUXR_R1, str, 10);  puts(str, stdout);  putc(' ', stdout);
    itostr(V_AUXR_L2, str, 10);  puts(str, stdout);  putc(' ', stdout);
    itostr(V_AUXR_R2, str, 10);  puts(str, stdout);  putc(' ', stdout);
    itostr(V_AUXR_L3, str, 10);  puts(str, stdout);  putc(' ', stdout);
    itostr(V_AUXR_R3, str, 10);  puts(str, stdout);  putc(' ', stdout);
    */
    itostr(V_CHMAIN, str, 10);  puts(str, stdout);  putc(' ', stdout);
    itostr(V_AUXS0, str, 10);  puts(str, stdout);  putc(' ', stdout);
    itostr(V_AUXS1, str, 10);  puts(str, stdout);  putc(' ', stdout);
    itostr(V_AUXS2, str, 10);  puts(str, stdout);  putc(' ', stdout);
    itostr(V_AUXS3, str, 10);  puts(str, stdout);  putc(' ', stdout);
    itostr(V_EQH, str, 10);  puts(str, stdout);  putc(' ', stdout);
    itostr(V_EQM, str, 10);  puts(str, stdout);  putc(' ', stdout);
    itostr(V_EQL, str, 10);  puts(str, stdout);  putc(' ', stdout);
    itostr(V_PAN, str, 10);  puts(str, stdout);  putc(' ', stdout);
    
}

/************************************************************************
 *    ADϊ͒l̕ϊ                                                *
 ************************************************************************/
/*
void
adConvert(ChAttr *cat, MnAttr *mat)
{
    UCHAR	value;

    cat->vol    = V_CHMAIN >> 1;
    cat->pan    = V_PAN >> 2;
    cat->hi     = V_EQH >> 2;
    cat->mid    = V_EQM >> 2;
    cat->low    = V_EQL >> 2;
    cat->snd[0] = V_AUXS0 >> 1;
    cat->snd[1] = V_AUXS1 >> 1;
    cat->snd[2] = V_AUXS2 >> 1;
    cat->snd[3] = V_AUXS3 >> 1;

    mat->auxl[0] = V_AUXR_L0 >> 1;
    mat->auxr[0] = V_AUXR_R0 >> 1;
    mat->auxl[1] = V_AUXR_L1 >> 1;
    mat->auxr[1] = V_AUXR_R1 >> 1;
    mat->auxl[2] = V_AUXR_L2 >> 1;
    mat->auxr[2] = V_AUXR_R2 >> 1;
    mat->auxl[3] = V_AUXR_L3 >> 1;
    mat->auxr[3] = V_AUXR_R3 >> 1;
    
    mat->mainl = V_MAIN_L >> 1;
    mat->mainr = V_MAIN_R >> 1;
}
*/
/************************************************************************
 *    LCD RgXg                                              *
 ************************************************************************/
void
setContrast(UCHAR d)
{
    if (d > 120)	d = 120;

    cntrst = d;
    d = 120 - d;
    DADR1 = d;
}

UCHAR
getContrast()	
{
    return cntrst;
}
    
/* end of file */
