/************************************************************************
 ************************************************************************
 ****                                                                ****
 ****    pccom.c : PC ʐM                                       ****
 ****                                                                ****
 ************************************************************************
 ************************************************************************/
#include	"include/generic.h"
#include	"include/config.h"
#include	"include/h8_3048.h"
#include	"include/sys.h"

/**** ch f[^MR}h ****/
#define	CMD_CHDSENDREQ	(0x10)
#define CMD_CHDSEND	(0x11)
#define CMD_CHDRCVREQ	(0x12)
#define	CMD_CHDRCV	(0x13)
#define	CMD_CHADSEND	(0x14)
#define CMD_CHVRCV      (0x15)
#define CMD_CHAS1RCV    (0x16)
#define CMD_CHAS2RCV    (0x17)
#define CMD_CHAS3RCV    (0x18)
#define CMD_CHAS4RCV    (0x19)
#define CMD_CHHIRCV     (0x1a)
#define CMD_CHMDRCV     (0x1b)
#define CMD_CHLWRCV     (0x1c)
#define CMD_CHPANRCV    (0x1d)
#define CMD_CHAREQ	(0x1f)

/**** main f[^MR}h ****/
#define	CMD_MNDSENDREQ	(0x20)
#define CMD_MNDSEND	(0x21)
#define CMD_MNDRCVREQ	(0x22)
#define	CMD_MNDRCV	(0x23)
#define CMD_MVOLRCV     (0x24)
#define CMD_A1RRCV      (0x25)
#define CMD_A2RRCV      (0x26)
#define CMD_A3RRCV      (0x27)
#define CMD_A4RRCV      (0x28)

/**** VXeݒ֘AMR}h ****/
#define	CMD_NONE	(0x00)
#define	CMD_PGLOAD	(0x30)
#define	CMD_PGSAVE	(0x31)
#define	CMD_DPMODE	(0x32)
#define CMD_FPLOCK      (0x33)		/* Front Panel Main Lock */
#define CMD_PGMREQ	(0x34)
#define CMD_PGMSTAT	(0x35)
#define CMD_STAMD	(0x36)
#define CMD_STAMDSEND	(0x37)
#define CMD_STAMDREQ	(0x38)
#define CMD_COMSEND	(0x81)
#define CMD_COMRCV	(0x82)
#define CMD_COMREQ	(0x83)
#define CMD_SYSSEND	(0x84)
#define CMD_SYSRCV	(0x85)
#define CMD_SYSREQ	(0x86)
#define CMD_PINGSTOP	(0xa0)
#define CMD_PINGSTART	(0xa1)
#define	CMD_PINGOUT	(0xa5)
#define	CMD_PINGIN	(0xaa)

/**** IvVw ****/
#define CMD_DSPCH	(0x10)
#define CMD_DSPMN       (0x20)

extern	int	pgmInit(int);
extern	int	pgmIncDec(int);
extern	int	savePgmData(int, ChAttr *, MnAttr *, char *);
extern	int	loadPgmData(ChAttr *, MnAttr *);
extern	int	falshProgram(UCHAR *, UCHAR *, ULONG);
extern	int	execSavePgm();
extern	void	waitSecLoop(int);
extern	void	pgmnoWarning();
extern	int	getpgmStrLoop();
extern	void	nstripPstr(char *, int);
extern	void	stripPstr(char *);
extern	int	pstrlen(char *);
extern	int	delStr(char *, int);
extern	void	refleshNameSpace(char *, int);
extern	int	getPushStat(UCHAR);

extern	int	miscInit();
extern	int	execDispInfo();
extern	int	execSysEnv();
extern	void	dispSysEnv(int);
extern	int	editSysEnv(int, int);
extern	void	dispBeepOnOff();
extern	int	editBeepOnOff(int);
extern	void	dispBeepFreq();
extern	int	editBeepFreq(int);
extern	void	dispBeepMsec();
extern	int	editBeepMsec(int);
extern	void	dispContrast();
extern	int	editContrast(int, UCHAR);
extern	void	saveSysEnv();

extern	int	execComEnv();
extern	int	comEnvLoop();
extern	void	dispCursor(int);
extern	void	incDecModeData(int, int);
extern	void	incDecBps(int, int);
extern	void	incDecDlen(int, int);
extern	void	incDecStop(int, int);
extern	void	incDecPrty(int, int);
extern	void	dispBaud();
extern	void	dispDataLen();
extern	void	dispStopLen();
extern	void	dispParity();
extern	void	saveComEnv();

extern	void	BeepEnable();
extern	void	BeepDisable();
extern	UINT	getBeepLen();
extern	void	Beep(int);
extern	void	setBeepLength(UINT);
extern	void	sysParamInit();
extern	void	sysParamRec();

extern	int	sciSetBaud(int, int);
extern	UINT	sciGetBaud(int);
extern	int	sciSetMode(int, int, int, int);
extern	int	getSciDataLen(int);
extern	int	getSciParity(int);
extern	int	getSciStopBit(int);
extern	UCHAR	getStartMode();
extern	void	setStartMode(UCHAR);

extern	void	mnseton();
extern	void	mnsetoff();
extern	void	chseton();
extern	void	chsetoff();

void	pcomInit();
int	pccom();
void	cmd_pingin(UCHAR *);
void	cmd_chdsend(UCHAR *);
void	cmd_chasend(UCHAR *);
void	cmd_chdrcv(UCHAR *);
void	cmd_chadsend(UCHAR *);
void	cmd_chvrcv(UCHAR *);
void	cmd_chas1rcv(UCHAR *);
void	cmd_chas2rcv(UCHAR *);
void	cmd_chas3rcv(UCHAR *);
void	cmd_chas4rcv(UCHAR *);
void	cmd_chhircv(UCHAR *);
void	cmd_chmdrcv(UCHAR *);
void	cmd_chlwrcv(UCHAR *);
void	cmd_panrcv(UCHAR *);
void	cmd_mndsend(UCHAR *);
void	cmd_mndrcv(UCHAR *);
void	cmd_mvolrcv(UCHAR *);
void	cmd_ar1rcv(UCHAR *);
void	cmd_ar2rcv(UCHAR *);
void	cmd_ar3rcv(UCHAR *);
void	cmd_ar4rcv(UCHAR *);
void	cmd_pgmreq(UCHAR *);
void	cmd_pgload(UCHAR *);
void	cmd_pgsave(UCHAR *);
void	cmd_dpmode(UCHAR *);
void	cmd_fplock(UCHAR *);
void	cmd_comsave(UCHAR *);
void	cmd_comreq(UCHAR *);
void	cmd_stamode(UCHAR *);
void	cmd_stareq(UCHAR *);
void	cmd_syssave(UCHAR *);
void	cmd_sysreq(UCHAR *);

void	sendChDataToPC(int);
void	setChData(UCHAR *);
void	sendMnDataToPC();
void	setMnData(UCHAR *);

extern  int	rxi1p, rxo1p;
extern  ChAttr  *cd;		/* o͗p`lf[^̃|C^ */
extern  MnAttr  *md;		/* o͗pCf[^̃|C^ */
extern  MnAttr  mnd;
/* extern  ChAttr  *chd; */
UCHAR	pcstat;
UCHAR	mcnt;
int     dsize;
int	remain;
int	sndch;
UCHAR	cbuf[35];
UCHAR   sndbuf[20];
int	debug;
int	ccnt;
void	(*f)();			/* M֐ւ̃|C^ */

void
ctohexstr(char *dest, char *src)
{
    unsigned char	c;
    
    c = (src[0] & 0xf0) >> 4;
    if (c <=0x9)			dest[0] = c + '0';
    else if ((c >= 0xa) && (c <=0xf))   dest[0] = c - 0x0a + 'a';
    c = src[0] & 0x0f;
    if (c <=0x9)			dest[1] = c + '0';
    else if ((c >= 0xa) && (c <=0xf))   dest[1] = c - 0x0a + 'a';
    dest[2] = '\0';
}

void
pcomInit()
{
    pcstat = CMD_NONE;			/* ʐM */
    mcnt = 0;				/* 512msec JE^ */
    remain = 0;				/* R}hcoCg */
    dsize = 0;				/* R}hTCY */
    sndch = 0;                          /* Mchf[^ԍ */
    debug = 0;
    ccnt = 0;				/* ڑpJE^ */
    f = NULL;
}

int
pccom()
{
    int		code, len;
    char	buf[4];

    /* 512msec ȓɏɑM */
    len = 0;
    disableIRQ();
    len = gets(cbuf, 25, stdin);
    enableIRQ();
    if (len == 0)   return(0);
    if (pcstat == CMD_NONE) {
        code = cbuf[0] & 0xf0;
        ccnt = 0;
        if (code == 0x10) {
            switch(cbuf[0]) {
            case 0x10:		/* PC->Mixer CHf[^v */
                putc('C', stderr);
                pcstat=CMD_CHDSEND;    dsize=1;    f=cmd_chdsend;    break;
            case 0x13:		/* PC->Mixer CHf[^M */
                pcstat=CMD_CHDRCV;     dsize=12;   f=cmd_chdrcv;     break;
            case 0x15:		/* PC->Mixer CHf[^M(vol/mute/opt) */
                pcstat=CMD_CHVRCV;     dsize=3;    f=cmd_chvrcv;     break;
            case 0x16:		/* PC->Mixer CHf[^M(aux1) */
                pcstat=CMD_CHAS1RCV;   dsize=3;    f=cmd_chas1rcv;   break;
            case 0x17:		/* PC->Mixer CHf[^M(aux2) */
                pcstat=CMD_CHAS2RCV;   dsize=3;    f=cmd_chas2rcv;   break;
            case 0x18:		/* PC->Mixer CHf[^M(aux3) */
                pcstat=CMD_CHAS3RCV;   dsize=3;    f=cmd_chas3rcv;   break;
            case 0x19:		/* PC->Mixer CHf[^M(aux4) */
                pcstat=CMD_CHAS4RCV;   dsize=3;    f=cmd_chas4rcv;   break;
            case 0x1a:		/* PC->Mixer CHf[^M(high) */
                pcstat=CMD_CHHIRCV;    dsize=2;    f=cmd_chhircv;    break;
            case 0x1b:		/* PC->Mixer CHf[^M(mid) */
                pcstat=CMD_CHMDRCV;    dsize=2;    f=cmd_chmdrcv;    break;
            case 0x1c:		/* PC->Mixer CHf[^M(low) */
                pcstat=CMD_CHLWRCV;    dsize=2;    f=cmd_chlwrcv;    break;
            case 0x1d:		/* PC->Mixer CHf[^M(pan) */
                pcstat=CMD_CHPANRCV;   dsize=2;    f=cmd_panrcv;     break;
            }
        } else if (code == 0x20) {
            switch(cbuf[0]) {
            case 0x20:		/* PC->Mixer Mainf[^v */
                pcstat=CMD_MNDSEND;    dsize=0;    f=cmd_mndsend;    break;
            case 0x23:		/* PC->Mixer MainSf[^M */
                pcstat=CMD_MNDRCV;     dsize=17;   f=cmd_mndrcv;     break;
            case 0x24:		/* PC->Mixer Main Volf[^M */
                pcstat=CMD_MVOLRCV;    dsize=6;    f=cmd_mvolrcv;    break;
            case 0x25:		/* PC->Mixer Aux1Rtn f[^M */
                pcstat=CMD_A1RRCV;     dsize=5;    f=cmd_ar1rcv;     break;
            case 0x26:		/* PC->Mixer Aux2Rtn f[^M */
                pcstat=CMD_A2RRCV;     dsize=5;    f=cmd_ar2rcv;     break;
            case 0x27:		/* PC->Mixer Aux3Rtn f[^M */
                pcstat=CMD_A3RRCV;     dsize=5;    f=cmd_ar3rcv;     break;
            case 0x28:		/* PC->Mixer Aux4Rtn f[^M */
                pcstat=CMD_A4RRCV;     dsize=5;    f=cmd_ar4rcv;     break;
            }
        } else if (code == 0x30) {
            switch(cbuf[0]) {
            case 0x30:		/* PC->Mixer Progoram Load */
                pcstat=CMD_PGLOAD;     dsize=1;    f=cmd_pgload;     break;
            case 0x31:		/* PC->Mixer Program Save */
                pcstat=CMD_PGSAVE;     dsize=24;   f=cmd_pgsave;     break;
            case 0x32:		/* PC->Mixer Display mode */
                pcstat=CMD_DPMODE;     dsize=2;    f=cmd_dpmode;     break;
            case 0x33:		/* PC->Mixer Front panel Lock */
                pcstat=CMD_FPLOCK;     dsize=2;    f=cmd_fplock;     break;
            case 0x34:		/* PC->Mixer Program ԍ₢킹 */
                pcstat=CMD_PGMREQ;     dsize=0;    f=cmd_pgmreq;     break;
            case 0x36:		/* PC->Mixer N[hݒ */
                pcstat=CMD_STAMD;      dsize=1;    f=cmd_stamode;    break;
            case 0x38:		/* PC->Mixer N[h₢킹 */
                pcstat=CMD_STAMDREQ;   dsize=0;    f=cmd_stareq;     break;
            }
        } else {
            switch(cbuf[0]) {
            case 0x82:		/* PC->Mixer COM|[gݒ */
                pcstat=CMD_COMRCV;     dsize=20;   f=cmd_comsave;    break;
            case 0x83:		/* PC->Mixer COM|[g₢킹 */
                pcstat=CMD_COMREQ;     dsize=0;    f=cmd_comreq;     break;
            case 0x85:		/* PC->Mixer Systemݒ */
                pcstat=CMD_SYSRCV;     dsize=6;    f=cmd_syssave;    break;
            case 0x86:		/* PC->Mixer Systemݒ₢킹 */
                pcstat=CMD_SYSREQ;     dsize=0;    f=cmd_sysreq;     break;
            case 0xaa:		/* PC->Mixer Ping */
                pcstat=CMD_PINGIN;     dsize=0;    f=cmd_pingin;     break;
            default:		/* None */
                pcstat=CMD_NONE;       dsize=0;    f=NULL;           break;
            }
        }
        remain=dsize;
        len--;
    } else {
        ccnt++;
    }
    if (remain <= len) {
        remain = 0;
    } else {
        remain = remain - len;
        if (remain) return(0);
    }
    putc('F', stderr);        
    if (f != NULL) {
        (*f)(cbuf);		/* M */
        f = NULL;
    }
    len = 0;
    pcstat = CMD_NONE;
    dsize = 0;
    remain = 0;
    return(1);
}

void
cmd_pingin(UCHAR *cbuf)
{
    putc(CMD_PINGOUT, stdout);
    dsize = 0;
    pcstat = CMD_NONE;
}

void
cmd_chdsend(UCHAR *cbuf)
{
    int		ch;

    ch = (int)cbuf[0];
    sendChDataToPC(ch);
    mcnt = 0;
    dsize = 0;
    pcstat = CMD_NONE;
}

void
cmd_chasend(UCHAR *cbuf)
{
    int		i;
    
    for(i=0; i<16; i++)
        sendChDataToPC(i);
    mcnt = 0;
    dsize = 0;
    pcstat = CMD_NONE;
}

void
cmd_chdrcv(UCHAR *cbuf)
{
    setChData(&cbuf[1]);
    dsize = 0;
    pcstat = CMD_NONE;
}

void
cmd_chvrcv(UCHAR *buf)
{
    int		ch;
    
    ch = (unsigned int)buf[0];
    disableIRQ();
    if (cd[ch].vol != buf[1]) {
        cd[ch].vol = buf[1];
        AFLAGON(cd[ch].vflg);
    }
    if (cd[ch].mut != buf[2]) {
        cd[ch].mut = buf[2];
        AFLAGON(cd[ch].vflg);
    }
    enableIRQ();
    pcstat = CMD_NONE;
}

void
cmd_chas1rcv(UCHAR *buf)
{
    int		ch;
    UCHAR	sw;

    ch = (unsigned int)buf[0];
    disableIRQ();
    if (cd[ch].snd[0] != buf[1]) {
        cd[ch].snd[0] = buf[1];
        cd[ch].sflg |= 0x11;
    }
    if (buf[2] == 0) {
        if ((cd[ch].sndsw & 0x01) == 0) {
            cd[ch].sndsw |= 0x01;
            cd[ch].sflg |= 0x11;
        }
    } else {
        if (cd[ch].sndsw & 0x01) {
            cd[ch].sndsw &= 0xfe;
            cd[ch].sflg |= 0x11;
        }
    }
    
    enableIRQ();
    pcstat = CMD_NONE;
}

void
cmd_chas2rcv(UCHAR *buf)
{
    int		ch;
    UCHAR	sw;

    ch = (unsigned int)buf[0];
    disableIRQ();
    if (cd[ch].snd[1] != buf[1]) {
        cd[ch].snd[1] = buf[1];
        cd[ch].sflg |= 0x22;
    }
    if (buf[2] == 0) {
        if ((cd[ch].sndsw & 0x02) == 0) {
            cd[ch].sndsw |= 0x02;
            cd[ch].sflg |= 0x22;
        }
    } else {
        if (cd[ch].sndsw & 0x02) {
            cd[ch].sndsw &= 0xfd;
            cd[ch].sflg |= 0x22;
        }
    }
    enableIRQ();
    pcstat = CMD_NONE;
}

void
cmd_chas3rcv(UCHAR *buf)
{
    int		ch;
    UCHAR	sw;

    ch = (unsigned int)buf[0];
    if (buf[2] == 0)    sw = ON;
    else                sw = OFF;
    disableIRQ();
    if (cd[ch].snd[2] != buf[1]) {
        cd[ch].snd[2] = buf[1];
        cd[ch].sflg |= 0x44;
    }
    if (buf[2] == 0) {
        if ((cd[ch].sndsw & 0x04) == 0) {
            cd[ch].sndsw |= 0x04;
            cd[ch].sflg |= 0x44;
        }
    } else {
        if (cd[ch].sndsw & 0x04) {
            cd[ch].sndsw &= 0xfb;
            cd[ch].sflg |= 0x44;
        }
    }
    enableIRQ();
    pcstat = CMD_NONE;
}

void
cmd_chas4rcv(UCHAR *buf)
{
    int		ch;
    UCHAR	sw;

    ch = (unsigned int)buf[0];
    if (buf[2] == 0)    sw = ON;
    else                sw = OFF;
    disableIRQ();
    if (cd[ch].snd[3] != buf[1]) {
        cd[ch].snd[3] = buf[1];
        cd[ch].sflg |= 0x88;
    }
    if (buf[2] == 0) {
        if ((cd[ch].sndsw & 0x08) == 0) {
            cd[ch].sndsw |= 0x08;
            cd[ch].sflg |= 0x88;
        }
    } else {
        if (cd[ch].sndsw & 0x08) {
            cd[ch].sndsw &= 0xf7;
            cd[ch].sflg |= 0x88;
        }
    }
    enableIRQ();
    pcstat = CMD_NONE;
}

void
cmd_chhircv(UCHAR *buf)
{
    int		ch, vl;

    ch = (unsigned int)buf[0];
    vl = (unsigned int)buf[1];
    tone(ch, EQHIGH, vl);
    pcstat = CMD_NONE;
}

void
cmd_chmdrcv(UCHAR *buf)
{
    int		ch, vl;

    ch = (unsigned int)buf[0];
    vl = (unsigned int)buf[1];
    tone(ch, EQMID, vl);
    pcstat = CMD_NONE;
}

void
cmd_chlwrcv(UCHAR *buf)
{
    int		ch, vl;

    ch = (unsigned int)buf[0];
    vl = (unsigned int)buf[1];
    tone(ch, EQLOW, vl);
    pcstat = CMD_NONE;
}

void
cmd_panrcv(UCHAR *buf)
{
    int		ch, vl;

    ch = (unsigned int)buf[0];
    vl = (unsigned int)buf[1];
    tone(ch, PANPOD, vl);
    pcstat = CMD_NONE;
}

void
cmd_mndsend(UCHAR *buf)
{
    sendMnDataToPC();
    mcnt = 0;
    dsize = 0;
    pcstat = CMD_NONE;
}

void
cmd_mndrcv(UCHAR *cbuf)
{
    setMnData(&cbuf[1]);
    setdpmode(DISP_MAIN, DMN_MAIN, -1);
    dsize = 0;
    pcstat = CMD_NONE;
}

void
cmd_mvolrcv(UCHAR *buf)
{
    disableIRQ();
    if ((mnd.mainl) != buf[1]) {
        mnd.mainl = buf[1];
        mnd.mnflg |= 0x11;
    }
    if ((mnd.mainr) != buf[2]) {
        mnd.mainr = buf[2];
        mnd.mnflg |= 0x22;
    }
    if ((mnd.mnmut & 0x01) != (buf[3] & 0x01)) {
        mnd.mnflg |= 0x11;
    }
    if ((mnd.mnmut & 0x02) != (buf[3] & 0x02)) {
        mnd.mnflg |= 0x22;
    }
    mnd.mnmut = buf[3];
    enableIRQ();
    if (buf[5] == CMD_DSPCH) {
        setdpmode(DISP_MAIN, DMN_MAIN, -1);
    } else if (buf[5] == CMD_DSPMN) {
        setdpmode(DISP_MAIN, DMN_MAIN, -1);
    }
    pcstat = CMD_NONE;
}

void
cmd_ar1rcv(UCHAR *buf)
{
    disableIRQ();
    if ((md->auxl[0]) != buf[1]) {
        md->auxl[0] = buf[1];
        md->alflg |= 0x11;
    }
    if ((md->auxr[0]) != buf[2]) {
        md->auxr[0] = buf[2];
        md->arflg |= 0x11;
    }
    enableIRQ();
    if (buf[3] == CMD_DSPCH) {
        setdpmode(DISP_MAIN, DMN_MAIN, -1);
    } else if (buf[3] == CMD_DSPMN) {
        setdpmode(DISP_MAIN, DMN_MAIN, -1);
    }
    pcstat = CMD_NONE;
}

void
cmd_ar2rcv(UCHAR *buf)
{
    disableIRQ();
    if ((md->auxl[1]) != buf[1]) {
        md->auxl[1] = buf[1];
        md->alflg |= 0x22;
    }
    if ((md->auxr[1]) != buf[2]) {
        md->auxr[1] = buf[2];
        md->arflg |= 0x22;
    }
    enableIRQ();
    if (buf[3] == CMD_DSPCH) {
        setdpmode(DISP_MAIN, DMN_MAIN, -1);
    } else if (buf[3] == CMD_DSPMN) {
        setdpmode(DISP_MAIN, DMN_MAIN, -1);
    }
    pcstat = CMD_NONE;
}

void
cmd_ar3rcv(UCHAR *buf)
{
    disableIRQ();
    if ((md->auxl[2]) != buf[1]) {
        md->auxl[2] = buf[1];
        md->alflg |= 0x44;
    }
    if ((md->auxr[2]) != buf[2]) {
        md->auxr[2] = buf[2];
        md->arflg |= 0x44;
    }
    enableIRQ();
    if (buf[3] == CMD_DSPCH) {
        setdpmode(DISP_MAIN, DMN_MAIN, -1);
    } else if (buf[3] == CMD_DSPMN) {
        setdpmode(DISP_MAIN, DMN_MAIN, -1);
    }
    pcstat = CMD_NONE;
}

void
cmd_ar4rcv(UCHAR *buf)
{
    disableIRQ();
    if ((md->auxl[3]) != buf[1]) {
        md->auxl[3] = buf[1];
        md->alflg |= 0x88;
    }
    if ((md->auxr[3]) != buf[2]) {
        md->auxr[3] = buf[2];
        md->arflg |= 0x88;
    }
    enableIRQ();
    if (buf[3] == CMD_DSPCH) {
        setdpmode(DISP_MAIN, DMN_MAIN, -1);
    } else if (buf[3] == CMD_DSPMN) {
        setdpmode(DISP_MAIN, DMN_MAIN, -1);
    }
    pcstat = CMD_NONE;
}

void
cmd_pgmreq(UCHAR *cbuf)
{
    int		pno;

    sndbuf[0] = CMD_PGMSTAT;
    pno = (UCHAR)getCurPgmNo();
    sndbuf[1] = (UCHAR)pno;
    if (queryDefPgm(pno))	sndbuf[2] = 1;
    else			sndbuf[2] = 0;
    putn(sndbuf, 3, stdout);
    pcstat = CMD_NONE;
    mcnt = 0;
    dsize = 0;
}

void
cmd_pgload(UCHAR *cbuf)
{
    int		pgmno;
    
    pgmno = (int)cbuf[1];
    loadPgm(pgmno);
    pcstat = CMD_NONE;
}

void
cmd_pgsave(UCHAR *cbuf)
{
    int		i, year;
    char	mon, day, hur, min, sec, name[18];
    UCHAR	pno, def;
    
    pno  = (int)cbuf[1];
    def  = (int)cbuf[2];
    year = (UINT)cbuf[3] + 2000;
    mon  = cbuf[4];
    day  = cbuf[5];
    hur  = cbuf[6];
    min  = cbuf[7];
    sec  = cbuf[8];
    for(i=0; i<16; i++)  name[i] = cbuf[9+i];
    pgmSetNo(pno);
    setPgmDate(year, mon, day, hur, min, sec);
    savePgmFromPC(def, name);
    resetDisp();
    dsize = 0;
    pcstat = CMD_NONE;
}

void
cmd_dpmode(UCHAR *cbuf)
{
    int		ch, md;
    
    md = (int)cbuf[1];
    ch = (int)cbuf[2];
    if (md == DISP_MAIN) {
        setdpmode(DISP_MAIN, 0, ch);
    } else {
        setdpmode(DISP_CH, 0, ch);
    }
    dsize = 0;
    pcstat = CMD_NONE;
}
    
void
cmd_fplock(UCHAR *cbuf)
{
    dsize=0;
    if (cbuf[0] == 0) {
	mnseton();
    } else {
        mnsetoff();
    }
    if (cbuf[1] == 0) {
	chseton();
    } else {
        chsetoff();
    }
    pcstat = CMD_NONE;
    dsize = 0;
}

void
cmd_comsave(UCHAR *cbuf)
{
    int		data, i;

    for(i=0; i<4; i++) {
        data  = ((UINT)cbuf[1+5*i] << 8) | ((UINT)cbuf[2+5*i]);
        if (data != 0)	setComEnv(i, SCI_BPS, data);
        data = (UINT)cbuf[3+5*i];
        if (data >= 0)	setComEnv(i, SCI_STOP, data);
        data = (UINT)cbuf[4+5*i];
        if (data >= 0)	setComEnv(i, SCI_DLEN, data);
        data = (UINT)cbuf[5+5*i];
        if (data >= 0)	setComEnv(i, SCI_PRTY, data);
    }
    saveComEnv();
    pcstat = CMD_NONE;
    dsize = 0;
}

void
cmd_comreq(UCHAR *cbuf)
{
    int		data, i;
    
    sndbuf[0] = CMD_COMSEND;
    for(i=0; i<2; i++) {
        data = getSciBaud(i);
        sndbuf[1+5*i] = (UCHAR)(data >> 8);
        sndbuf[2+5*i] = (UCHAR)(data & 0x00ff);
        sndbuf[3+5*i] = (UCHAR)(getSciStopBit(i));
        sndbuf[4+5*i] = (UCHAR)(getSciDataLen(i));
        sndbuf[5+5*i] = (UCHAR)(getSciParity(i));
    }
    for(i=2; i<4; i++) {
        sndbuf[1+5*i] = 0;
        sndbuf[2+5*i] = 0;
        sndbuf[3+5*i] = 0;
        sndbuf[4+5*i] = 0;
        sndbuf[5+5*i] = 0;
    }
    putn(sndbuf, 21, stdout);
    pcstat = CMD_NONE;
    mcnt = 0;
    dsize = 0;
}

void
cmd_stamode(UCHAR *cbuf)
{
    setStartMode(cbuf[1]);
}

void
cmd_stareq(UCHAR *cbuf)
{
    UCHAR	md;
    
    md = getStartMode();
    sndbuf[0] = CMD_STAMDSEND;
    sndbuf[1] = (UCHAR)md;
    putn(sndbuf, 2, stdout);
    mcnt = 0;
    pcstat = CMD_NONE;
    dsize = 0;
}

void
cmd_syssave(UCHAR *cbuf)
{
    int		data;
    UCHAR	byte;
    
    data = (int)cbuf[1];
    if (data)	BeepEnable();
    else	BeepDisable();
    data = ((int)cbuf[2] << 8) | ((int)cbuf[3] & 0x00ff);
    setBeepLength(data);
    data = ((int)cbuf[4] << 8) | ((int)cbuf[5] & 0x00ff);
    setBeepFreq(data);
    byte = cbuf[6];
    setContrast2(byte);
    pcstat = CMD_NONE;
    dsize = 0;
}

void
cmd_sysreq(UCHAR *cbuf)
{
    UINT	data;
    
    sndbuf[0] = CMD_SYSSEND;
    if (getBeepOn())    sndbuf[1] = 1;
    else		sndbuf[1] = 0;
    data = getBeepLen();
    sndbuf[2] = (UCHAR)(data >> 8);
    sndbuf[3] = (UCHAR)(data & 0x00ff);
    data = getBeepFreq();
    sndbuf[4] = (UCHAR)(data >> 8);
    sndbuf[5] = (UCHAR)(data & 0x00ff);
    sndbuf[6] = getContrast();
    putn(sndbuf, 7, stdout);
    mcnt = 0;
    pcstat = CMD_NONE;
    dsize = 0;
}
    
void
sendChDataToPC(int ch)
{
    putc('S', stderr);
    sndbuf[0] = 0x11;		/* command No. */
    sndbuf[1] = (UCHAR)ch;	/* ch ԍ */
    sndbuf[2] = cd[ch].vol;	/* ch volume */
    sndbuf[3] = cd[ch].snd[0];	/* AUX1 Send */
    sndbuf[4] = cd[ch].snd[1];	/* AUX2 Send */
    sndbuf[5] = cd[ch].snd[2];	/* AUX3 Send */
    sndbuf[6] = cd[ch].snd[3];	/* AUX4 Send */
    sndbuf[7] = cd[ch].hi;	/* Tone High */
    sndbuf[8] = cd[ch].mid;	/* Tone Mid */
    sndbuf[9] = cd[ch].low;	/* Tone Low */
    sndbuf[10]= cd[ch].pan;	/* panpod */
    sndbuf[11]= cd[ch].mut;	/* mute */
    sndbuf[12]= cd[ch].sndsw;	/* AUX Send SW */
    putn(sndbuf, 13, stdout);
    mcnt = 0;
}

void
setChData(UCHAR *buf)
{
    int		ch;
    UCHAR	d;

    ch = (int)buf[0];
    if (cd[ch].vol != buf[1]) {
        disableIRQ();
        cd[ch].vol = buf[1];
        AFLAGON(cd[ch].vflg);
        enableIRQ();
    }
    if (cd[ch].snd[0] != buf[2]) {
        disableIRQ();
        cd[ch].snd[0] = buf[2];
        cd[ch].sflg |= 0x11;
        enableIRQ();
    }
    if (cd[ch].snd[1] != buf[3]) {
        disableIRQ();
        cd[ch].snd[1] = buf[3];
        cd[ch].sflg |= 0x22;
        enableIRQ();
    }
    if (cd[ch].snd[2] != buf[4]) {
        disableIRQ();
        cd[ch].snd[2] = buf[4];
        cd[ch].sflg |= 0x44;
        enableIRQ();
    }
    if (cd[ch].snd[3] != buf[5]) {
        disableIRQ();
        cd[ch].snd[3] = buf[5];
        cd[ch].sflg |= 0x88;
        enableIRQ();
    }
    if (cd[ch].hi != buf[6]) {
        disableIRQ();
        cd[ch].hi = buf[6];
        cd[ch].tflg |= 0x44;
        enableIRQ();
    }
    if (cd[ch].mid != buf[7]) {
        disableIRQ();
        cd[ch].mid = buf[7];
        cd[ch].tflg |= 0x22;
        enableIRQ();
    }
    if (cd[ch].low != buf[8]) {
        disableIRQ();
        cd[ch].low = buf[8];
        cd[ch].tflg |= 0x11;
        enableIRQ();
    }
    if (cd[ch].pan != buf[9]) {
        disableIRQ();
        cd[ch].pan = buf[9];
        cd[ch].tflg |= 0x88;
        enableIRQ();
    }
    if (cd[ch].mut != buf[10]) {
        disableIRQ();
        cd[ch].mut = buf[10];
        AFLAGON(cd[ch].vflg);
        enableIRQ();
    }
    if ((cd[ch].sndsw & 0x01) && ((buf[11] & 0x01) == 0)) {
        disableIRQ();
        cd[ch].sndsw &= 0xfe;
        cd[ch].sflg |= 0x11;
        enableIRQ();
    } else if (((cd[ch].sndsw & 0x01) == 0) && (buf[11] & 0x01)) {
        disableIRQ();
        cd[ch].sndsw |= 0x01;
        cd[ch].sflg |= 0x11;
        enableIRQ();
    }
    if ((cd[ch].sndsw & 0x02) && ((buf[11] & 0x02) == 0)) {
        disableIRQ();
        cd[ch].sndsw &= 0xfd;
        cd[ch].sflg |= 0x22;
        enableIRQ();
    } else if (((cd[ch].sndsw & 0x02) == 0) && (buf[11] & 0x02)) {
        disableIRQ();
        cd[ch].sndsw |= 0x02;
        cd[ch].sflg |= 0x22;
        enableIRQ();
    }
    if ((cd[ch].sndsw & 0x04) && ((buf[11] & 0x04) == 0)) {
        disableIRQ();
        cd[ch].sndsw &= ~0x04;
        cd[ch].sflg |= 0x44;
        enableIRQ();
    } else if (((cd[ch].sndsw & 0x04) == 0) && (buf[11] & 0x04)) {
        disableIRQ();
        cd[ch].sndsw |= 0x04;
        cd[ch].sflg |= 0x44;
        enableIRQ();
    }
    if ((cd[ch].sndsw & 0x08) && ((buf[11] & 0x08) == 0)) {
        disableIRQ();
        cd[ch].sndsw &= ~0x08;
        cd[ch].sflg |= 0x88;
        enableIRQ();
    } else if (((cd[ch].sndsw & 0x08) == 0) && (buf[11] & 0x08)) {
        disableIRQ();
        cd[ch].sndsw |= 0x08;
        cd[ch].sflg |= 0x88;
        enableIRQ();
    }
    /* Tone through is not supported */
}

void
sendMnDataToPC()
{
    sndbuf[0] = 0x21;
    sndbuf[1] = 18;
    sndbuf[2] = 0;
    sndbuf[3] = md->mainl;
    sndbuf[4] = md->mainr;
    sndbuf[5] = md->auxl[0];
    sndbuf[6] = md->auxr[0];
    sndbuf[7] = md->auxl[1];
    sndbuf[8] = md->auxr[1];
    sndbuf[9] = md->auxl[2];
    sndbuf[10] = md->auxr[2];
    sndbuf[11] = md->auxl[3];
    sndbuf[12] = md->auxr[3];
    sndbuf[13] = md->phonel;
    sndbuf[14] = md->phoner;
    sndbuf[15] = md->mnmut;
    sndbuf[16] = 0;
    sndbuf[17] = 0;
    putn(sndbuf, 18, stdout);
    mcnt = 0;
}

void
setMnData(UCHAR *buf)
{
    if((md->mainl) != buf[1]) {
        disableIRQ();
        md->mainl = buf[1];
        md->mnflg |= 0x11;
        enableIRQ();
    }
    if ((md->mainr) != buf[2]) {
        disableIRQ();
        md->mainr = buf[2];
        md->mnflg |= 0x22;
        enableIRQ();
    }
    if ((md->auxl[0]) != buf[3]) {
        disableIRQ();
        md->auxl[0] = buf[3];
        md->alflg |= 0x11;
        enableIRQ();
    }
    if ((md->auxr[0]) != buf[4]) {
        disableIRQ();
        md->auxr[0] = buf[4];
        md->arflg |= 0x11;
        enableIRQ();
    }
    if ((md->auxl[1]) != buf[5]) {
        disableIRQ();
        md->auxl[1] = buf[5];
        md->alflg |= 0x22;
        enableIRQ();
    }
    if ((md->auxr[1]) != buf[6]) {
        disableIRQ();
        md->auxr[1] = buf[6];
        md->arflg |= 0x22;
        enableIRQ();
    }
    if ((md->auxl[2]) != buf[7]) {
        disableIRQ();
        md->auxl[2] = buf[7];
        md->alflg |= 0x44;
        enableIRQ();
    }
    if ((md->auxr[2]) != buf[8]) {
        disableIRQ();
        md->auxr[2] = buf[8];
        md->arflg |= 0x44;
        enableIRQ();
    }
    if ((md->auxl[3]) != buf[9]) {
        disableIRQ();
        md->auxl[3] = buf[9];
        md->alflg |= 0x88;
        enableIRQ();
    }
    if ((md->auxr[3]) != buf[10]) {
        disableIRQ();
        md->auxr[3] = buf[10];
        md->arflg |= 0x88;
        enableIRQ();
    }
    if ((md->phonel) != buf[11]) {
        disableIRQ();
        md->phonel = buf[11];
        md->mnflg |= 0x44;
        enableIRQ();
    }
    if ((md->phoner) != buf[12]) {
        disableIRQ();
        md->phoner = buf[12];
        md->mnflg |= 0x88;
        enableIRQ();
    }

    disableIRQ();
    if ((md->mnmut & 0x01) != (buf[13] & 0x01)) {
        md->mnflg |= 0x11;
    }
    if ((md->mnmut & 0x02) != (buf[13] & 0x02)) {
        md->mnflg |= 0x22;
    }
    md->mnmut = buf[13];
    enableIRQ();
    
}

/* end of file */
