/************************************************************************
 ************************************************************************
 ****                                                                ****
 ****    VXe\`                                            ****
 ****                                                                ****
 ****----------------------------------------------------------------****
 ****                                                                ****
 ************************************************************************
 ************************************************************************/
/************************************************************************
 *    VXe                                                      *
 ************************************************************************/
#define	VERSION		(0x0002)

#define BEEP_FREQ	(0x0010)
#define BEEP_LEN	(0x0011)
#define BEEP_ON		(0x0012)
#define CONTRAST	(0x0020)
#define	SCI_BPS		(0x0040)
#define SCI_STOP	(0x0041)
#define SCI_PRTY	(0x0042)
#define SCI_DLEN	(0x0043)
#define DEFPGM		(0x0050)
#define STAMODE		(0x0060)

/* VXep[^ۑAhX */
#define FAREA_TOP	EROM_SEC7		/* Systemf[^AhX */
#define RAREA_TOP	(0x000d0000)		/* RAM AhX */
#define	SPARAM_SIZE	(0x00010000)		/* 64KByte */
/************************************************************************
 *    Memory Map                                                        *
 ************************************************************************/
/* tbV */
#define	IROM_TOP        (0x00000000)		/* ROM擪AhX */
#define IROM_SIZE       (0x00020000)            /* ROMTCY(128KByte) */

/* OtbV */
#define EROM_TOP        (0x00020000)            /* OROM擪AhX */
#define EROM_SIZE       (0x00080000)            /* OROMTCY(512KByte) */
#define EROM_SEC0	(0x00020000) 		/* Sector0 Top */
#define EROM_SEC1	(0x00030000) 		/* Sector1 Top */
#define EROM_SEC2	(0x00040000) 		/* Sector2 Top */
#define EROM_SEC3	(0x00050000) 		/* Sector3 Top */
#define EROM_SEC4	(0x00060000) 		/* Sector4 Top */
#define EROM_SEC5	(0x00070000) 		/* Sector5 Top */
#define EROM_SEC6	(0x00080000) 		/* Sector6 Top */
#define EROM_SEC7	(0x00090000) 		/* Sector7 Top */
#define PAREA_TOP       EROM_SEC4               /* PGMf[^擪AhX */
#define PAREA_SIZE      (0x00020000)            /* PGMf[^TCY */

#define ERAM_TOP        (0x000a0000)            /* ORAM擪AhX */
#define ERAM_SIZE       (0x00040000)            /* ORAMTCY(256KByte) */

#define FLASH_TOP       (0x00020000)
#define FLASH_SEC1	(0x00020000)
#define FLASH_SEC2	(0x00030000)
#define FLASH_SEC3	(0x00040000)
#define FLASH_SEC4	(0x00050000)
#define FLASH_SEC5	(0x00060000)
#define FLASH_SEC6	(0x00070000)
#define FLASH_SEC7	(0x00080000)
#define FLASH_SEC8	(0x00090000)

#define T002MSEC	(0x0002)
#define T004MSEC	(0x0004)
#define	T008MSEC	(0x0008)
#define	T016MSEC	(0x0010)
#define	T032MSEC	(0x0020)
#define	T064MSEC	(0x0040)
#define	T128MSEC	(0x0080)
#define	T256MSEC	(0x0100)
#define	T512MSEC	(0x0200)
#define	T1SEC		(0x0400)

#define T0001MSEC	(0x0001)
#define T0002MSEC	(0x0002)
#define T0004MSEC	(0x0004)
#define T0008MSEC	(0x0008)
#define T0016MSEC	(0x0010)
#define T0032MSEC	(0x0020)
#define T0064MSEC	(0x0040)
#define T0128MSEC	(0x0080)
#define T0256MSEC	(0x0100)
#define T0512MSEC	(0x0200)
#define T1024MSEC	(0x0400)

#define	MON_CH		(1)
#define	COM_CH		(3)

/************************************************************************
 *    LCD `                                                      *
 ************************************************************************/
#define	CLEAR		(0x0101)
#define CUR_HOME	(0x0102)
#define	LCD_ON		(0x0103)
#define	LCD_OFF		(0x0104)
#define	CUR_ON		(0x0105)
#define	CUR_OFF		(0x0106)
#define	BRINK_ON	(0x0107)
#define	BRINK_OFF	(0x0108)
#define	CUR_LEFT	(0x0109)
#define	CUR_RIGHT	(0x010a)
#define	DISP_LEFT	(0x010b)
#define	DISP_RIGHT	(0x010c)

#define SELSW		(0x00ff)
#define	TACTSW		(0xff00)
#define	DOWN_STAT	(0x0001)
#define	UP_STAT		(0x0002)
#define	PUSH_STAT	(0x0003)

#define	MAINSW		(0x0001)
#define SELSW0		(0x0002)
#define SELSW1		(0x0004)
#define SELSW2		(0x0008)
#define SELSW3		(0x0010)
#define TACTSW0		(0x0020)
#define TACTSW1		(0x0040)
#define TACTSW2		(0x0080)
#define TACTSW3		(0x0100)
#define TACTSW4		(0x0200)
#define TACTSW5		(0x0400)
#define TACTSW6		(0x0800)
#define TACTSW7		(0x1000)

#define	CMAINSW		(0x8001)

/************************************************************************
 *    ݒf[^                                                        *
 ************************************************************************/
/* ftHgݒl */
#define	DEFVOL		(0x60)
/* CRCUEp l */
#define LOW		(0x00)	/* X9241 ݒf[^ */
#define	HIGH		(0x7f)	/* X9241 ݒf[^ */
#define LEFT		(0x00)	/* X9241 ݒf[^ */
#define RIGHT		(0x7f)	/* X9241 ݒf[^ */
#define CENTER		(0x40)	/* X9241 ݒf[^ */

#define LCHSEL          (0x00)	/* LM1972 `lZNg */
#define RCHSEL          (0x01)	/* LM1972 `lZNg */
#define LCH		(0x01)
#define RCH		(0x02)
#define BOTHCH		(0x03)
#define OFF		(0x00)
#define ON		(0x01)
#define DISPON		(0x10)

#define EQLOW		(0x01)
#define EQMID		(0x02)
#define EQHIGH		(0x04)
#define PANPOD		(0x08)

#define	FLAGON(x)	(x |= 0x01)
#define FLAGOFF(x)	(x &= 0xfe)
#define CHKFLAG(x)	(x & 0x01)
#define CKAX1F(x)	(x & 0x01)
#define CKAX2F(x)	(x & 0x02)
#define CKAX3F(x)	(x & 0x04)
#define CKAX4F(x)	(x & 0x08)

#define AFLAGON(x)	(x |= 0x11)
#define AFLAGOFF(x)	(x &= 0xee)
#define DFLAGON(x)	(x = x | 0x10)
#define DFLAGOFF(x)	(x = x & 0xef)
#define CHKDFLAG(x)	(x & 0x10)

/* ~LVOf[^vTCY */
typedef struct {		/* 15Byte */
    UCHAR	vol;		/* 1 : CH {[ */
    UCHAR	snd[4];		/* 4 : AUX Send l */
    UCHAR	sndsw;	        /* 1 : AUX Send Switch: 4bit mask */
    UCHAR	pan;		/* 1 : panpod */
    UCHAR	hi;		/* 1 : high equarizer */
    UCHAR	mid;		/* 1 : middle equarizer */
    UCHAR	low;		/* 1 : low equarizer */
    UCHAR	mut;		/* 1 : mute */
    UCHAR	panway;		/* 1 : 0: 0-3f=R-L / 1: 0-3f=L-R */
    UCHAR	vflg;		/* 1 : Volume change flag */
    UCHAR	tflg;		/* 1 : Tone/Pan change flag */
    UCHAR	sflg;	        /* 1 : Aux Send change flag */
} ChAttr, *ChAttrPtr;

typedef struct {		/* 17Byte */
    UCHAR	auxl[4];	/* 4 : AUX Return L */
    UCHAR	auxr[4];	/* 4 : AUX Return R */
    UCHAR	mainl;		/* 1 : Main L */
    UCHAR	mainr;		/* 1 : Main R */
    UCHAR	phonel;		/* 1 : Headphone L */
    UCHAR	phoner;		/* 1 : Headphone R */
    UCHAR	mnmut;          /* 1 : Mute flag */
    UCHAR	syncpm;         /* 1 : Headphone/Main tO */
    UCHAR	alflg;		/* 1 : AUX Return L change counter */
    UCHAR	arflg;		/* 1 : AUX Return R change counter */
    UCHAR	mnflg;		/* 1 : Main Volume change counter */
} MnAttr, *MnAttrPtr;

/* f[^ۑpf[^` */
typedef struct {			/* v28Byte */
    UCHAR	chname[16];		/* 16Byte */
    UCHAR	vol;			/* 1Byte */
    UCHAR	snd[4];			/* 4Byte */
    UCHAR	sndsw;			/* 1Byte */
    UCHAR	pan, hi, mid, low;	/* 4Byte */
    UCHAR	mut, panway;		/* 2Byte */
} pgChAtr, *pgChAtrPtr;

typedef struct {			/* v78Byte */
    UCHAR	auxl[4], auxr[4];	/* 8Byte */
    UCHAR	mainl, mainr;		/* 2Byte */
    UCHAR	phonel, phoner;		/* 2Byte */
    UCHAR	mnmut;			/* 1Byte */
    UCHAR	syncpm;			/* 1Byte */
    UCHAR	axname[4][16];		/* 64Byte */
} pgMnAtr, *pgMnAtrPtr;

typedef struct {
    int		hdr;			/*   2Byte    f[^wb_[ */
    int		year;			/*   2Byte    ۑN */
    UCHAR	month, day;		/*   2Byte    ۑ */
    UCHAR	hour, minuite, second;	/*   3Byte    ۑb */
    UCHAR	reserve;		/*   1Byte    Byte align */
    UCHAR	name[18];		/*  18Byte    vO */
    pgChAtr	pch[16];		/* 448Byte ch f[^ */
    pgMnAtr	pmd;			/*  78Byte    Main f[^ */
} PgAttr, *PgAttrPtr;

/************************************************************************
 *    VXef[^                                                    *
 ************************************************************************/
typedef struct {
    UINT	magicA[2];		/* 4byte */
    /**** VAf[^    0/1: H8  2/3: 16552 ****/
    UCHAR	stoplen[4];		/* 4byte */
    UCHAR	parity[4];		/* 4byte */
    UCHAR	datalen[4];		/* 4byte */
    UINT	bps[4];			/* 8byte */

    /**** Beep֌W ****/
    UINT	BeepFreq;		/* 2byte */
    UINT	BeepLen;		/* 2byte */
    UINT	BeepEn;			/* 2byte */
    UINT	defch;			/* 2byte */
    UCHAR	contrast;		/* 1byte */
    UCHAR	stamode;		/* 1byte */
    UINT	magicB[2];		/* 2byte */
} SysAttr, *SysAttrptr;

/************************************************************************
 *    LCD \[h                                                    *
 ************************************************************************/
/**** \[h ****/
/* C\[h */
#define DISP_MAIN       (0x00)
#define DMN_MAIN        (0x00)
#define DMN_CHVOL       (0x01)
#define DMN_HIGH        (0x02)
#define DMN_MID         (0x03)
#define DMN_LOW         (0x04)
#define DMN_AUX1S	(0x05)
#define DMN_AUX2S       (0x06)
#define DMN_AUX3S       (0x07)
#define DMN_AUX4S       (0x08)
#define DMN_PAN         (0x09)
#define DMN_MAXLEVEL    (0x0a)

/* ch ʕ\[h */
#define DISP_CH         (0x01)
#define DCH_EQAUX       (0x00)
#define DCH_PANVOL      (0x01)
#define DCH_NUM         (0x02)
#define DCH_NUMAXS      (0x03)
#define DCH_MAXLEVEL    (0x04)

/**** \bN ****/
#define MNLOCK          (0x01)
#define PCMNLOCK	(0x02)
#define CHLOCK          (0x10)
#define PCCHLOCK	(0x20)

/**** W[[h` ****/
#define	MJ_MAIN		(0x00)		/* g[^\[h */
#define	MJ_CH		(0x01)		/* chʕ\[h */
#define MJ_MENU		(0x02)		/* j[[h */

/**** }Ci[[h` ****/
/* \[h */  
#define	MNR_VOL		(0x00)		/* {[ZbeBO */
#define MNR_AUXR	(0x01)		/* AUX Return */

#define MNR_MSET	(0x00)		/* ch@CZbeBO */
#define MNR_PSET	(0x01)		/* ch  pZbeBO */
#define	MNR_AUXEQ	(0x02)		/* AUX send/CRCUZbeBO */
#define MNR_VALUE	(0x03)		/* \[h */

/* j[[h */
#define MNR_TOP		(0x00)		/* gbvxj[ */
#define MNR_MIDI	(0x01)		/* MIDI j[ */
#define MNR_SETUP	(0x02)		/* setup j[ */
#define MNR_COM		(0x03)		/* ʐM|[gj[ */
#define MNR_CONS	(0x04)		/* R\[j[ */
#define MNR_DATA	(0x05)		/* ZbeBOf[^j[ */
#define	MNR_UTIL	(0x06)		/* [eBeBj[ */

/************************************************************************
 *    LED\֘A                                                       *
 ************************************************************************/
#define	LED_LEFT	(0x01)
#define	LED_CENTER	(0x10)
#define	LED_LAMP	(0x80)

#define	BRINK		(0x01)
#define	DOT_BRINK	(0x10)
#define BRINK_NONE	(0x00)

/************************************************************************
 *    LM1972 ݒpVtgWX^AhX                               *
 ************************************************************************/
#define	NUMSELECT	(*((UCHAR *)0xe500e))
#define	VSETTRIG	(*((UCHAR *)0xe500f))
#define	CH4VOLSET	(*((UCHAR *)0xe5010))
#define	CH4LRSET	(*((UCHAR *)0xe5011))
#define	CH3VOLSET	(*((UCHAR *)0xe5012))
#define	CH3LRSET	(*((UCHAR *)0xe5013))
#define	CH2VOLSET	(*((UCHAR *)0xe5014))
#define	CH2LRSET	(*((UCHAR *)0xe5015))
#define	CH1VOLSET	(*((UCHAR *)0xe5016))
#define	CH1LRSET	(*((UCHAR *)0xe5017))

#define XICOR_ADR	(*((UCHAR *)0xe5018))
#define XICOR_REG	(*((UCHAR *)0xe5019))
#define XICOR_VOL	(*((UCHAR *)0xe501a))
#define XICOR_RST	(*((UCHAR *)0xe500c))

#define	XICOR_B0	(*((UCHAR *)0xe500d))
#define	XICOR_B1	(*((UCHAR *)0xe501a))
#define	XICOR_B2	(*((UCHAR *)0xe501b))

#define	MAINVOLSET	(*((UCHAR *)0xe5010))
#define MAINLRSET	(*((UCHAR *)0xe5011))
#define	PHONVOLSET	(*((UCHAR *)0xe5012))
#define	PHONLRSET	(*((UCHAR *)0xe5013))

#define	MAINVOLSET2	(*((UCHAR *)0xe5014))
#define MAINLRSET2	(*((UCHAR *)0xe5015))
#define	PHONVOLSET2	(*((UCHAR *)0xe5016))
#define	PHONLRSET2	(*((UCHAR *)0xe5017))

/************************************************************************
 *    
 ************************************************************************/
/*
 * ch Volume : 
 */
#define CH01XADR         (0x06)
#define CH03XADR         (0x03)
#define CH05XADR         (0x0e)
#define CH07XADR         (0x07)
#define CH09XADR         (0x0b)
#define CH11XADR         (0x0d)
#define CH13XADR         (0x09)
#define CH15XADR         (0x0c)

/* end of file */
