/************************************************************************
 *   prototype.h				                                        *
 ************************************************************************/

/****	main.c		****/
int	main();
int	mainInitMsg1();
int mainEventLoop();
int mainDisplay(int, int);
int	halt();


/****	mon.c	****/
int monComExec(char *);
int monHelp3();
int monHelp2();
void monInit();
void monPromtOut();
void monCRout();
void monLineOut( char *);
int monCommLine();
int monHelp1();

/****	sys.c	****/
void	sysInit();
void	sysInitPort();
void	sysInitWdt();
void	sysInitSCI();
void	sysInitITU();
void	sysInitIrq();
int		sysGetc(int *, int );
int		sysPutc(int,int);
int		sysGetcX();
int		sysPutcX(int);
void	sysEnableExIRQ(UCHAR);
void	sysDisableExIRQ(UCHAR);
void	sysSetExIRQEdge(UCHAR);
void	sysSetExIRQLevel(UCHAR);
void	sysReadIRQStat(UCHAR);

/*	 cbox	*/
void	sysInitAD();
void	sysStartAD();
void	sysStopAD();

void	cboxCHchange(int);

/****	display.c	****/
int dspInitDisplay();


/****	lcd.c	****/
void lcdLineOut(char *);
void lcdInit();
void lcdInitVCgRam();
void lcdInitHCgRam();
void lcdWriteCGRAM(int, UCHAR, UCHAR);
void lcdWait(int);
void lcdOut(char *);
void lcdnOut(char *, int );
void lcdRawOut(char *, int );
void lcdBackspace();
void lcdMoveto(int, int);
void lcdCommand(int);


/*****	swin.c		****/
void swInitSwin();
void swTgswin();
BOOL swTglcheck(int);
UINT swMdswin();
UINT swKswin();
UINT swCHswin();
UINT swKeycheck(UINT, UINT);
int swReinput(int, int, ULONG);


/****	led.c	****/
void ledInitLed();
void ledStartLed();
void ledOff(int , int );
void ledOn(int , int );
void ledIntled();
void ledSegOff();
void ledSegOut(long, int );

/****	usb.c ****/
extern	void	*getUsbFunc(int);
extern	UCHAR	*usbBmemcpy(void *, const void *, int);	
extern	void	usbSetDescArray(void);

void mlInit();
void mlAckSend();
void mlIntStat(UCHAR *, int);
void mlClrIntSOF();
void mlClrSetupRdy();
void mlClrIntEP0Rxpr();
void mlClrIntEP0Txpr();
void mlClrIntEP1Rxpr();
void mlClrIntEP1Txpr();
void mlClrIntEP2Rxpr();
void mlClrIntEP2Txpr();
void mlSetEP0Txprdy();
void mlSetEP2Txprdy();
void mlDisableIntEP0Rxpr();
void mlDisableIntEP0Txpr();
void mlCfgEp();

void mlSendEP0(UCHAR *, int);
void mlDisableIntEP0Rxpr();
void mlDisableIntEP0Txpr();
void mlSetDevAdd(UCHAR);

void mlClrSetupRdy();
void mlClrEP1Rxprdy();
int mlEP0RxPcktRdy();
int mlEP0TxPcktRdy();
int mlEP1RxPcktRdy();
int mlEP2TxPcktRdy();

int mlEP0RxCnt();
int mlEP1RxCnt();



UCHAR	*usbBmemcpy(void *dest, const void *src, int count);

/**** end ****/