#!/usr/bin/python
########################################################################
#                                                                      #
#    ldcnv.py : bios.map  syslib.x 𐶐XNvg            #
#                                                                      #
########################################################################

import os, sys, string

class MkLdScript:
    def helpmsg(self):
        progname = sys.argv[0]
        print "%s [input_file] [output_file]."%progname

    def openfile(self):
        global ifname, ofname
        if len(sys.argv) == 1:
            ifname = 'bios.map'
            ofname = 'syslib.x'
        elif len(sys.argv) == 2:
            if sys.argv[1] == '--help':
                self.helpmsg()
                return False
            if sys.argv[1] == '-h':
                self.helpmsg()
                return False
            ifname = sys.argv[1]
            ofname = 'syslib.x'
        elif len(sys.argv) == 3:
            ifname = sys.argv[1]
            ofname = sys.argv[2]
        return True

    def checkResFunc(self, word):
        if word == 'ramcrt0.o':
            return False
        if string.find(word, '_mulsi3.o') >= 0:
            return False
        if string.find(word, '_divsi3.o') >= 0:
            return False
        if string.find(word, 'strtol.o') >= 0:
            return False
        if string.find(word, 'impure.o') >= 0:
            return False
        return True

    def checkResWord(self, word):
        if word == 'start':
            return False
        if word == 'start_app':
            return False
        if word == '_end=.':
            return False
        if word == '_stack=.':
            return False
        if word == '_impure_ptr':
            return False
        if word == 'main':
            return False
        if word == '__mulsi3':
            return False
        if word == '__umodsi3':
            return False
        if word == '__divsi3':
            return False
        if word == '__modsi3':
            return False
        if word == '__udivsi3':
            return False
        if word == 'strtol':
            return False
        if word == '_strtol_r':
            return False
        if word == '_ctype_':
            return False
        if word == '_etext=.':
            return False
        if word == '___ctors=.':
            return False
        if word == '___ctors_end=.':
            return False
        if word == '___dtors=.':
            return False
        if word == '___dtors_end=.':
            return False
        if word == '___data=.':
            return False
        if word == '_edata=.':
            return False
        if word == '_bss_start=.':
            return False
        return True

    def Convert(self):
        inf  = open(ifname, 'r')
        outf = open(ofname, 'w')
        pre  = True
        for line in inf.readlines():
            if line[0] == '\n':
                continue
            n = string.find(line, '\n')
            if n >= 0:
                line = line[:n]
            if line[0] in string.whitespace:
                line = ' '+string.strip(string.join(string.split(line)))+'\n'
            else:
                line = string.strip(string.join(string.split(line)))+'\n'
            larray = string.split(line, ' ')
            if larray[0] == '.text' or larray[0] == '.bkram':
                pre = False
            if pre == True:
                continue
            if line[0] == ' ':
                if larray[1] == '.text' or larray[1] == '.data' or larray[1] == '.bss' or larray[1] == '.bkram':
                    if len(larray) == 5:
                        larray[4] = larray[4][:len(larray[4])-1]
                        #outf.write('/* '+larray[4]+' */\n')
                        if self.checkResFunc(larray[4]):
                            print '\n/* '+larray[4]+' */\n'
                            outf.write('\n/* '+larray[4]+' */\n')
                else:
                    if line[0] == ' ' and len(larray) == 3:
                        larray[1] = larray[1][:len(larray[1])]
                        larray[2] = larray[2][:len(larray[2])-1]
                        if self.checkResWord(larray[2]):
                            print '"_'+larray[2]+'"=' + larray[1] + ';'
                            outf.write('"_'+larray[2]+'"='+larray[1]+';\n')
            #outf.write(line)
        inf.close()
        outf.close()

app = MkLdScript()
if app.openfile():
    app.Convert()

# end of file #