/************************************************************************
 ************************************************************************
 ****                                                                ****
 ****    miscenv.c : X̊ݒ֐                              ****
 ****                                                                ****
 ************************************************************************
 ************************************************************************/
#include	"generic.h"
#include	"config.h"
#include	"include/sys.h"
#include	"mdate.h"

extern	UCHAR	getStartMode();
extern	void	setStartMode(UCHAR);
extern	UCHAR	getBeepOn();
extern	UINT	getBeepFreq();

int	miscInit();
int	execDispInfo();
int	execSysEnv();
void	dispSysEnv(int);
int	editSysEnv(int, int);
void	dispBeepOnOff();
int	editBeepOnOff(int);
void	dispBeepFreq();
int	editBeepFreq(int);
void	dispBeepMsec();
int	editBeepMsec(int);
void	dispContrast();
int	editContrast(int, UCHAR);
void	dispStartMode();
int	editStartMode();
void	saveSysEnv();

extern UINT	beep;			/* Beep JEgl(̒) */
extern UINT	bcnt;			/* Beep pJE^ */

int
execDispInfo()
{
    UCHAR	stat;

    Beep(0);
    lcdCommand(CUR_OFF);
    lcdCommand(BRINK_OFF);
    lcdCommand(CLEAR);
    lcdMoveto(0, 0);	lcdOut(VER_SYS);
    lcdMoveto(1, 4);	lcdOut(VER_HARD);
    lcdMoveto(2, 4);	lcdOut(VER_BIOS);
    lcdMoveto(3, 3);	lcdOut(COMPILE_DATE);
    while(1) {
        checkTimeFlag(T0002MSEC);
        checkTimeFlag(T0004MSEC);
        if (checkTimeFlag(T0008MSEC)) {
            if (bcnt < beep) { BeepOn();    bcnt++; }
            else             { BeepOff(); }
        }
        if (checkTimeFlag(T0016MSEC)) {
            stat  = (UCHAR)getSwStat(TACTSW, DOWN_STAT);
            if (stat & 0x10)    break;
        }
        checkTimeFlag(T0032MSEC);
        checkTimeFlag(T0064MSEC);
        checkTimeFlag(T0128MSEC);
        checkTimeFlag(T0256MSEC);
        checkTimeFlag(T0512MSEC);
        checkTimeFlag(T1024MSEC);
    }
    Beep();
    return (-2);
}

/*
 * Beep Setting
 * [    ]Hz [    ]msec
 * Display Contrast
 * |--------o--------|
 */
int
execSysEnv()
{
    int		mode, rtn = 0, d;
    UCHAR	bkcntrst, bkbeep, stat, bkstamd, contrast;
    UINT	bkfreq, bkmsec, bpcnt, bpmax;
    
    /*lcdCommand(CUR_ON);*/
    contrast = getContrast();
    bkcntrst = contrast / 4;
    bkbeep = getBeepOn();
    bkmsec = getBeepLen();
    bkstamd  = getStartMode();
    lcdCommand(BRINK_ON);
    lcdCommand(CLEAR);
    lcdCommand(CUR_HOME);
    lcdMoveto(0, 0);	lcdOut("Beep : ");
    lcdMoveto(1, 0);	lcdOut("[    ]Hz [    ]msec");
    lcdMoveto(2, 0);	lcdOut("Contrast [    ]");
    lcdMoveto(3, 0);    lcdOut("StartMode[    ]");
    dispBeepMsec();
    lcdFlush();
    for(mode=4; mode >= 0; mode--)  dispSysEnv(mode);
    mode = 0;
    bpcnt = 0;
    bpmax = getBeepLen() >> 3;
    while(1) {
	if (checkTimeFlag(T0004MSEC)) {
            pccom(4);
	}
	if (checkTimeFlag(T0008MSEC)) {
            bpmax = getBeepLen() >> 3;
            if (bpcnt < bpmax) { BeepOn();    bpcnt++; }
            else               { BeepOff(); }
	}
	/**** 16msec 62.5Hz ****/
	if (checkTimeFlag(T0016MSEC)) {
            stat  = (UCHAR)getSwStat(TACTSW, DOWN_STAT);
            if (stat & 0x01) {			/* Right (No) */
                if (mode < 4)    mode++;
                dispSysEnv(mode);
            } else if (stat & 0x04) {		/* Left (Yes) */
                if (mode > 0)    mode--;
                dispSysEnv(mode);
            } else if (stat & 0x02) {		/* Up */
                if (editSysEnv(mode, 1))  bpcnt = 0;
            } else if (stat & 0x20) {		/* Down */
                if (editSysEnv(mode, -1)) bpcnt = 0;
            } else if (stat & 0x10) {		/* Enter */
                saveSysEnv();
                rtn = -2;
                Beep();
                break;
            } else if (stat & 0x40) {		/* Edit/Exit */
                if (bkbeep)    BeepEnable();
                else           BeepDisable();
                setBeepFreq(bkfreq);
                setSysParam(BEEP_FREQ, bkfreq);
                setBeepLength(bkmsec);
                setSysParam(BEEP_LEN, bkmsec);
                setContrast(bkcntrst * 4);
                setSysParam(CONTRAST, bkcntrst*4);
                setStartMode(bkstamd);
                rtn = -1;
                Beep();
                break;
            }
        }
    }
    return(rtn);
}

void
dispSysEnv(int m)
{
    switch(m) {
    case 0:    dispBeepOnOff();		break;
    case 1:    dispBeepFreq();		break;
    case 2:    dispBeepMsec();		break;
    case 3:    dispContrast();		break;
    case 4:    dispStartMode();		break;
    }
}

int
editSysEnv(int m, int s)
{
    int		rtn;
    UCHAR	dcntrst;
    
    dcntrst = getContrast() / 4;
    switch(m) {
    case 0:	rtn = editBeepOnOff(s);		break;
    case 1:	rtn = editBeepFreq(s);		break;
    case 2:	rtn = editBeepMsec(s);		break;
    case 3:	rtn = editContrast(s, dcntrst);	break;
    case 4:	rtn = editStartMode();          break;
    }
    return(rtn);
}

void
dispBeepOnOff()
{
    lcdMoveto(0, 7);
    if (getBeepOn()) { lcdOut("ON "); lcdCommand(CUR_LEFT); }
    else  	     { lcdOut("OFF"); }
}

int
editBeepOnOff(int s)
{
    int		rtn=0;
    
    if (s == 1) {
        BeepEnable();
        /*beepon = 1;*/
        rtn = 1;
    } else if (s == -1) {
	BeepDisable();
        /*beepon = 0;*/
        rtn = 0;
    }
    dispBeepOnOff();
    return(rtn);
}

void
dispBeepFreq()
{
    char	fstr[5];
    UINT	beepf;

    beepf = getBeepFreq();
    itonstr(fstr, beepf, 4);
    fstr[4] = '\0';
    lcdMoveto(1, 1);
    lcdOut(fstr);
}

int
editBeepFreq(int s)
{
    UINT	bfreq;

    bfreq = getBeepFreq();
    if (s == 1) {
        if (bfreq < 20000)    bfreq = bfreq + 100;
        setBeepFreq(bfreq);
    } else if (s == -1) {
        if (bfreq > 100)      bfreq = bfreq - 100;
        setBeepFreq(bfreq);
    }
    dispBeepFreq();
    return(1);
}

void
dispBeepMsec()
{
    char	mstr[5];
    UINT	len;

    len = getBeepLen();
    itonstr(mstr, len, 4);
    mstr[4] = '\0';
    lcdMoveto(1, 10);
    lcdOut(mstr);
}

int
editBeepMsec(int s)
{
    UINT	dms;

    dms = getBeepLen();
    if (s == 1) {
        dms = dms << 1;
        setBeepLength(dms);
    } else if (s == -1) {
        dms = dms >> 1;
        setBeepLength(dms);
    }
    dispBeepMsec();
    return(1);
}

void
dispContrast()
{
    UCHAR	c, str[6];

    c = getContrast() / 4;
    if (c >= 30)  c = 30;
    lcdMoveto(2, 12);
    itonstr(str, c, 2);
    lcdOut(str);
    lcdMoveto(2, 13);
}

int
editContrast(int s, UCHAR src)
{
    UCHAR	contrast;
    
    if (s == 1) {
        if (src < 30)    src = src++;
    } else if (s == -1) {
        if (src > 0)	 src = src--;
    }
    contrast = src * 4;
    setContrast(contrast);
    dispContrast();
    return(0);
}

void
dispStartMode()
{
    UCHAR	m;
    
    m = getStartMode();
    lcdMoveto(3, 10);
    if (m) {
        lcdOut("CONT");
    } else {
        lcdOut(" PGM");
    }
    lcdMoveto(3, 13);
}
    
int
editStartMode()
{
    UCHAR	m;

    m = getStartMode();
    if (m)	setStartMode(0);
    else	setStartMode(1);
    dispStartMode();
    return(0);
}
              
void
saveSysEnv()
{
    UCHAR	contrast;
    UINT	bfreq, beepon, dms;
    
    lcdCommand(CLEAR);
    lcdCommand(BRINK_OFF);
    lcdCommand(CUR_OFF);
    lcdMoveto(1, 0);
    lcdOut("Save system setting.");

    /* bfreq, beepon, dms, contrast */
    bfreq = getBeepFreq();
    setSysParam(BEEP_FREQ, bfreq,    0);
    dms = getBeepLen();
    setSysParam(BEEP_LEN,  dms,      0);
    beepon = getBeepOn();
    setSysParam(BEEP_ON,   beepon,   0);
    contrast = getContrast();
    setSysParam(CONTRAST,  contrast, 0);
    waitSecLoop(1);
    sysParamRec();
}

void
execFadeEnv()
{
    ;
}
