/************************************************************************
 ************************************************************************
 ****                                                                ****
 ****    pgm.c : Setting program
 ****                                                                ****
 ************************************************************************
 ************************************************************************/
#include	"generic.h"
#include	"config.h"
#include	"include/h8_3048.h"
#include	"include/sys.h"

#define PGM_SIZE        (sizeof(ChAttr)*16 + sizeof(MnAttr))
#define PGM_ALL         (sizeof(pgmch) + sizeof(md))

extern ChAttr   *getAllChDataPtr();
extern MnAttr   *getMnDataPtr();
extern void	setSysParam(int, int, int);
extern UINT	etSysDefCh();


int	pgmInit(int, PgAttr *);
int	pgmIncDec(int);
int	savePgmData(int, ChAttr *, MnAttr *, char *);
int	loadPgmData(ChAttr *, MnAttr *);
int	falshProgram(UCHAR *, UCHAR *, ULONG);
int	execSavePgm();
void	setAuxName(int, char *);
void	getAuxName(int, char *);
void	setChName(int, char *);
void	getChName(int, char *);
void	waitSecLoop(int);
void	waitSecLoop2(int);
void	pgmnoWarning();
int	getpgmStrLoop();
void	nstripPstr(char *, int);
void	stripPstr(char *);
int	pstrlen(char *);
int	delStr(char *, int);
void	refleshNameSpace(char *, int);
int	getPushStat(UCHAR);

int	loadPgm(int, ChAttr *, MnAttr *);
int	getCurPgmName(char *);
int	getCurPgmDate(unsigned char *);
unsigned int	umemcpy(char *, char *, unsigned int);

extern	int	curpgm;
extern	UCHAR	*defpan, *pw;

PgAttr	*pgmd;
PgAttr  *pgmf;
UCHAR	pgstr[18];
UCHAR	defpgm;

int
getCurPgmNo()
{
    return(curpgm);
}

int
queryDefPgm(int pgm)
{
    if (pgm == getSysDefCh())    return 1;
    return 0;
}
    
int
pgmInit(int chno, PgAttr pgmdsrc[100])
{
    int		i, n;

    pgmd = pgmdsrc;
    if (chno > 99)	curpgm = 0;
    else if (chno >= 0) curpgm = chno;

    pgmf = (PgAttr *)PAREA_TOP;
    /* Sf[^Rs[ */
    umemcpy((char *)pgmd, (char *)pgmf, (unsigned int)sizeof(pgmd));
    /* ftHgݒ̏ */
    strcpy(pgmd[0].name, "Default");
    pgmd[0].hdr = VERSION;
    pgmd[0].year = 0;
    pgmd[0].month = 0;
    pgmd[0].day = 0;
    pgmd[0].hour = 0;
    pgmd[0].minuite = 0;
    pgmd[0].second = 0;
    for(i=0; i<16; i++) {
        pgmd[0].pch[0].vol = DEFVOL;
        for(n=0; n<16; n++) {
            pgmd[0].pch[0].snd[n] = DEFVOL;
        }
        pgmd[0].pch[0].sndsw = 0x0f;
        pgmd[0].pch[0].pan = defpan[i];
        pgmd[0].pch[0].hi = CENTER;
        pgmd[0].pch[0].mid = CENTER;
        pgmd[0].pch[0].low = CENTER;
        pgmd[0].pch[0].mut = OFF;
        pgmd[0].pch[0].panway = pw[i];
    }
    for(i=0; i<4; i++) {
        pgmd[0].pmd.auxl[i] = DEFVOL;
        pgmd[0].pmd.auxr[i] = DEFVOL;
    }
    pgmd[0].pmd.mainl = DEFVOL;
    pgmd[0].pmd.mainr = DEFVOL;
    pgmd[0].pmd.phonel = DEFVOL;
    pgmd[0].pmd.phoner = DEFVOL;
    pgmd[0].pmd.mnmut = 0x00;
    pgmd[0].pmd.syncpm = ON;

    if (curpgm == 0) {
        ledoutCenterRaw(0x0c, 0x0c);
        setLedMode(BRINK_NONE, LED_CENTER);
        defpgm = 0;
    } else {
        ledoutCenter(curpgm);
        if (chno > 0)
            setLedMode(DOT_BRINK, LED_CENTER);	/* LED _OFF */
        defpgm = 1;
    }
}

int
setPgmDate(int y, UCHAR m, UCHAR d, UCHAR hur, UCHAR min, UCHAR sec)
{
    pgmd[curpgm].year = y;
    pgmd[curpgm].month = m;
    pgmd[curpgm].day = d;
    pgmd[curpgm].hour = hur;
    pgmd[curpgm].minuite = min;
    pgmd[curpgm].second = sec;
}

int
resetPgmDate()
{
    pgmd[curpgm].year = 0;
    pgmd[curpgm].month = 0;
    pgmd[curpgm].day = 0;
    pgmd[curpgm].hour = 0;
    pgmd[curpgm].minuite = 0;
    pgmd[curpgm].second = 0;
}
    
int
pgmIncDec(int way)
{
    if (way > 0) {
	curpgm++;
        if (curpgm > 99)    curpgm = 99;
    } else if (way < 0) {
        curpgm--;
        if (curpgm < 0)     curpgm = 0;
    }
    if (curpgm == 0) {
	ledoutCenterRaw(0x0c, 0x0c);
        setLedMode(BRINK_NONE, LED_CENTER);
        defpgm = 0;
    } else {
        ledoutCenter(curpgm);
        setLedMode(DOT_BRINK, LED_CENTER);	/* LED _OFF */
        if (curpgm == getSysDefCh())    defpgm = 1;
        else                            defpgm = 0;
    }
    return(curpgm);
}

int
pgmSetNo(int no)
{
    if (no <= 0)    return 0;
    if (no > 99)   return 0;
    if (no == 0) {
	ledoutCenterRaw(0x0c, 0x0c);
        setLedMode(BRINK_NONE, LED_CENTER);
    } else {
        curpgm = no;
        ledoutCenter(curpgm);
        setLedMode(DOT_BRINK, LED_CENTER);	/* LED _OFF */
    }
    if (curpgm == getSysDefCh())    defpgm = 1;
    else                            defpgm = 0;
    return 1;
}

int
savePgmData(int pn, ChAttr *cd, MnAttr *md, char *string)
{
    int		i, len;
    UCHAR	*ptr;

    if (pn <= 0)	return(FALSE);
    if (pn >= 100)	return(FALSE);
    if (cd == NULL)	return(FALSE);
    if (md == NULL)	return(FALSE);

    disableIRQ();
    lcdOut(".");    outToLcd();
    /**** wb_[̐ݒ ****/
    pgmd[pn].hdr = VERSION;

    /**** program̂̐ݒ ****/
    len = strlen(string);
    if (len > 17)    len = 17;
    for(i=0; i<len; i++) {
        pgmd[pn].name[i] = string[i];
    }
    pgmd[pn].name[i] = '\0';

    /**** ch f[^̃Rs[ ****/
    for(i=0; i<16; i++) {
        pgmd[pn].pch[i].vol    = cd[i].vol;
        pgmd[pn].pch[i].snd[0] = cd[i].snd[0];
        pgmd[pn].pch[i].snd[1] = cd[i].snd[1];
        pgmd[pn].pch[i].snd[2] = cd[i].snd[2];
        pgmd[pn].pch[i].snd[3] = cd[i].snd[3];
        pgmd[pn].pch[i].sndsw  = cd[i].sndsw;
        pgmd[pn].pch[i].pan    = cd[i].pan;
        pgmd[pn].pch[i].hi     = cd[i].hi;
        pgmd[pn].pch[i].mid    = cd[i].mid;
        pgmd[pn].pch[i].low    = cd[i].low;
        pgmd[pn].pch[i].mut    = cd[i].mut;
        pgmd[pn].pch[i].panway = cd[i].panway;
    }

    /**** Mainf[^̃Rs[ ****/
    for(i=0; i<4; i++) {
        pgmd[pn].pmd.auxl[i] = md->auxl[i];
        pgmd[pn].pmd.auxr[i] = md->auxr[i];
    }
    pgmd[pn].pmd.mainl  = md->mainl;
    pgmd[pn].pmd.mainr  = md->mainr;
    pgmd[pn].pmd.phonel = md->phonel;
    pgmd[pn].pmd.phoner = md->phoner;
    pgmd[pn].pmd.mnmut  = md->mnmut;
    pgmd[pn].pmd.syncpm = md->syncpm;
    lcdOut(".");    outToLcd();

    /**** tbVւ̏ ****/
    eraseSector(4);
    lcdOut(".");    outToLcd();
    pgmf = (PgAttr *)PAREA_TOP;		/* 0x00060000 */
    flashProgram((UCHAR *)pgmf, (UCHAR *)pgmd, (ULONG)(sizeof(pgmd)));
    lcdOut(".");
    enableIRQ();
    return(1);
}
            
int
dispPgmData(int mask)
{
    UCHAR	str[4];

    if (mask & 0x01) {
        lcdCommand(CLEAR);
        itostr(curpgm, str, 10);
        lcdMoveto(0, 0);
        lcdOut("PGM No.");
        lcdOut(str);
    }
    
    if (mask & 0x02) {
        lcdMoveto(1, 0);
        if ((pgmd[curpgm].name[0]!=0xff) && (pgmd[curpgm].name[0]!=0x00)) {
            lcdOut(pgmd[curpgm].name);
        }
    }
    
    if (mask & 0x04) {
        lcdMoveto(2, 0);
        lcdOut("Date: ");
        if (pgmd[curpgm].year != 0xffff) {
            itonstr(str, (long)pgmd[curpgm].year, 4);
            lcdOut(str);    lcdOut("/");
            itonstr(str, (long)pgmd[curpgm].month, 2);
            lcdOut(str);    lcdOut("/");
            itonstr(str, (long)pgmd[curpgm].day, 2);
            lcdOut(str);
        } else {
            lcdOut("None.");
        }
    }
}

int
loadPgmData(ChAttr *cd, MnAttr *md)
{
    UCHAR	*ptr, str[4], c, buf[16];
    int		i, n, len;

    if (curpgm <= 0)	return(FALSE);
    if (curpgm > 99)	return(FALSE);
    if (cd == NULL)	return(FALSE);
    if (md == NULL)	return(FALSE);
    dispPgmData(0x01);
    if (pgmd[curpgm].hdr != VERSION) {	/* łȂ */
        lcdMoveto(3, 3);
        lcdOut("not programed.");
        waitSecLoop(2);
	return(FALSE);
    }
    dispPgmData(0x06);
    /**** ch f[^̃Rs[ ****/
    for(i=0; i<16; i++) {
        cd[i].vol    = pgmd[curpgm].pch[i].vol;
        cd[i].snd[0] = pgmd[curpgm].pch[i].snd[0];
        cd[i].snd[1] = pgmd[curpgm].pch[i].snd[1];
        cd[i].snd[2] = pgmd[curpgm].pch[i].snd[2];
        cd[i].snd[3] = pgmd[curpgm].pch[i].snd[3];
        cd[i].sndsw  = pgmd[curpgm].pch[i].sndsw;
        cd[i].pan    = pgmd[curpgm].pch[i].pan;
        cd[i].hi     = pgmd[curpgm].pch[i].hi;
        cd[i].mid    = pgmd[curpgm].pch[i].mid;
        cd[i].low    = pgmd[curpgm].pch[i].low;
        cd[i].mut    = pgmd[curpgm].pch[i].mut;
        cd[i].panway = pgmd[curpgm].pch[i].panway;
    }
    for(i=0; i<16; i++) {
        AFLAGON(cd[i].vflg);
        cd[i].tflg = 0xff;
        cd[i].sflg = 0xff;
    }
    
    /**** Mainf[^̃Rs[ ****/
    for(i=0; i<4; i++) {
        md->auxl[i] = pgmd[curpgm].pmd.auxl[i];
        md->auxr[i] = pgmd[curpgm].pmd.auxr[i];
    }
    md->mainl  = pgmd[curpgm].pmd.mainl;
    md->mainr  = pgmd[curpgm].pmd.mainr;
    md->phonel = pgmd[curpgm].pmd.phonel;
    md->phoner = pgmd[curpgm].pmd.phoner;
    md->mnmut  = pgmd[curpgm].pmd.mnmut;
    md->syncpm = pgmd[curpgm].pmd.syncpm;
    md->mnflg = 0x33;

    lcdMoveto(3, 13);
    lcdOut("loaded.");
    waitSecLoop(2);
    setLedMode(BRINK_NONE, LED_CENTER);
    mnsetoff();
    chsetoff();
    return(TRUE);
}

int
flashProgram(UCHAR *dest, UCHAR *src, ULONG size)
{
    int		c;
    ULONG	i;
    UCHAR	*cur, *adr, *tgt, d, str[10];
    
    adr = (UCHAR *)0x20000;	*adr = 0x0f;	/* [hZbg */
    /**** f[^ ****/
    cur = src;
    tgt = dest;
    for(i=0; i<size; i++) {
	write_flash((UCHAR *)0x2902b, 0xaa);
	write_flash((UCHAR *)0x220d4, 0x55);
	write_flash((UCHAR *)0x2902b, 0xa0);
	write_flash(tgt, *cur);
	for(c=0; c<10; c++) { ; }		/* \usec҂ */
	while(1) {
	    d = read_byte(tgt);
	    if (d == *cur)	break;
	    if (d & 0x20)	continue;
	    if (d == *cur)	break;
	}
	cur++;
	tgt++;
	adr = (UCHAR *)0x20000;	*adr = 0x0f;	/* [hZbg */
	for(c=0; c<10; c++) { ; }		/* \usec҂ */
    }
}

int
savePgmFromPC(int def, char *pname)
{
    int		ch;
    UCHAR	sndsw;
    
    ch = getCurCH();
    lcdCommand(CLEAR);
    lcdMoveto(3, 0);
    lcdOut("Saving PGM Data");
    ledoutCenterRaw(0x0f, 0x0f);
    ledoutLeftRaw(0x0f, 0x0f);
    waitSecLoop2(1);
    lcdFlush();
    if (def == 1) {
        defpgm = 1;
        setSysParam(DEFPGM, curpgm, curpgm);
        sysParamRec();
    }
    savePgmData(curpgm, getAllChDataPtr(), getMnDataPtr(), pname);
    ledoutCenter(curpgm);
    ledoutLeft(ch+1);
    lcdMoveto(3, 0);
    lcdOut("Saved OK.          ");
    setLedMode(BRINK_NONE, LED_CENTER);
    return(-2);
}

int
execSavePgm()
{
    int		rtn=-1, cnt, ch;
    UCHAR	sndsw;
    
    lcdCommand(CLEAR);
    lcdMoveto(0,0);
    cnt = 0;
    if (curpgm == 0) {
        pgmnoWarning();
        waitSecLoop(2);
        return(-2);
    }
    if (rtn = getpgmStrLoop()) {
        ch = getCurCH();
        lcdMoveto(3, 0);
        lcdOut("Saving PGM Data");
        ledoutCenterRaw(0x0f, 0x0f);
        ledoutLeftRaw(0x0f, 0x0f);
        waitSecLoop(2);
        lcdFlush();
        if (defpgm == 1) {
            setSysParam(DEFPGM, curpgm, curpgm);
            sysParamRec();
        }
        savePgmData(curpgm, getAllChDataPtr(), getMnDataPtr(), pgstr);
        ledoutCenter(curpgm);
        ledoutLeft(ch+1);
        lcdMoveto(3, 0);
        lcdOut("Saved OK.          ");
        rtn = -2;			/* top level ֖߂ */
    } else {
        lcdMoveto(3, 0);
        lcdOut("Cancel PGM Save...");
        rtn = -1;
    }
    setLedMode(BRINK_NONE, LED_CENTER);
    waitSecLoop(2);
    return(rtn);
}

void
setAuxName(int ano, char *name)
{
    int		i;
    
    for(i=0; i<16; i++) {
        pgmd[curpgm].pmd.axname[ano][i] = name[i];
    }
}

void
getAuxName(int ano, char *name)
{
    int		i;
    
    for(i=0; i<16; i++) {
        name[i] = pgmd[curpgm].pmd.axname[ano][i];
    }
}

void
setChName(int chno, char *name)
{
    int		i;
    
    for(i=0; i<16; i++) {
        pgmd[curpgm].pch[chno].chname[i] = name[i];
    }
}

void
getChName(int chno, char *name)
{
    int		i;
    
    for(i=0; i<16; i++) {
        name[i] = pgmd[curpgm].pch[chno].chname[i];
    }
}

void
waitSecLoop(int num)
{
    int		cnt, ch;
    UCHAR	sndsw;
    
    ch = getCurCH();
    sndsw = getCurSendSW();
    cnt = 0;
    while(1) {
	if (checkTimeFlag(T0004MSEC)) {
            pccom(4);
	}
	if (checkTimeFlag(T0016MSEC)) {
        }
        if (checkTimeFlag(T1024MSEC)) {
            cnt++;
            if (cnt > num)	break;
        }
    }
}

void
waitSecLoop2(int num)
{
    int		cnt, ch;
    UCHAR	sndsw;
    
    cnt = 0;
    checkTimeFlag(T1024MSEC);
    while(1) {
	if (checkTimeFlag(T0008MSEC)) {
	}
	if (checkTimeFlag(T0016MSEC)) {
        }
        if (checkTimeFlag(T1024MSEC)) {
            cnt++;
            if (cnt > num)	break;
        }
    }
}

void
pgmnoWarning()
{
    lcdCommand(CUR_OFF);
    lcdCommand(BRINK_OFF);
    lcdMoveto(1, 1);
    lcdOut("Please Select");
    lcdMoveto(2, 10);
    lcdOut("PGM No");
}

int	pcntA, pcntB;

int
getpgmStrLoop()
{
    int		ch, i, stat, rtn = 0, c, d;
    UINT	bpcnt, bpmax;
    UCHAR	sndsw, src[4];
    
    checkTimeFlag(T0002MSEC);
    checkTimeFlag(T0004MSEC);
    checkTimeFlag(T0008MSEC);
    checkTimeFlag(T0016MSEC);
    checkTimeFlag(T0032MSEC);
    lcdMoveto(0, 0);
    strcpy(pgstr, "PGM No: ");
    itostr(curpgm, src, 10);
    strcat(pgstr, src);
    lcdOut(pgstr);
    lcdMoveto(1, 0);    lcdOut("Name:\n [");
    lcdMoveto(2, 18);   lcdOut("]");
    lcdMoveto(0, 13);
    if (curpgm == getSysDefCh()) {
        lcdOut("Default");
        defpgm = 1;
    } else {
        lcdOut("Normal ");
        defpgm = 0;
    }
    lcdMoveto(2, 2);
    for(i=0; i<=16; i++)	pgstr[i] = '\0';
    if ((pgmd[curpgm].name[0] != 0xff) && (pgmd[curpgm].name[0] != 0x00)) {
        lcdOut(pgmd[curpgm].name);
        strcpy(pgstr, pgmd[curpgm].name);
        i = strlen(pgstr);
        c = 'A';
    } else {
        i = 0;
        c = 'A';
    }
    lcdCommand(BRINK_OFF);
    ch = getCurCH();
    sndsw = getCurSendSW();
    pcntA = 0;
    pcntB = 0;
    bpcnt = 0;
    while(1) {
	if (checkTimeFlag(T0004MSEC)) {
            pccom(4);
	}
	if (checkTimeFlag(T0008MSEC)) {
            bpmax = getBeepLen() >> 3;
            if (bpcnt < bpmax) { BeepOn();    bpcnt++; }
            else               { BeepOff(); }
	}
	/**** 16msec 62.5Hz ****/
	if (checkTimeFlag(T0016MSEC)) {
            d = getPushStat(c);
            if (d) {
                c = c + d;
                if (c < 0x20)		c = 0x20;
                else if (c > 0xfd)	c = 0xfd;
                pgstr[i] = (UCHAR)c;
                lcdRawOut(&(pgstr[i]), 1);
                lcdCommand(CUR_LEFT);
            }
            stat = (UCHAR)getSwStat(TACTSW, DOWN_STAT);
            if (stat & 0x01) {				/* Right */
                i++;
                if (i > 15)	i = 15;
                else		lcdCommand(CUR_RIGHT);
                if (pgstr[i] == '\0')    pgstr[i] = ' ';
                /* c = pgstr[i]; */
            } else if (stat & 0x04) {			/* Left */
                i--;
                if (i < 0)	i = 0;
                else		lcdCommand(CUR_LEFT);
                c = pgstr[i];
                nstripPstr(pgstr, i);
            } else if (stat & 0x08) {			/* MainDisp/Delete */
                if (delStr(pgstr, i)) {
                    i--;
                    if (i < 0)	i = 0;
                    else	lcdCommand(CUR_LEFT);
                }
                refleshNameSpace(pgstr, i);
                c = pgstr[i];
            } else if (stat & 0x80) {
                lcdMoveto(0, 13);
                if (defpgm == 0) {
                    defpgm = 1;
                    lcdOut("Default");
                } else {
                    defpgm = 0;
                    lcdOut("Normal ");
                }
                d = strlen(pgstr);
                lcdMoveto(2, d+2);
            } else if (stat & 0x02) {			/* Up */
                c--;
                if (c < 0x20)	c = 0x20;
                pgstr[i] = (UCHAR)c;
                lcdRawOut(&(pgstr[i]), 1);
                lcdCommand(CUR_LEFT);
            } else if (stat & 0x20) {			/* Down */
                c++;
                if (c > 0xfd)	c = 0xfd;
                pgstr[i] = (UCHAR)c;
                lcdRawOut(&(pgstr[i]), 1);
                lcdCommand(CUR_LEFT);
            } else if (stat & 0x10) {			/* Enter */
                d = strlen(pgstr);
                refleshNameSpace(pgstr, d);
                lcdCommand(BRINK_ON);
                if (checkYesNo()) {
                    lcdCommand(BRINK_OFF);
                    lcdCommand(CUR_OFF);
                    rtn = 1;
                    break;
                }
                lcdCommand(BRINK_OFF);
                lcdMoveto(2, 2+d);
                i = d;
            } else if (stat & 0x40) {			/* Edit/Exit */
                rtn = 0;
                break;
            }
        }
    }
    return(rtn);
}

void
nstripPstr(char *str, int n)
{
    int		len, i;

    len = strlen(str);
    for(i=len; i>n; i--) {
        if (str[i] != ' ')    break;
        str[i] = '\0';
    }
}
        
void
stripPstr(char *str)
{
    int		n;
    
    for(n=15; n>=0; n--) {
        if (str[n] == ' ')	str[n] = '\0';
        else			break;
    }
}

int
pstrlen(char *str)
{
    int		l, n;

    for(n=15; n>=0; n--) {
        if (str[n] != ' ') break;
    }
    return(n);
}
        
int
delStr(char *str, int i)
{
    int		n, len, rtn;

    len = strlen(str);
    if (i == len) {
        str[i-1] = '\0';
        rtn = 1;
    } else {
        for(n=i; n<len; n++) {
            str[n] = str[n+1];
        }
        rtn = 0;
    }
    str[16] = '\0';
    return(rtn);
}

void
refleshNameSpace(char *str, int place)
{
    int		len, i;

    len = strlen(str);
    lcdMoveto(2, 2);
    lcdOut(str);
    for(i=0; i<16-len; i++)	lcdOut(" ");
    lcdMoveto(2, 2+place);
}

int
getPushStat(UCHAR c)
{
    UCHAR	stat;
    int		rtn;

    rtn = 0;
    stat = (UCHAR)getSwStat(TACTSW, PUSH_STAT);
    if (stat & 0x20) {					/* Down */
        if (pcntA < 30) {
            pcntA++;
        } else {
            pcntB++;
            if (pcntB == 10) {
                pcntB = 0;
                rtn = 1;
            }
        }
    } else if (stat & 0x02) {				/* Up */
        if (pcntA < 30) {
            pcntA++;
        } else {
            pcntB++;
            if (pcntB == 10) {
                pcntB = 0;
                rtn = -1;
            }
        }
    } else {
        pcntA = 0;
        pcntB = 0;
        rtn = 0;
    }
    return(rtn);
}

/************************************************************************
 *    program change interface                                          *
 ************************************************************************/
int
loadPgm(int pnum, ChAttr *cd, MnAttr *md)
{
    UCHAR	*ptr, str[4];
    int		i, n, len, prev;

    prev = curpgm;
    pgmSetNo(pnum);
    n = TRUE;
    if (curpgm <= 0)	n = FALSE;
    if (curpgm > 99)	n = FALSE;
    if (cd == NULL)	n = FALSE;
    if (md == NULL)	n = FALSE;
    if (pgmd[curpgm].hdr != VERSION) {	/* łȂ */
	n = FALSE;
    }
    if (n == FALSE) {
        pgmSetNo(prev);
        return(FALSE);
    }
    /**** ch f[^̃Rs[ ****/
    for(i=0; i<16; i++) {
        cd[i].vol    = pgmd[curpgm].pch[i].vol;
        cd[i].snd[0] = pgmd[curpgm].pch[i].snd[0];
        cd[i].snd[1] = pgmd[curpgm].pch[i].snd[1];
        cd[i].snd[2] = pgmd[curpgm].pch[i].snd[2];
        cd[i].snd[3] = pgmd[curpgm].pch[i].snd[3];
        cd[i].sndsw  = pgmd[curpgm].pch[i].sndsw;
        cd[i].pan    = pgmd[curpgm].pch[i].pan;
        cd[i].hi     = pgmd[curpgm].pch[i].hi;
        cd[i].mid    = pgmd[curpgm].pch[i].mid;
        cd[i].low    = pgmd[curpgm].pch[i].low;
        cd[i].mut    = pgmd[curpgm].pch[i].mut;
        cd[i].panway = pgmd[curpgm].pch[i].panway;
    }
    for(i=0; i<16; i++) {
        AFLAGON(cd[i].vflg);
        cd[i].tflg = 0xff;
        cd[i].sflg = 0xff;
    }
    
    /**** Mainf[^̃Rs[ ****/
    for(i=0; i<4; i++) {
        md->auxl[i] = pgmd[curpgm].pmd.auxl[i];
        md->auxr[i] = pgmd[curpgm].pmd.auxr[i];
    }
    md->mainl  = pgmd[curpgm].pmd.mainl;
    md->mainr  = pgmd[curpgm].pmd.mainr;
    md->phonel = pgmd[curpgm].pmd.phonel;
    md->phoner = pgmd[curpgm].pmd.phoner;
    md->mnmut  = pgmd[curpgm].pmd.mnmut;
    md->syncpm = pgmd[curpgm].pmd.syncpm;
    md->mnflg = 0x33;
    setLedMode(BRINK_NONE, LED_CENTER);
    return(TRUE);
}

int
getCurPgmName(char *str)
{
    int		i;
    
    for(i=0; i<16; i++) {
        str[i] = pgmd[curpgm].name[i];
    }
    if (str[0] == '\0')	return(TRUE);
    else		return(FALSE);
}

int
getCurPgmDate(unsigned char *str)
{
    str[0] = pgmd[curpgm].year - 2000;
    str[1] = pgmd[curpgm].month;
    str[2] = pgmd[curpgm].day;
    str[3] = pgmd[curpgm].hour;
    str[4] = pgmd[curpgm].minuite;
    str[5] = pgmd[curpgm].second;
    return(TRUE);
}

int
ltostr(unsigned long d, char *str, int base)
{
    unsigned long	sub, cnt;
    int			i, max;
    char		src[8];

    max = 0;
    while(d) {
	sub = d / (unsigned long)base;
	cnt = d - sub * (unsigned long)base;
	src[max++] = (char)cnt + '0';
	d = sub;
    }

    if (max == 0) {
	str[0] = '0';
	i = 1;
    } else {
	for(i=0; i<max; i++) {
	    str[max-i-1] = src[i];
	}
    }

    str[i] = '\0';
    return(i);
}

unsigned int
umemcpy(char *dest, char *src, unsigned int num)
{
    unsigned int	i;
    for(i=0; i<num; i++) {
	*dest = *src;
	dest++;
	src++;
    }
    return(i);
}

/* end of file */
