/************************************************************************
 ************************************************************************
 ****                                                                ****
 ****    main.c : HaM-II vO                              ****
 ****                                                                ****
 ************************************************************************
 ************************************************************************/
#include	"include/generic.h"
#include	"include/config.h"
#include	"include/h8_3048.h"
#include	"include/sys.h"

#define	RIGHTON		(0x0001)
#define LEFTON		(0x0002)
#define UPON		(0x0004)
#define DOWNON		(0x0008)

#define MAINDISP        (0x1000)
#define CHDISP		(0x1010)

#define	ENTER		(0x2000)
#define EDIT		(0x2010)
#define PGMINFO		(0x2020)

/*----------------------------------------------------------------
 *    ϐE֐錾
 *----------------------------------------------------------------*/
extern void	volinit(ChAttr *, MnAttr *);
extern int	startmsg();
extern void	sysinit();
extern void     ledLampOut2(UCHAR);
extern ChAttr   *getAllChDataPtr();
extern MnAttr   *getMnDataPtr();
extern void	settmpchp(MnAttr *, ChAttr *);
extern void	setBeepFreq(int);
extern int	initSci0(int, UCHAR, UCHAR, UCHAR);
extern int	initSci1(int, UCHAR, UCHAR, UCHAR);

int	main();
int	initLoop();
int	mainLoop();
int	setState(int, int *);

/**** Backup RAM ****/
extern int	curch;		/* ݑΏۂƂȂĂ`l */
extern SysAttr	sParam;

/**** ϐ ****/
extern	ChAttr  *cd;		/* o͗p`lf[^̃|C^ */
extern	MnAttr  *md;		/* o͗pCf[^̃|C^ */
extern	ChAttr  dcd;		/* \p`lf[^ */
extern	MnAttr  dmd;		/* \p`lf[^ */

extern UCHAR	panel;		/* plbN */
extern UINT	beep;		/* Beep JEgl(̒) */
extern UINT	bcnt;		/* Beep pJE^ */

extern	int	pretop, second;
extern	int	top, chsec, mnsec;	/* ԕϐ(Top/SecondLevel) */
extern	int	swcntA, swcntB;		/* XCb`ςȂJE^ */
extern	UCHAR	runinit;		/* tO */
extern	int	keepram;
extern	PgAttr	pgmds[100];

/************************************************************************
 *    main ()                                                 *
 ************************************************************************/
int
main(void)
{
    int		i;
    UCHAR	*ptr;
    
    runinit = 1;
    
    /**** VXe ****/
    sysinit();			/* VXe */
    sysParamInit();		/* ۑp[^ */
    fifoInit();			/* VAʐMpobt@ */
    initSci0(sParam.bps[0],     sParam.datalen[0],
             sParam.stoplen[0], sParam.parity[0]);
    initSci1(sParam.bps[1],     sParam.datalen[1],
             sParam.stoplen[1], sParam.parity[1]);
    enableIRQ();
    addaInit();			/* AD/DARo[^/AiOXCb` */
    lcdInit();			/* LCD */
    ledInit();			/* LEDv֘A */
    swinit();			/* SW͏ */
    initmsg();			/* bZ[W\֘Ȁ */
    volinit(NULL, NULL);	/* ʐݒ֘A */
    /*miscInit();*/

    /**** ԕϐ̏ ****/
    swcntA= 0;
    swcntB= 0;
    panel = 0;
    top = MAINDISP;
    pretop = top;
    chsec = 0;
    mnsec = 0;
    second= 0;
    setBeepFreq(sParam.BeepFreq);
    setBeepLength(sParam.BeepLen);
    if (sParam.BeepEn)	BeepEnable();
    else		BeepDisable();
    setContrast(sParam.contrast);

    /**** {[Erv̏ ****/
    if (keepram == 0) {
        curch = 0;
    }
    cd = getAllChDataPtr();	/* chf[^|C^̎擾 */
    md = getMnDataPtr();	/* main f[^|C^̎擾 */
    setmndest(md);		/* adda.c ւmain f[^|C^̐ݒ */
    for(i=0; i<16; i++) {	/* adda.c ւchf[^|C^̐ݒ */
        setchdest(&cd[i], i);
    }
    settmpchp(&dmd, &dcd);	/* \pf[^ADf[^o^ */
    setaddmp();			/* adda.c ̃f[^|C^̃ATC */
    setaddcp(curch);		/* adda.c chf[^|C^̃ATC */
    adchupdateSet(OFF);		/* ADϊʂɂchf[^XV OFF */
    admnupdateSet(ON);		/* Main ̓tgplON */
    if (sParam.stamode == 0) {
        pgmInit(sParam.defch, pgmds);	/* ftHgf[^̐ݒ */
        loadPgmData(cd, md);	/* ۑ`lf[^̕A */
        mnseton(top, panel);
        panel = chseton(top, panel);
    } else {
        if (keepram) {
            pgmInit(-1, pgmds);	/* Backup RAM ɂp */
        } else {
            pgmInit(0, pgmds);	/* Default */
        }
    }
    initLoop();			/* p[v */
    /*setprompt(1);*/		/* VFvvgݒ */
    /*shellInit();*/		/* VF */
    pcomInit();			/* PC I/F  */
    runinit = 0;
    mainLoop();			/* C[v */
}

/************************************************************************
 *    initLoop() : ԂKvȃCjVCY                       *
 ************************************************************************/
int
initLoop()
{
    int		imode = 0, initing = 1;
    char	chno, tno, type, loop;

    lcdCommand(CLEAR);
    chno = 0;
    tno  = 0;
    type = 0x01;
    loop = 0;
    while(initing) {
	/**** 2msec 500Hz ****/
	if (checkTimeFlag(T0002MSEC)) {
            if (sParam.defch == 0)    adinput(curch);
            outToLcd();
        }
	/**** 8msec 125Hz ****/
	if (checkTimeFlag(T0008MSEC)) {
	    driveLed();				/* LED _ */
	}

	/**** 16msec 62.5Hz ****/
        if (checkTimeFlag(T0016MSEC)) {
            /**** tone/pan o͐ݒ ****/
            if (chno < 16) {
                vbufInput(chno, type);		/* obt@ݒ */
                tno++;				/* tone ݒpJE^ */
                type = type << 1;		/* hi/mid/low/pan I */
                if (tno == 4) {			/* tone 1ŃNA */
                    tno = 0;
                    type = 0x01;
                    chno++;			/* ̃`lֈړ */
                }
                /* ݂̏2s */
                if ((chno == 16) && (loop == 0)) {
                    chno = 0;
                    tno = 0;
                    type = 0x01;
                    loop++;
                }
            }
            /**** /tone o͐ݒ ****/
            volSet();
        }
        
	/**** 64msec 16Hz ****/
	if (checkTimeFlag(T0064MSEC)) {
            /**** LCD \ ****/
	    imode = startmsg();
	}
        if ((chno == 16) && (imode == 0)) initing = 0;
    }

    /* o̓~[g off */
    PBDDR = 0xff;
    PBDR  = 0x20;

    /* ԃtÕNA */
    checkTimeFlag(T0002MSEC);    checkTimeFlag(T0004MSEC);
    checkTimeFlag(T0008MSEC);    checkTimeFlag(T0016MSEC);
    checkTimeFlag(T0032MSEC);    checkTimeFlag(T0064MSEC);
    checkTimeFlag(T0128MSEC);    checkTimeFlag(T0256MSEC);
    checkTimeFlag(T0512MSEC);    checkTimeFlag(T1024MSEC);

    admnupdateSet(ON);			/* CRg[̂ON */
    /* puts("Initialize OK...\n\r", stdout); */

    return(1);
}

/************************************************************************
 *    ̃XL
 *		iAvP[V̖[vĂяopj
 ************************************************************************/
int
mainLoop()
{
    int		dup, pstat;		/* \XVtO */

    dup = 0;
    bcnt = 0;
    
    /**** fBXvC\ ****/
    disp_start(md, &dmd, cd, &dcd, curch);
    while(1) {
        /* pccom(); */
	/**** 2msec 500Hz ****/
	if (checkTimeFlag(T0002MSEC)) {
        }
	/**** 4msec 250Hz ****/
	if (checkTimeFlag(T0004MSEC)) {
	    /* shell(); */			/* shell: fobOp */
            pstat = pccom(4);			/* zXgʐM */
            if (pstat == -2) {
                exitMenu();
                resetDisp();
                top = pretop;
            }
	}

	/**** 8msec 125Hz ****/
	if (checkTimeFlag(T0008MSEC)) {
            if (bcnt < beep) { BeepOn();    bcnt++; }
            else             { BeepOff(); }
	}

	/**** 16msec 62.5Hz ****/
	if (checkTimeFlag(T0016MSEC)) {
            if (swcheck(cd)) {
                setaddcp(curch);
                dup = 1;
            }
            ledoutLeft(curch+1);
            /* ledLampOut(&(cd[curch].sndsw)); */
            ledLampOut2(cd[curch].sndsw);
            checkPush(curch);
            setState(curch, &dup);
	}

	/**** 32msec 31.2Hz ****/
	if (checkTimeFlag(T0032MSEC)) {
            dup = display(curch, dup);
	}

	/**** 64msec 15.6Hz ****/
	if (checkTimeFlag(T0064MSEC)){
            /* dup = display(curch, dup); */
	}		

	/**** 128msec 7.81Hz ****/
	if (checkTimeFlag(T0128MSEC)) {
        }
	/**** 256msec 3.90Hz ****/
	if (checkTimeFlag(T0256MSEC)) { ; }
	/**** 512msec 1.95Hz ****/
	if (checkTimeFlag(T0512MSEC)) { ; }
	/**** 1.0sec 1.0Hz ****/
	if (checkTimeFlag(T1024MSEC)) { ; }
    }
}

/************************************************************************
 *    ԑJڊ֐                                                      *
 ************************************************************************/
/*   {^z
 *   Main Display   * o o o
 *   Ch Display     * o o o
 *
 *   Left Button    o * o o
 *   Edit Button    o * o o
 *
 *   Up Button      o o * o
 *   Down Button    o o * o	(Lock)
 *
 *   Right Button   o o o *
 *   Enter Button   o o o *     (Load)
 */
int
setState(int ch, int *dup)
{
    int		mstat;
    UCHAR	stat, pstat;

    stat  = (UCHAR)getSwStat(TACTSW, DOWN_STAT);
    if (stat == 0)	return(0);
    Beep(0);
    if (stat & 0x01) {					/* Right */
        if ((top == MAINDISP) || (top == CHDISP)) {
            pgmIncDec(-1);
        } else if (top == EDIT) {
            second = incMenu(second, 1);
        } else if (top == PGMINFO) {
            pgmIncDec(-1);
            dispPgmData(0x07);
        }
    }
    if (stat & 0x02) {					/* Up */
        if ((top == MAINDISP) || (top == CHDISP)) {
            dispPgmData(0x07);
            pretop = top;
            top = PGMINFO;
        } else if (top == EDIT) {
            second = decMenu(second, 2);
        } else if (top == PGMINFO) {
            top = pretop;
            resetDisp();
        }
    }
    if (stat & 0x04) {					/* Left */
        if ((top == MAINDISP) || (top == CHDISP)) {
            pgmIncDec(1);
        } else if (top == EDIT) {
            second = decMenu(second, 1);
        } else if (top == PGMINFO) {
            pgmIncDec(1);
            dispPgmData(0x07);
        }
    }
    if (stat & 0x08) {					/* Main Display */
        if (top == MAINDISP) {
            mnsec++;
            if (mnsec == 10) mnsec = 0;
        } else if (top == EDIT) {
            lcdCommand(BRINK_OFF);
            lcdCommand(CUR_OFF);
        } else if (top == PGMINFO) {
            resetDisp();
        }
        top = MAINDISP;
        *dup = 1;
    }
    if (stat & 0x10) {					/* Enter/Load */
        if ((top == MAINDISP) || (top == CHDISP)) {
            loadPgmData(cd, md);
            resetDisp();
        } else if (top == EDIT) {
            mstat = execMenu(second);
            second = 0;
            if (mstat == -2) {
                exitMenu();
                top = pretop;
                /* mnseton(top, panel); */
            } else if (mstat < 0) {
                exitMenu();
                startMenu();
                /* mnseton(top, panel); */
            }
        } else if (top == PGMINFO) {
            loadPgmData(cd, md);
            dispPgmData(0x07);
        }
    }
    if (stat & 0x20) {					/* Down */
        if ((top == MAINDISP) || (top == CHDISP)) {
            panel = panelLockOnOff(panel);
        } else if (top == EDIT) {
            second = incMenu(second, 2);
        }
    }
    if (stat & 0x40) {					/* Edit/Exit */
        if ((top == MAINDISP) || (top == CHDISP)) {
            pretop = top;
            top = EDIT;
            startMenu();
            /* mnsetoff(top, panel); */
        } else if (top == EDIT) {
            exitMenu();
            top = pretop;
            second = 0;
            /* mnseton(top, panel); */
        } else if (top == PGMINFO) {
            top = EDIT;
            startMenu();
            /* mnsetoff(top, panel); */
        }
    }
    if (stat & 0x80) {					/* CH Display */
        if (top == CHDISP) {
            chsec++;
            if (chsec == 4) chsec = 0;
        } else if (top == EDIT) {
            lcdCommand(BRINK_OFF);
            lcdCommand(CUR_OFF);
        } else if (top == PGMINFO) {
            resetDisp();
        }
        top = CHDISP;
        *dup = 1;
    }

    return((int)stat);
}

/* end of file */
