#include	"include/generic.h"
#include	"include/h8_3048.h"

extern	int	rxbuf0Outputs(char *, int);
extern	int	rxbuf1Outputs(char *, int);
extern	int	tx0run, tx1run;

int	sci0outn(char *, int);
int	sci1outn(char *, int);
int	initSci0(int, UCHAR, UCHAR, UCHAR);
int	initSci1(int, UCHAR, UCHAR, UCHAR);
UCHAR	calcBrrValue(int);
int	sciSetBaud(int, int);
UINT	sciGetBaud(int);
int	sciSetMode(int, int, int, int);
int	getSciDataLen(int);
int	getSciParity(int);
int	getSciStopBit(int);

extern	int	rxo1p, rxi1p;
extern  char	rxbuf[2][0x40];

int
rxbuf1OutputB(char *s)
{
    if (rxo1p == rxi1p) {
        s[0] = '\0';
        return(0);
    }
    s[0] = rxbuf[1][rxo1p];
    rxo1p = ++rxo1p & 0x3f;
    return(1);
}


int
sci1insB(char *s, int num)
{
    int		i, n;
    
    for(i=0; i<num; i++) {
        n = rxbuf1OutputB(s);
        if (n == 0)    break;
        s++;
    }
    return(i);
}

int
initSci0(int bps, UCHAR dlen, UCHAR stop, UCHAR pty)
{
    UCHAR	brrvalue, smrvalue;
    int		i;

    SCR0 = 0x00;				/* $B%7%j%"%kDd;_(B */
    SSR0 = SSR0 & 0x04;
    tx0run = 0;
    brrvalue = calcBrrValue(bps);
    smrvalue = 0;
    if (dlen == 7)    smrvalue |= 0x40;
    if (pty == 0) {				/* parity $B$J$7(B */
        smrvalue &= 0xdf;
    } else if (pty == 1) {			/* parity Even */
        smrvalue |= 0x20;
        smrvalue &= 0xef;
    } else if (pty == 2) {			/* parity Odd */
        smrvalue |= 0x20;
        smrvalue |= 0x10;
    }
    if (stop == 1)	smrvalue &= 0xf7;	/* 1 stop bit */
    else if (stop == 2) smrvalue |= 0x08;	/* 2 stop bit */

    /**** $B=i4|2=(B ****/
    SMR0 = smrvalue;
    BRR0 = brrvalue;			/* 38400bps */

    for(i=0; i<0x600; i++) {;}		/* $B%b!<%IJQ998e;~4V$r$*$/(B */

    /**** $BAw<u?.3+;O!&<u?.3d$j9~$_5v2D(B ****/
    SCR0 = TxON(INIT_SCR0) | RxON(INIT_SCR0);
    SCR0 |= 0x40;			/* Recieve Interrupt Enable */
    /* SCR0 |= 0x80; */			/* Transmit Interrupt Enable */
}

int
initSci1(int bps, UCHAR dlen, UCHAR stop, UCHAR pty)
{
    UCHAR	brrvalue, smrvalue;
    int		i;

    SCR1 = 0x00;				/* $B%7%j%"%kDd;_(B */
    SSR1 = SSR1 & 0x04;
    tx1run = 0;
    brrvalue = calcBrrValue(bps);
    smrvalue = 0;
    if (dlen == 7)    smrvalue |= 0x40;
    if (pty == 0) {				/* parity $B$J$7(B */
        smrvalue &= 0xdf;
    } else if (pty == 1) {			/* parity Even */
        smrvalue |= 0x20;
        smrvalue &= 0xef;
    } else if (pty == 2) {			/* parity Odd */
        smrvalue |= 0x20;
        smrvalue |= 0x10;
    }
    if (stop == 1)	smrvalue &= 0xf7;	/* 1 stop bit */
    else if (stop == 2) smrvalue |= 0x08;	/* 2 stop bit */

    /**** $B=i4|2=(B ****/
    SMR1 = smrvalue;			/* 0x00(1stop bit) */
    BRR1 = brrvalue;			/* 38400bps */

    for(i=0; i<0x600; i++) {;}		/* $B%b!<%IJQ998e;~4V$r$*$/(B */

    /**** $BAw<u?.3+;O!&<u?.3d$j9~$_5v2D(B ****/
    SCR1 = TxON(INIT_SCR1) | RxON(INIT_SCR1);
    SCR1 |= 0x40;			/* Recieve Interrupt Enable */
    /* SCR1 |= 0x80; */			/* Transmit Interrupt Enable */
}

/* end of file */
